/*
 *  linux/arch/arm/mach-argonplus/argonplusodyssey.c
 *
 *  Copyright (C) 2000 Deep Blue Solutions Ltd
 *  Copyright (C) 2002 Shane Nay (shane@minirl.com)
 *  Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <linux/config.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/irq.h>
#include <asm/setup.h>
#include <asm/mach-types.h>
#include <asm/mach/arch.h>
#include <asm/arch/memory.h>
#include <asm/arch/gpio.h>
#include <asm/arch/board.h>

/*!
 * @file argonplusodyssey.c
 * 
 * @brief This file contains the board specific initialization routines. 
 * 
 * @ingroup System
 */

extern void argonplus_map_io(void);
extern void argonplus_init_irq(void);
extern void argonplus_cpu_init(void) __init;
extern void argonplusodyssey_gpio_init(void) __init;
extern struct sys_timer mxc_timer;

/*!
 * REVISIT: document me
 */
static int __init argonplus_init(void)
{
	return 0;
}

arch_initcall(argonplus_init);

/*!
 * ARGONPLUS Odyssey specific fixup function. It is called by \b setup_arch() in 
 * setup.c file very early on during kernel starts. It allows the user to 
 * statically fill in the proper values for the passed-in parameters. None of 
 * the parameters is used currently.
 * 
 * @param  desc         pointer to \b struct \b machine_desc
 * @param  tags         pointer to \b struct \b tag
 * @param  cmdline      pointer to the command line
 * @param  mi           pointer to \b struct \b meminfo
 */
void __init fixup_argonplusodyssey(struct machine_desc *desc, struct tag *tags,
        char **cmdline, struct meminfo *mi) 
{
        argonplus_cpu_init();
}

/*!
 * Board specific initialization.
 */
static void __init mxc_board_init(void)
{
        argonplusodyssey_gpio_init();
}

/*
 * The following uses standard kernel macros define in arch.h in order to 
 * initialize __mach_desc_ARGONPLUSODYSSEY data structure.
 */
MACHINE_START(ARGONPLUSODYSSEY, "Freescale ARGONPLUS Odyssey")
        MAINTAINER("Freescale Semiconductor")
        /*       physical memory    physical IO        virtual IO     */
        BOOT_MEM(PHYS_OFFSET_ASM, AIPS1_BASE_ADDR, AIPS1_BASE_ADDR_VIRT)
        BOOT_PARAMS(PHYS_OFFSET_ASM + 0x100)
        FIXUP(fixup_argonplusodyssey)
        MAPIO(argonplus_map_io)
        INITIRQ(argonplus_init_irq)
        INIT_MACHINE(mxc_board_init)
        .timer		= &mxc_timer,
MACHINE_END
