/*
 *  File Name       : linux/arch/arm/mach-mp200/lcdc_intr.h
 *  Function        : LCDC Interrupt (VSYNC)
 *  Release Version : Ver 1.00
 *  Release Date    : 2005/05/16
 *
 *  Copyright (C) NEC Electronics Corporation 2005
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef ARCH_ARM_MACH_MP200_LCDC_INTR_H
#define ARCH_ARM_MACH_MP200_LCDC_INTR_H

#define LCDC_REG(ADDR,OFF)	\
	(*(unsigned int volatile *)((unsigned char *)(ADDR) + OFF))

#define LCDC_ADDR		IO_ADDRESS (MP200_LCDC_BASE)

#define LCDC_INTSTATUS		LCDC_REG (LCDC_ADDR, 0x0060)
#define LCDC_INTRAWSTATUS	LCDC_REG (LCDC_ADDR, 0x0064)
#define LCDC_INTENSET		LCDC_REG (LCDC_ADDR, 0x0068)
#define LCDC_INTENCLR		LCDC_REG (LCDC_ADDR, 0x006c)
#define LCDC_INTFFCLR		LCDC_REG (LCDC_ADDR, 0x0070)

typedef struct driver_private {
	spinlock_t lock;
	spinlock_t free_act_ent_lock;
	struct list_head list;
	struct list_head queue;
	struct list_head free_act_ent;	/* action free entry list */
	int enable;
	void (*dmaerr) (unsigned long bit);
	void (*dmastop) (unsigned long bit);
	void (*underrun) (unsigned long bit);
	void (*lcdstop) (unsigned long bit);
} driver_private_t;

typedef struct lcdc_vsync_run_action {
	struct list_head list;
	lcdc_vsync_action_t action;	/* action struct */
	unsigned long dec_cnt;	/* decrement counter */
	int enable;		/* enable/disable */
} lcdc_vsync_run_action_t;

#endif
