/*
 *  File Name       : linux/arch/arm/mach-mp200/pwc.h
 *  Function        : pwc
 *  Release Version : Ver 1.01
 *  Release Date    : 2006/07/27
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef __ARCH_ARM_MACH_MP200_PWC_H
#define __ARCH_ARM_MACH_MP200_PWC_H

#ifdef CONFIG_MP201
#define UWIRE_CHECK_COUNT	5

/* 2006.05.19 has */
#ifdef CONFIG_SONY_ICX1087
#define PWC_GIO_OUTPORT1	0x00
/*#define PWC_GIO_OUTPORT2	0x00*/
/* modified by ita. 2006.08.16. To keep LCD backlight on.*/
#define PWC_GIO_OUTPORT2	0x00
/* WARNING!!                                                    */
/* this defined value do not be set to register at the ICX1087. */
/* because following MASK_PWC_IOSEL1/2 is zero.                 */
/* if you want to modify this value for kernel,                 */
/* please modify PWC_GIO_OUTPORT1/2 and MASK_PWC_IOSEL1/2.      */
/* and if you want to set value for u-boot to kernel seamless,  */
/* please modify PWC_IOSEL1/2_INIT_VAL.                         */
#else
#define PWC_GIO_OUTPORT1	0xF0
#define PWC_GIO_OUTPORT2	0x3F
#endif

/* 2006.09.25 has */
#ifdef CONFIG_SONY_ICX1087
#define MASK_PWC_IOSEL1		0x00
#define MASK_PWC_IOSEL2		0x00
#else
#define MASK_PWC_IOSEL1		0xFF
#define MASK_PWC_IOSEL2		0xFF
#endif

#define PWC_REGA_INIT_VAL	0x03
/* 2006.08.8 fuj */
#ifdef CONFIG_SONY_ICX1087
/* 2006.11.27 fuj */
/* #define PWC_VOUTSET1_INIT_VAL	0xA2     */
/* #define PWC_VOUTSET2_INIT_VAL_OLD	0x60 */
/* #define PWC_VOUTSET2_INIT_VAL	0x60     */
#define PWC_VOUTSET1_INIT_VAL	0xA3
#define PWC_VOUTSET2_INIT_VAL_OLD	0xA8
#define PWC_VOUTSET2_INIT_VAL	0xA8
/* 2006.10.5 fuj */
#define PWC_VOUTSET3_INIT_VAL	0x20
#define PWC_VOUTSET3_INIT_VAL_OLD	0x2C
/* 2006.11.6 fuj */
#define PWC_VOUTSET3_INIT_VAL_ES2_2	0x00
#else
#define PWC_VOUTSET1_INIT_VAL	0xAC
#define PWC_VOUTSET2_INIT_VAL_OLD	0xA0
#define PWC_VOUTSET2_INIT_VAL	0xA8
#endif
/* 2006.09.25 has */
#ifdef CONFIG_SONY_ICX1087
#define PWC_IOSEL1_INIT_VAL	0x00	/* boot */
#else
#define PWC_IOSEL1_INIT_VAL	0x80	/* boot */
#endif
/* 2006.11.24 fuj */
/* #define PWC_GPPUPD3_INIT_VAL	0x55 */
#define PWC_GPPUPD3_INIT_VAL	0x10
/* 2006.11.17 fuj */
/* #define PWC_GPPUPD4_INIT_VAL	0x55 */
/* #define PWC_GPPUPD4_INIT_VAL	0x51 */
#define PWC_GPPUPD4_INIT_VAL	0x00
#define PWC_CHGCNTR1_INIT_VAL	0x03
#define PWC_TIMCNTR_INIT_VAL	0x02
#define PWC_USBCONT_INIT_VAL	0x07

/* 2006.06.7 ish */
#ifdef CONFIG_SONY_ICX1087
/* #define PWC_PSCNT1_INIT_VAL     0xFF */  /* set by u-boot */
/* #define PWC_PSCNT2_INIT_VAL     0xFE */  /* set by u-boot */
/* 2006.10.19 fuj */
/* #define PWC_PSCNT1_INIT_VAL     0x0C */  /* set by u-boot */
/* #define PWC_PSCNT2_INIT_VAL     0x06 */  /* set by u-boot */
#define PWC_PSCNT1_INIT_VAL_OLD 0x0C  /* set by u-boot */
#define PWC_PSCNT1_INIT_VAL     0x0E  /* set by u-boot */
/* 2006.12.20 fuj */
/* #define PWC_PSCNT2_INIT_VAL     0x0E */  /* set by u-boot */
#define PWC_PSCNT2_INIT_VAL     0x06  /* set by u-boot */
/* 2006.11.30 fuj */
/* #define PWC_PSCNT2_INIT_VAL_PWS 0x0A */  /* set by u-boot */
#define PWC_PSCNT2_INIT_VAL_PWS 0x02  /* set by u-boot */

/* 2006.09.22 aiz */
/* 2006.10.31 fuj */
/* #define PWC_IOSEL2_INIT_VAL		0xd9 */	/* set by u-boot */
/* #define PWC_IOOUT2_INIT_VAL_OLD	0xd1 */	/* set by u-boot */
/* #define PWC_IOOUT2_INIT_VAL		0xd9 */	/* set by u-boot */
/* 2006.11.17 fuj */
/* #define PWC_IOSEL2_INIT_VAL		0xd8 */	/* set by u-boot */
/* #define PWC_IOOUT2_INIT_VAL_OLD	0xd0 */	/* set by u-boot */
/* #define PWC_IOOUT2_INIT_VAL		0xd8 */	/* set by u-boot */
#define PWC_IOSEL2_INIT_VAL		0xf8	/* set by u-boot */
#define PWC_IOOUT2_INIT_VAL_OLD	0xf0	/* set by u-boot */
#define PWC_IOOUT2_INIT_VAL		0xf8	/* set by u-boot */
/* 2006.10.05 fuj */
/* 2006.10.31 fuj */
/* #define PWC_IOSEL2_INIT_VAL_PWS	0x19 */	/* set by u-boot for Power Save */
/* #define PWC_IOOUT2_INIT_VAL_OLD_PWS	0x11 */ /* set by u-boot for Power Save */
/* #define PWC_IOOUT2_INIT_VAL_PWS	0x19 */	/* set by u-boot for Power Save */
/* 2006.11.17 fuj */
/* #define PWC_IOSEL2_INIT_VAL_PWS	0x18 */	/* set by u-boot for Power Save */
/* #define PWC_IOOUT2_INIT_VAL_OLD_PWS	0x10 */ /* set by u-boot for Power Save */
/* #define PWC_IOOUT2_INIT_VAL_PWS	0x18 */	/* set by u-boot for Power Save */
#define PWC_IOSEL2_INIT_VAL_PWS	0x38	/* set by u-boot for Power Save */
#define PWC_IOOUT2_INIT_VAL_OLD_PWS	0x30/* set by u-boot for Power Save */
#define PWC_IOOUT2_INIT_VAL_PWS	0x38	/* set by u-boot for Power Save */

#define	PWC_DETMOD3L_INIT_VAL	0x01	/* set by u-boot */
#endif

#define PWC_LSIVER_ES1_1	0x01
/* 2006.10.19 fuj */
#define PWC_LSIVER_ES2_0	0x02
#define PWC_LSIVER_ES2_2	0x03
#else
#define PWC_RDBAK_ADR		0xFE
#define PWC_RDBAK_DATA		0xFF

#define UWIRE_CHECK_COUNT	5

#define PWC_USBINT_MASK		0xBF
#define PWC_TVINT_MASK		0x40
#define PWC_IRINT_MASK		0x01
#define PWC_DDINT_MASK		0x02

/* 
 * OUTPORT : IO04, IO05, IO06
 * INPORT  : IO02, IO03
 */
#define PWC_GIO_INPORT		0x0C
#define MASK_PWC_IOSEL2		0x7C

#define PWC_MASK3_USBINTG	0x04

#define PWC_CLRMODE_INTMODE	0x01
#endif				/* CONFIG_MP201 */

#endif				/* __ARCH_ARM_MACH_MP200_PWC_H */
