/*
 *  File Name	    : linux/arch/arm/mach-mp200/time.h
 *  Function	    : time
 *  Release Version : Ver 1.01
 *  Release Date    : 2006/05/12
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef __ARCH_ARM_MACH_MP200_TIME_H
#define __ARCH_ARM_MACH_MP200_TIME_H

#define TM_EN			0x00000001
#define TSTART			0x00000002
#define TO_EN			0x00000004
#define TCR_CLR			0x00000002

/*
 * Timer clock condition
 */
#define TIMER_SUSPEND		0
#define TIMER_RESUME		1
#define TIMER_FULLSPEED		2
#define TIMER_ECONOMY		3
#define TIMER_INIT		4

/*
 * TIN_SEL value
 */
#ifdef CONFIG_MP201
#define TIN_SEL_12M		0x00000000
#define TIN_SEL_32K		0x00000004
#define TIN_SEL_EXT		0x00000005
#define MASK_TIN_SEL		0x00000007
#else
#define TIN_SEL_12M		0x00000000
#define TIN_SEL_32K		0x00000001
#define TGNTIN_SEL_12M		0x00000000
#define TGNTIN_SEL_32K		0x00111111
#endif				/* CONFIG_MP201 */

/*
 * How long is the timer interval
 */

#ifdef CONFIG_SONY_ICX1087
#define TIMER_INTERVAL_12M	(112896 - 1)
#else
#define TIMER_INTERVAL_12M	(120000 - 1)
#endif

#define TIMER_INTERVAL_32K	(328 - 1)

#if CONFIG_MP200_CLOCK > 1000
#define TIMER_INTERVAL		TIMER_INTERVAL_12M
#define TIN_SEL_VAL		TIN_SEL_12M
#define TGNTIN_SEL_VAL		TGNTIN_SEL_12M
#else
#define TIMER_INTERVAL		TIMER_INTERVAL_32K
#define TIN_SEL_VAL		TIN_SEL_32K
#define TGNTIN_SEL_VAL		TGNTIN_SEL_32K
#endif

#define COUNTER_MAXVAL		TIMER_INTERVAL

#define DSP_COUNT_VALUE		1000	/* 1 mSec */

#define TIMER_SYSTEM		TIMER_TI0	/* Don't modify */
#define TIMER_DSP		TIMER_TG1

#define TIMER_SET_DELAY		100	/* usec */

struct tm_param_t {
	unsigned int usecs;
	unsigned int tm_op;
};

struct tm_reg_t {
	unsigned int irq;
	unsigned int tm_op;
	unsigned int tm_clr;
	unsigned int tm_set;
	unsigned int rcr;
	unsigned int clkdev;
	unsigned int rstdev;
	unsigned int clkctrldev;
	unsigned int tin_sel;
};

extern struct sys_timer mp200_timer;

extern void timer_set_clock_parm(unsigned int mode);
extern void timer_set_clock(unsigned int mode);

#endif
