/*
 *  File Name       : linux/drivers/char/mp200_wdt.h
 *  Function        : MP200 Watchdog driver 
 *  Release Version : Ver 1.02
 *  Release Date    : 2006/02/17
 *
 *  Copyright (C) NEC Electronics Corporation 2005-2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify itunder the terms of
 *  the GNU General Public License as published by Free Softwere Foundation;either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __DRIVERS_CHAR_WATCHDOG_MP200_WDT_H
#define __DRIVERS_CHAR_WATCHDOG_MP200_WDT_H

/* SMU register parameter */
#ifdef CONFIG_MP201
#define SMU_TW0_RSTREQ		0x00000010
#else
#define SMU_TW0_RSTREQ		0x00000100
#endif				/* CONFIG_MP201 */
#define SMU_TW_TIMEOUT_ACTION	SMU_TW0_RSTREQ

/* TIMER register parameter */
#define TM_EN			0x00000001
#define TSTART			0x00000002
#define TO_EN			0x00000004

/* PWC register parameter */
#ifndef CONFIG_MP201
#define RSTMASK			0x01
#endif				/* CONFIG_MP201 */
#define RDET_EN			0x01

/* other parameter */
#define WDT_MIN_TIMEOUT		1
#define WDT_MAX_TIMEOUT		32
#define DEFAULT_TIMEOUT		WDT_MAX_TIMEOUT	/* Default is 32 seconds */

#endif				/* __DRIVERS_CHAR_WATCHDOG_MP200_WDT_H */
