/*
 *  File Name       : linux/drivers/input/keyboard/mp200_btn.h
 *  Function        : button Interface
 *  Release Version : Ver 1.01
 *  Release Date    : 2006/02/22
 *
 *  Copyright (C) NEC Electronics Corporation 2005-2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify itunder the terms of
 *  the GNU General Public License as published by Free Softwere Foundation;either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __DRIVERS_INPUT_KEYBOARD_MP200_BTN_H__
#define __DRIVERS_INPUT_KEYBOARD_MP200_BTN_H__

/* key scan default parameter */
#define BTN_CHAT_GARDTIME	20	/* 20ms */
#define BTN_SCAN_INTERVAL	30	/* 30ms */

#define BTN_SCAN		(0x1 << GPIOCORE_GPIO_KEY_SCAN0)
#define BTN_SCAN_MASK		(0x1 << GPIOCORE_GPIO_KEY_SCAN0)

#define BTN_DATA_MASK		0x0f
#define BTN_DATA_SHIFT		GPIOCORE_GPIO_KEY_DATA0

#define MP200_BTN_NAME		"mp200_button"

struct mp200_btn_table {
	unsigned int scancode;	/* keycode */
	unsigned char btn_id_bit;	/* button id bit */
};

#endif				/* __DRIVERS_INPUT_KEYBOARD_MP200_BTN_H__ */
