/*
 * File Name       : drivers/media/video/omap/mp200_v4l2_rot.h
 * Function        : Video for Linux driver for MP201 driver core
 * Release Version :
 * Release Date    :
 *
 * Copyright (C) NEC Electronics Corporation 2006
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef MP200_V4L2_ROTATE__H
#define MP200_V4L2_ROTATE__H


struct mp200_v4l2_rot;
struct mp200_rot_req_v4l2;


/*===============================================================*/
/* ROT driver request information structure                      */
/*===============================================================*/
typedef struct mp200_rot_req_v4l2 {
    struct mp200_rot_req *next;     /* pointer to next ROT requst (used by ROT driver)               */
    struct mp200_rot_req *prev;     /* pointer to previous ROT requst (used by ROT driver)           */
    int                   status;   /* Status of ROT request (used by ROT driver)                    */
    rot_callback_func     callback; /* callback function                                             */
    unsigned long         data;     /* optional data (used by caller)                                */
    struct mp200_rot_reg_info rot_reg_info[ROT_REG_INFO_MAX];  /* ROT register setting informations  */
    /* repeat until end condition (max 50 pairs)                                                     */
    /*   end condition :                                                                             */
    /*         set 0x00000001 to ROT_REQ (request to start ROT process) reg=ROT_REQ data=0x00000001, */
    /*         or reg=-1(0xFFFFFFFF)                                                                 */
} MP200_ROT_REQ_V4L2;


/*===============================================================*/
/* rotate data structure                                         */
/*===============================================================*/
struct mp200_v4l2_rot {
	MP200_ROT_REQ_V4L2	qROT_req;
	struct v4l2_phys_add	src_add;
	struct v4l2_phys_add	rot_add;
	__u32		 	width;
	__u32			height;
	__u32			bytesperline;
	void * 			vb;
	int			next_buffer;
	int			rot_comp;
};


/***************************************************/
/* request data structure defintion. to ROT driver */
#define RotRequest(DATA, REG)  dev->rot_data.qROT_req.rot_reg_info[index_req].reg = REG;   \
                               dev->rot_data.qROT_req.rot_reg_info[index_req].data = DATA; \
                               index_req++;


/*********************************/
/* ROT register data  <ROT_MODE> */
#define RO_MODE_SRCENDIAN_BIG    0x00000000
#define RO_MODE_SRCENDIAN_LITTLE 0x00000010

#define RO_MODE_DSTENDIAN_BIG    0x00000000
#define RO_MODE_DSTENDIAN_LITTLE 0x00000008

#define RO_MODE_SRCYUV_422       0x00000000
#define RO_MODE_SRCYUV_420       0x00000004

#define RO_MODE_ROT_MOD_0        0x00000000
#define RO_MODE_ROT_MOD_90       0x00000001
#define RO_MODE_ROT_MOD_180      0x00000002
#define RO_MODE_ROT_MOD_270      0x00000003


/*********************************/
/* ROT double buffer status      */
#define ROT_BUFFER_A		0
#define ROT_BUFFER_B		1
#define ROT_BUFFER_ADDR_A	(ROT_SMEM_START)
#define ROT_BUFFER_ADDR_B	(ROT_SMEM_START + ROT_SMEM_LENGTH / 2)


#endif /* MP200_V4L2_ROTATE__H */
