/*
 * File Name       : drivers/media/video/omap/mp200_v4l2_time.h
 * Function        : Video for Linux driver for MP201 driver core
 * Release Version :
 * Release Date    :
 *
 * Copyright (C) NEC Electronics Corporation 2006
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef MP200_V4L2_TIME__H
#define MP200_V4L2_TIME__H


struct mp200_v4l2_time;


/*===============================================================*/
/* make option definetion                                        */
/*===============================================================*/
#define DEFAULT_ADJUST  17 /* msec */
#define ENABLE_DELAY    0  /* 1: delay enable
                            * 0: delay disable 
                            2006.08.15 ita. change from 1 to 0.
                            To make PCM driver work correctly.*/

/*===============================================================*/
/* flag definetion                                               */
/*===============================================================*/
#define STATE_STOP_TIMER   0
#define STATE_RUN_TIMER    1
#define STATE_CANCEL_TIMER 2

#define RET_STOP_TIMER 1


/*===============================================================*/
/* rotate data structure                                         */
/*===============================================================*/
struct mp200_v4l2_time {
	struct timer_list       wait_timer;
	struct timeval		now_time;
	struct timeval		do_time;
	struct timeval		comp_time;
	long			wait_time;
	long			adjust_time;
	void * 			vb;
};


#endif /* MP200_V4L2_TIME__H */
