/*
 *
 *  Copyright 2006,2007 Sony Corporation. 
 *
 *  Based on drivers/mtd/nand/mp200_nand.h
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


#ifndef __DRIVERS_MTD_NAND_ICX1087_NAND_BASE_H
#define __DRIVERS_MTD_NAND_ICX1087_NAND_BASE_H

#include <asm/arch/hardware.h>

/* device name */
#define NAND_NAME               "icx1087_nand_bios"

/* -------- */

#define NAND_ATBAR              (IO_ADDRESS(MP200_NAND_BASE) + 0x0000)  /* R/W */
#define NAND_ATCR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0004)  /* R   */
#define NAND_ATACR              (IO_ADDRESS(MP200_NAND_BASE) + 0x0008)  /* R   */
#define NAND_MSR                (IO_ADDRESS(MP200_NAND_BASE) + 0x000C)  /* R/W */
#define NAND_INTSTATUS          (IO_ADDRESS(MP200_NAND_BASE) + 0x0010)  /* R   */
#define NAND_INTRAWSTATUS       (IO_ADDRESS(MP200_NAND_BASE) + 0x0014)  /* R   */
#define NAND_INTENSET           (IO_ADDRESS(MP200_NAND_BASE) + 0x0018)  /* R/W */
#define NAND_INTENCLR           (IO_ADDRESS(MP200_NAND_BASE) + 0x001C)  /* W   */
#define NAND_INTFFCLR           (IO_ADDRESS(MP200_NAND_BASE) + 0x0020)  /* W   */
#define NAND_FRD                (IO_ADDRESS(MP200_NAND_BASE) + 0x0024)  /* R   */

/* -------- */

#define NAND_CR                 (IO_ADDRESS(MP200_NAND_BASE) + 0x0200)  /* R/W */
#define NAND_ESR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0204)  /* R   */
#define NAND_EICR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0208)  /* R/W */
#define NAND_EIRSR              (IO_ADDRESS(MP200_NAND_BASE) + 0x020C)  /* R   */
#define NAND_EICLR              (IO_ADDRESS(MP200_NAND_BASE) + 0x0210)  /* W   */
#define NAND_CECR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0214)  /* R/W */
#define NAND_CDR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0218)  /* R/W */
#define NAND_SCCR               (IO_ADDRESS(MP200_NAND_BASE) + 0x021C)  /* R/W  */
#define NAND_CWR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0220)  /* W   */
#define NAND_AWR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0224)  /* W   */
#define NAND_LAWR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0228)  /* W   */
#define NAND_DWR                (IO_ADDRESS(MP200_NAND_BASE) + 0x022C)  /* W   */
#define NAND_DRR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0230)  /* W   */
#define NAND_BDWR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0234)  /* W   */
#define NAND_BDRR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0238)  /* W   */
#define NAND_FPSCR              (IO_ADDRESS(MP200_NAND_BASE) + 0x023C)  /* W   */
#define NAND_FWSR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0240)  /* R   */
#define NAND_RSSR               (IO_ADDRESS(MP200_NAND_BASE) + 0x02A0)  /* R   */
#define NAND_RSEV0R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02C0)  /* R   */
#define NAND_RSEV1R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02C4)  /* R   */
#define NAND_RSEV2R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02C8)  /* R   */
#define NAND_RSEV3R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02CC)  /* R   */
#define NAND_RSEP0R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02D0)  /* R   */
#define NAND_RSEP1R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02D4)  /* R   */
#define NAND_RSEP2R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02D8)  /* R   */
#define NAND_RSEP3R             (IO_ADDRESS(MP200_NAND_BASE) + 0x02DC)  /* R   */
#define NAND_SDH0R              (IO_ADDRESS(MP200_NAND_BASE) + 0x0300)  /* R/W */
#define NAND_SDH1R              (IO_ADDRESS(MP200_NAND_BASE) + 0x0304)  /* R/W */
#define NAND_SDH2R              (IO_ADDRESS(MP200_NAND_BASE) + 0x0308)  /* R/W */
#define NAND_SDH3R              (IO_ADDRESS(MP200_NAND_BASE) + 0x030C)  /* R   */
#define NAND_SDH4R              (IO_ADDRESS(MP200_NAND_BASE) + 0x0310)  /* R   */
#define NAND_SDH5R              (IO_ADDRESS(MP200_NAND_BASE) + 0x0314)  /* R   */
#define NAND_SDH6R              (IO_ADDRESS(MP200_NAND_BASE) + 0x0318)  /* R   */
#define NAND_SDH7R              (IO_ADDRESS(MP200_NAND_BASE) + 0x031C)  /* R   */

#define NAND_RSEVxR             NAND_RSEV0R
#define NAND_RSEPxR             NAND_RSEP0R

/* -------- */

#define NAND_PSCR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0400)  /* R/W */
#define NAND_IPR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0404)  /* R/W */
#define NAND_IIDR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0408)  /* R   */
#define NAND_ITR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0420)  /* R/W */

/* -------- */

#define NAND_LCR                (IO_ADDRESS(MP200_NAND_BASE) + 0x0600)  /* R/W */
#define NAND_LICR               (IO_ADDRESS(MP200_NAND_BASE) + 0x060C)  /* R/W */
#define NAND_LIRSR              (IO_ADDRESS(MP200_NAND_BASE) + 0x0610)  /* R   */
#define NAND_LICLR              (IO_ADDRESS(MP200_NAND_BASE) + 0x0614)  /* W   */
#define NAND_TCCR               (IO_ADDRESS(MP200_NAND_BASE) + 0x0620)  /* R   */

/* -------- */

/* BBC unit value */
#define BBC_INT_512INT          (0x01)
#define BBC_INT_PAGEINT         (0x02)
#define BBC_INT_MASK            (0x03)

#define NAND_MSR_FBDC           (0x1 << 31)

#define NAND_MSR_PSIZE_512      (0x0 << 6)
#define NAND_MSR_PSIZE_2048     (0x2 << 6)
#define NAND_MSR_PSIZE_MASK     (0x3 << 6)

#define NAND_MSR_AHBDIR         (0x1 << 1)
#define NAND_MSR_AHBMEN         (0x1)

#define NAND_FRD_CACT           (0x1 << 19)
#define NAND_FRD_DATA_MASK      0xffff

/* EMMU unit value */
#define NAND_CECR_CEZ           0x01
#define NAND_CECR_MASK          0x0f
#define NAND_RSSR_CALC_END      0x08
#define NAND_RSSR_UNCOR         0x04
#define NAND_RSSR_ERR           0x02
#define NAND_RSSR_NO_ERR        0x01
#define NAND_RSSR_MASK          0x0f

#define RS_UNCORRECT_ERROR      (NAND_RSSR_CALC_END | NAND_RSSR_UNCOR | NAND_RSSR_ERR)
#define RS_NO_ERROR             (NAND_RSSR_CALC_END | NAND_RSSR_NO_ERR)
#define RS_CORECT_ERROR         (NAND_RSSR_CALC_END | NAND_RSSR_ERR)

#define RS_CHECK_SIZE           512

#define EMMU_INT_MASK           0x01ff
#define EMMU_INT_COMPEN         0x0100

/* PSC commands */
#define PSC_CMD_CESEL           0x0a
#define PSC_CMD_OUTCMD          0x10
#define PSC_CMD_OUTADRS         0x12
#define PSC_CMD_OUTLTADRS       0x14
#define PSC_CMD_CHKST           0x1e
#define PSC_CMD_DMAST           0xc0
#define PSC_CMD_INT             0xd0
#define PSC_CMD_STOPINT         0xd1
#define PSC_CMD_BTS             0xe0
#define PSC_CMD_WAITFOR         0xf0
#define PSC_CMD_WAITTC          0xf1
#define PSC_CMD_WAITBUSY        0xf2
#define PSC_CMD_WAITRDY         0xf3

#define PSC_START               0x01
#define PSC_CE0_ENA             0x0e
#define PSC_RYBYZ0_AND          0x10
#define PSC_RYBYZ0              0x01
#define PSC_DMA_START           0x05
#define PSC_DMA_RSOK            0x02
#define PSC_DMA_TCEA            0x01

#define LDMA_INT_RSERR          0x80
#define LDMA_INT_RSOK           0x20
#define LDMA_INT_PSC            0x08
#define LDMA_INT_LDMACTC        0x04
#define LDMA_INT_MASK           0xac

#define PSC_IIDR_ADR_SEND       0x01
#define PSC_IIDR_DMA_END        0x02

#define NAND_CMD_EDO            0xB1
#define BIOS_ERR_TIMEOUT        (-1)
#define BIOS_ERR_PARAM          (-2)

/* delay time */
#define NAND_DELAY_US           15
#define NAND_DELAY_CWR          22
#define NAND_DELAY_BDRR         8

/* timeout */
#define NAND_TMO_100US          2500 /* 250MHz x 10clkȲ */
#define NAND_READ_TIMEOUT       (NAND_TMO_100US * 5)
#define NAND_WRITE_TIMEOUT      (NAND_TMO_100US * 100)
#define NAND_ERASE_TIMEOUT      (NAND_TMO_100US * 500)
#define NAND_WRITE_WAIT_TICK    2
#define NAND_ERASE_WAIT_TICK    6

/* sequence */
#define PSC_CMD_SET_BEGIN()     do { pointer = NAND_ITR; psc_step = 0; } while (0)
#define PSC_CMD_SET(inst, ope)  do {  outl(((((ope) << 8) | (inst))), (pointer)); pointer += 4; psc_step++; } while(0)
#define PSC_CMD_SET_END()       outl(0, NAND_IPR)
#define PSC_SEQUENCE_END()      (psc_step - 1)
#define PSC_SEQUENCE_CUR()      (psc_step)

/* wait */
#define NAND_WAIT_NOT_CACT()    do { int i = NAND_TMO_100US; while( ( inl(NAND_FRD) & NAND_FRD_CACT ) && ( i > 0 ) ) { i--; } } while(0)
#define NAND_MACRO_CWR(cmd)     do { outl((cmd), NAND_CWR);  udelay(NAND_DELAY_US); NAND_WAIT_NOT_CACT(); } while(0)
#define NAND_MACRO_AWR(cmd)     do { outl((cmd), NAND_AWR);  udelay(NAND_DELAY_US); NAND_WAIT_NOT_CACT(); } while(0)
#define NAND_MACRO_LAWR(cmd)    do { outl((cmd), NAND_LAWR); udelay(NAND_DELAY_US); NAND_WAIT_NOT_CACT(); } while(0)

/* pin function */
#define SMU_PCTL_NAND_VALUE     0x00000088 /* pin func -> NAND, DA[15-8] -> GPIO, RBZ[3-1] -> Use, CSZ[3-1] -> Use */
#define SMU_PCTL_NAND_VALUE_DS  0x00000000 /* pin func -> all float */
#define SMU_PCTL_NAND_MASK      0x000001ff

/* pull control */
#define SMU_PULLCTL_NAND_VALUE     0x00000000 /* all no control */
#define SMU_PULLCTL_NAND_VALUE_DS  0x00001f80 /* all pd control */
#define SMU_PULLCTL_NAND_MASK      0x1e001f80 /* except for DATA14-8 */
#define SMU_PULLCTL_NAND_RB2_PU    0x08000000 /* RB2 pull up */
#define SMU_PULLCTL_NAND_RB2_MASK  0x08000800 /* RB2 pull up mask */

/* Write protect port */
#define GPIOCORE_NAND_XWP       GPIOCORE_GPIO_P47

#define NAND_ACCESS_TOSHIBA     0x00351100 /* ( CLH/ALH 0, CLS/ALS 0, REH 3,  RP 5, WH 1, WP 1 ) + 1 */
#define NAND_ACCESS_SAMSUNG     0x01c31200 /* ( CLH/ALH 0, CLS/ALS 1, REH 12, RP 3, WH 1, WP 2 ) + 1 */
#define NAND_ACCESS_INIT        0x01c51200 /* TOSHIBA | SAMSUNG */
#define NAND_MSR_INIT           (NAND_MSR_FBDC|NAND_MSR_PSIZE_2048|NAND_ACCESS_INIT)
#define NAND_MSR_TOSHIBA        (NAND_MSR_FBDC|NAND_MSR_PSIZE_2048|NAND_ACCESS_TOSHIBA)
#define NAND_MSR_SAMSUNG        (NAND_MSR_FBDC|NAND_MSR_PSIZE_2048|NAND_ACCESS_SAMSUNG)

#define NUM_CHIP                4
#define ICX1087_NAND_PAGE_SIZE  2048
#define ICX1087_NAND_USE_INTERRUPT


#endif /* __DRIVERS_MTD_NAND_ICX1087_NAND_BASE_H */
