/*
 * Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.
 */

/* 
 * The code contained herein is licensed under the GNU General Public
 * License. You may obtain a copy of the GNU General Public License
 * Version 2 or later at the following locations:
 * 
 * http://www.opensource.org/licenses/gpl-license.html 
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef MT9V143_H_
#define MT9V143_H_

/*!
 * mt9v143 IFP REGISTER BANK MAP
 */
#define MT9V143I_ADDR_SPACE_SEL           0x1
#define MT9V143I_BASE_MAXTRIX_SIGN        0x2
#define MT9V143I_BASE_MAXTRIX_SCALE15     0x3
#define MT9V143I_BASE_MAXTRIX_SCALE69     0x4
#define MT9V143I_APERTURE_GAIN            0x5
#define MT9V143I_MODE_CONTROL             0x6
#define MT9V143I_SOFT_RESET               0x7
#define MT9V143I_FORMAT_CONTROL           0x8
#define MT9V143I_BASE_MATRIX_CFK1         0x9
#define MT9V143I_BASE_MATRIX_CFK2         0xa
#define MT9V143I_BASE_MATRIX_CFK3         0xb
#define MT9V143I_BASE_MATRIX_CFK4         0xc
#define MT9V143I_BASE_MATRIX_CFK5         0xd
#define MT9V143I_BASE_MATRIX_CFK6         0xe
#define MT9V143I_BASE_MATRIX_CFK7         0xf
#define MT9V143I_BASE_MATRIX_CFK8         0x10
#define MT9V143I_BASE_MATRIX_CFK9         0x11
#define MT9V143I_AWB_POSITION             0x12
#define MT9V143I_AWB_RED_GAIN             0x13
#define MT9V143I_AWB_BLUE_GAIN            0x14
#define MT9V143I_DELTA_MATRIX_CF_SIGN     0x15
#define MT9V143I_DELTA_MATRIX_CF_D1       0x16
#define MT9V143I_DELTA_MATRIX_CF_D2       0x17
#define MT9V143I_DELTA_MATRIX_CF_D3       0x18
#define MT9V143I_DELTA_MATRIX_CF_D4       0x19
#define MT9V143I_DELTA_MATRIX_CF_D5       0x1a
#define MT9V143I_DELTA_MATRIX_CF_D6       0x1b
#define MT9V143I_DELTA_MATRIX_CF_D7       0x1c
#define MT9V143I_DELTA_MATRIX_CF_D8       0x1d
#define MT9V143I_DELTA_MATRIX_CF_D9       0x1e
#define MT9V143I_LUMINANCE_LIMIT_WB       0x20
#define MT9V143I_RBG_MANUUAL_WB           0x21
#define MT9V143I_AWB_RED_LIMIT            0x22
#define MT9V143I_AWB_BLUE_LIMIT           0x23
#define MT9V143I_MATRIX_ADJUST_LIMIT      0x24
#define MT9V143I_AWB_SPEED                0x25
#define MT9V143I_H_BOUND_AE               0x26
#define MT9V143I_V_BOUND_AE               0x27
#define MT9V143I_H_BOUND_AE_CEN_WIN       0x2b
#define MT9V143I_V_BOUND_AE_CEN_WIN       0x2c
#define MT9V143I_BOUND_AWB_WIN            0x2d
#define MT9V143I_AE_PRECISION_TARGET      0x2e
#define MT9V143I_AE_SPEED                 0x2f
#define MT9V143I_RED_AWB_MEASURE          0x30
#define MT9V143I_LUMA_AWB_MEASURE         0x31
#define MT9V143I_BLUE_AWB_MEASURE         0x32
#define MT9V143I_LIMIT_SHARP_SATU_CTRL    0x33
#define MT9V143I_LUMA_OFFSET              0x34
#define MT9V143I_CLIP_LIMIT_OUTPUT_LUMI   0x35
#define MT9V143I_GAIN_LIMIT_AE            0x36
#define MT9V143I_SHUTTER_WIDTH_LIMIT_AE   0x37
#define MT9V143I_CEN_LEN_POSITION         0x38
#define MT9V143I_SQUARE_HOR_LEN_POSITION  0x39
#define MT9V143I_SQUARE_VER_LEN_POSITION  0x3a
#define MT9V143I_HOR_CORR_RED             0x3b
#define MT9V143I_HOR_CORR_GREEN           0x3c
#define MT9V143I_HOR_CORR_BLUE            0x3d
#define MT9V143I_VER_CORR_RED_GREEN       0x3e
#define MT9V143I_VER_CORR_BLUE            0x3f
#define MT9V143I_DECIMATION_CTRL          0x46
#define MT9V143I_THRESHOLD_EDGE_DEFECT    0x47
#define MT9V143I_TEST_PAT_GEN             0x48
#define MT9V143I_CHIP_VERSION             0x49
#define MT9V143I_DEFECT_COUNT             0x4a
#define MT9V143I_AE_DIR_BIRGHT_ADJ        0x4b
#define MT9V143I_LUMA_SUM_MEASURE         0x4c
#define MT9V143I_TIME_ADV_SUM_LUMA        0x4d
#define MT9V143I_GAMMA_KNEE_Y12           0x53
#define MT9V143I_GAMMA_KNEE_Y34           0x54
#define MT9V143I_GAMMA_KNEE_Y56           0x55
#define MT9V143I_GAMMA_KNEE_Y78           0x56
#define MT9V143I_GAMMA_KNEE_Y90           0x57
#define MT9V143I_GAMMA_VALUE_Y0           0x58
#define MT9V143I_RATIO_IMAGE_GAIN_BASE    0x5e
#define MT9V143I_RATIO_IMAGE_GAIN_DELTA   0x5f
#define MT9V143I_SIGN_VALUE_REG5F         0x60
#define MT9V143I_MAX_GAIN_AE              0x67

#define MT9V143I_SEL_IFP                  0x1
#define MT9V143I_SEL_SCA                  0x4
#define MT9V143I_FC_RGB_OR_YUV            0x1000

/*!
 * Mt9v143 SENSOR CORE REGISTER BANK MAP
 */
#define MT9V143S_ADDR_SPACE_SEL           0x1
#define MT9V143S_COLUMN_START             0x2
#define MT9V143S_WIN_HEIGHT               0x3
#define MT9V143S_WIN_WIDTH                0x4
#define MT9V143S_HOR_BLANKING             0x5
#define MT9V143S_VER_BLANKING             0x6
#define MT9V143S_OUTPUT_CTRL              0x7
#define MT9V143S_SHUTTER_WIDTH            0x9
#define MT9V143S_PIXEL_CLOCK_SPEED        0xa
#define MT9V143S_RESTART                  0xb
#define MT9V143S_SHUTTER_DELAY            0xc
#define MT9V143S_RESET                    0xd
#define MT9V143S_COLUMN_START_IN_ZOOM     0x12
#define MT9V143S_DIGITAL_ZOOM             0x1e
#define MT9V143S_READ_MODE                0x20
#define MT9V143S_DAC_CTRL                 0x27
#define MT9V143S_IREF_ADJ                 0x28
#define MT9V143S_GREEN1_GAIN              0x2b
#define MT9V143S_BLUE_GAIN                0x2c
#define MT9V143S_READ_GAIN                0x2d
#define MT9V143S_GREEN2_GAIN              0x2e
#define MT9V143S_ROW_START                0x30
#define MT9V143S_ROW_START_ZOOM           0x31
#define MT9V143S_TEST_DATA                0x32
#define MT9V143S_GLOBAL_GAIN              0x35
#define MT9V143S_SENSOR_CORE_VERSION      0x36
#define MT9V143S_VREF                     0x3b
#define MT9V143S_IREF                     0x3c
#define MT9V143S_CAL_THRESHOLD            0x5f
#define MT9V143S_CAL_G1                   0x60
#define MT9V143S_CAL_G2                   0x61
#define MT9V143S_CAL_CTRL                 0x62
#define MT9V143S_CAL_R                    0x63
#define MT9V143S_CAL_B                    0x64
#define MT9V143S_CLOCK_CTRL               0x65
#define MT9V143S_CHIP_ENABLE              0xf1

// OUTPUT_CTRL
#define MT9V143S_OUTCTRL_SYNC             0x1
#define MT9V143S_OUTCTRL_CHIP_ENABLE      0x2

// READ_MODE
#define MT9V143S_RM_NOBADFRAME            0x1
#define MT9V143S_RM_NODESTRUCT            0x2
#define MT9V143S_RM_COLUMNSKIP            0x4
#define MT9V143S_RM_ROWSKIP               0x8
#define MT9V143S_RM_BOOSTEDRESET          0x1000
#define MT9V143S_RM_COLUMN_LATE           0x10
#define MT9V143S_RM_ROW_LATE              0x80
#define MT9V143S_RM_RIGTH_TO_LEFT         0x4000
#define MT9V143S_RM_BOTTOM_TO_TOP         0x8000	

/*! I2C Slave Address */
#ifdef CONFIG_VIRTIO_SUPPORT  
#define MT9V143_I2C_ADDRESS	0x48
#else
#define MT9V143_I2C_ADDRESS	0x5c
#endif
/*! I2C Bus that this device is connected to */
#define I2C_BUS                 0

/* Ioctls */
#define MT9V143_IOCTL_POWER_ON  0x1
#define MT9V143_IOCTL_POWER_OFF 0x2

/*!
 * The data format enum for the mt9v143 sensor
 */
typedef enum {
        MT9V143_OutputFormat_CCIR656 = 0,  /*!< CCIR656 */
        MT9V143_OutputFormat_RGB565,	   /*!< RGB565  */
} MT9V143_OutputFormat;

/*!
 * The image resolution enum for the mt9v143 sensor
 */
typedef enum {
        MT9V143_OutputResolution_VGA = 0,  /*!< VGA size */
        MT9V143_OutputResolution_QVGA,	   /*!< QVGA size */
        MT9V143_OutputResolution_CIF,	   /*!< CIF size */
        MT9V143_OutputResolution_QCIF,	   /*!< QCIF size */
        MT9V143_OutputResolution_QQVGA,	   /*!< QQVGA size */
        MT9V143_OutputResolution_SXGA	   /*!< SXGA size */
} MT9V143_OutputResolution;

/*!
 * Mt9v143 Core Register structure.
 */
typedef struct {
        u32 addressSelect;       /*!< select address bank for Core Register 0x4 */
        u32 columnStart;         /*!< Starting Column */
        u32 windowHeight;      	 /*!< Window Height */ 
        u32 windowWidth;       	 /*!< Window Width */ 
        u32 horizontalBlanking;	 /*!< Horizontal Blank time, in pixels */
        u32 verticalBlanking;  	 /*!< Vertical Blank time, in pixels */
        u32 outputControl;     	 /*!< Register to control sensor output */
        u32 shutterWidth;      	 
        u32 pixelClockSpeed;  	 /*!< pixel date rate */
        u32 restart;             /*!< Abandon the readout of current frame */
        u32 shutterDelay;      	 
        u32 reset;               /*!< reset the sensor to the default mode */
        u32 digitalZoom;       	 /*!< 1 means zoom by 2 */
        u32 readMode;          	 /*!< Readmode: aspects of the readout of the sensor */
        u32 dacControl; 
        u32 irefAdj;  
        u32 green1Gain;        	 /*!< Gain Settings */
        u32 blueGain;          
        u32 redGain;           
        u32 green2Gain;        
        u32 rowStart;  
        u32 rowStartZoom;  
        u32 testData;          	 /*!< test mode */
        u32 globalGain;        
        u32 sensorVersion;       
        u32 vRef;          
        u32 iRef;        
        u32 calibThreshold;    
        u32 calibGreen1;      
        u32 calibGreen2;      
        u32 calibControl;
        u32 calibRed;    
        u32 calibBlue;   
        u32 clockControl;
        u32 chipEnable;           /*!< Image core Registers written by image flow processor */
} mt9v143_coreReg;

/*!
 * Mt9v143 IFP Register structure.
 */
typedef struct {
        u32 addrSpaceSel;        /*!< select address bank for Core Register 0x1 */
        u32 baseMaxtrixSign;     /*!< sign of coefficient for base color correction matrix */
        u32 baseMaxtrixScale15;  /*!< scaling of color correction coefficient K1-5 */
        u32 baseMaxtrixScale69;  /*!< scaling of color correction coefficient K6-9 */
        u32 apertureGain;        /*!< sharpening */
        u32 modeControl;         /*!< bit 7 CCIR656 sync codes are embedded in the image */
        u32 softReset;           /*!< Image processing mode: 1 reset mode, 0 operational mode */
        u32 formatControl;       /*!< bit12 1 for RGB565, 0 for YcrCb */
        u32 baseMatrixCfk1;      /*!< K1 Color correction coefficient */
        u32 baseMatrixCfk2;      /*!< K2 Color correction coefficient */
        u32 baseMatrixCfk3;      /*!< K3 Color correction coefficient */
        u32 baseMatrixCfk4;      /*!< K4 Color correction coefficient */
        u32 baseMatrixCfk5;      /*!< K5 Color correction coefficient */
        u32 baseMatrixCfk6;      /*!< K6 Color correction coefficient */
        u32 baseMatrixCfk7;      /*!< K7 Color correction coefficient */
        u32 baseMatrixCfk8;      /*!< K8 Color correction coefficient */
        u32 baseMatrixCfk9;      /*!< K9 Color correction coefficient */
        u32 awbPosition;         /*!< Current position of AWB color correction matrix */
        u32 awbRedGain;          /*!< Current value of AWB red channel gain */
        u32 awbBlueGain;         /*!< Current value of AWB blue channel gain */
        u32 deltaMatrixCFSign; 	 /*!< Sign of coefficients of delta color correction matrix register */
        u32 deltaMatrixCFD1;   	 /*!< D1 Delta coefficient */
        u32 deltaMatrixCFD2;   	 /*!< D2 Delta coefficient */
        u32 deltaMatrixCFD3;   	 /*!< D3 Delta coefficient */
        u32 deltaMatrixCFD4;   	 /*!< D4 Delta coefficient */
        u32 deltaMatrixCFD5;   	 /*!< D5 Delta coefficient */
        u32 deltaMatrixCFD6;   	 /*!< D6 Delta coefficient */
        u32 deltaMatrixCFD7;   	 /*!< D7 Delta coefficient */
        u32 deltaMatrixCFD8;   	 /*!< D8 Delta coefficient */
        u32 deltaMatrixCFD9;   	 /*!< D9 Delta coefficient */
        u32 lumLimitWB;          /*!< Luminance range of pixels considered in WB statistics */
        u32 RBGManualWB;       	 /*!< Red and Blue color channel gains for manual white balance */
        u32 awbRedLimit;         /*!< Limits on Red channel gain adjustment through AWB */
        u32 awbBlueLimit;        /*!< Limits on Blue channel gain adjustment through AWB */
        u32 matrixAdjLimit;  	 /*!< Limits on color correction matrix adjustment through AWB */
        u32 awbSpeed;            /*!< AWB speed and color saturation control */
        u32 HBoundAE;            /*!< Horizontal boundaries of AWB measurement window */
        u32 VBoundAE;            /*!< Vertical boundaries of AWB measurement window */
        u32 HBoundAECenWin;   	 /*!< Horizontal boundaries of AE measurement window for backlight compensation */
        u32 VBoundAECenWin;   	 /*!< Vertical boundaries of AE measurement window for backlight compensation */
        u32 boundAwbWin;         /*!< Boundaries of AWB measurement window */
        u32 AEPrecisionTarget;   /*!< Auto exposure target and precision control */
        u32 AESpeed;             /*!< AE speed and sensitivity control register */
        u32 redAWBMeasure;       /*!< Measure of the red channel value used by AWB */
        u32 lumaAWBMeasure;      /*!< Measure of the luminance channel value used by AWB */
        u32 blueAWBMeasure;      /*!< Measure of the blue channel value used by AWB */
        u32 limitSharpSatuCtrl;	 /*!< Limits Sharpness and Saturation Control */
        u32 lumaOffset;          /*!< Luma Offset (Brightness) */
        u32 clipLimitOutputLumi; /*!< Clipping Limits On Output Luminance */
        u32 gainLimitAE;         /*!< Gain Limits for AE */
        u32 shutterWidthLimitAE; /*!< Shutter Width Limits for AE */
        u32 centerLenPosition;	 /*!< Center of Lens Position (Yo,Xo) */
        u32 squareHLenPosition;	 /*!< Square of Horizontal Lens Position (Xo x Xo) */
        u32 squareVLenPosition;	 /*!< Square of Vertical Lens Position (Yo x Yo) */
        u32 HCorrectionR;        /*!< Horizontal Correction for Red Pixels */
        u32 HCorrectionG;        /*!< Horizontal Correction for Green Pixels */
        u32 HCorrectionB;        /*!< Horizontal Correction for Blue Pixels */
        u32 VCorrectionRG;       /*!< Vertical Correction for Red and Green Pixels */
        u32 VCorrectionB;        /*!< Vertical Correction for Blue Pixels */
        u32 decimationControl;   /*!< Decimation Control */
        u32 thresholdEdegDefect; /*!< Threshold for Edge and Defect Detection */
        u32 testPattern;         /*!< Test Pattern Generator */
        u32 chipVersion;         /*!< Chip Version */
        u32 defectCount;         /*!< Defect Count */
        u32 AEDirectionBright;	 /*!< AE Direction of Brightness Adj */
        u32 lumaSum;             /*!< Luma Sum Measurement */
        u32 timeAdvSum;          /*!< Time Adv. Sum of Luma */
        u32 gammaKneeY12;        /*!< Gamma knee points Y1 and Y2 */
        u32 gammaKneeY34;        /*!< Gamma knee points Y3 and Y4 */
        u32 gammaKneeY56;        /*!< Gamma knee points Y5 and Y6 */
        u32 gammaKneeY78;        /*!< Gamma knee points Y7 and Y8 */
        u32 gammaKneeY90;        /*!< Gamma knee points Y9 and Y10 */
        u32 gammaKneeY0;         /*!< Gamma knee point Y0 */
        u32 ratioImageGainBase;	 /*!< Ratios of Image Gains for Base Matrix */
        u32 ratioImageGainDelta; /*!< Ratios of Image Gains for Delta Matrix */
        u32 signValueReg5F;      /*!< Signs of values in Reg0x5F */
        u32 maxGainAE;           /*!< MAX Digital Gain used by AE block */
        u32 flashCtrl;           /*!< Flash control */
} mt9v143_IFPReg;

/*!								 
 * mt9v143 Config structure		 
 */								 
typedef struct {
        mt9v143_coreReg *coreReg; /*!< Sensor Core Register Bank */
        mt9v143_IFPReg *ifpReg;	  /*!< IFP Register Bank */
} mt9v143_conf;

/*!
 * Function declarations 
 */
/*!
 * mt9v143_PowerOn function
 * Turn Sensor power On/Off
 *
 * @param       powerOn      true to turn camera on, otherwise shut down
 *
 * @return status
 */
u8 
mt9v143_PowerOn(bool powerOn);
/*!
* Set sensor to test mode, which will generate chessboard.
*		 
* @return none
*/
void 
mt9v143_TestPattern(void);

#endif   // MT9V143_H_
