/*
 * Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*!
 * @file dptc.h
 *
 * @brief ArgonPlus dvfs & dptc table file. 
 * 
 * @ingroup PM
 */ 
#ifndef __DVFS_DPTC_TABLE_ARGON_H__
#define __DVFS_DPTC_TABLE_ARGON_H__

/*!
 * Default DPTC table definition
 */
#define NUM_OF_FREQS 1
#define NUM_OF_WP    9

static char * default_table_str = "WORKING POINT 17\n\
\n\
WP 0x1c\n\
WP 0x1b\n\
WP 0x1a\n\
WP 0x19\n\
WP 0x18\n\
WP 0x17\n\
WP 0x16\n\
WP 0x15\n\
WP 0x14\n\
WP 0x13\n\
WP 0x12\n\
WP 0x11\n\
WP 0x10\n\
WP 0xf\n\
WP 0xe\n\
WP 0xd\n\
WP 0xc\n\
\n\
DCVR 0xffc00000 0x98a45784 0xffc00000 0xe676ed98\n\
DCVR 0xffc00000 0x98e46788 0xffc00000 0xe7770d9c\n\
DCVR 0xffc00000 0x99246788 0xffc00000 0xe8371da0\n\
DCVR 0xffc00000 0x9964778c 0xffc00000 0xe8b72da0\n\
DCVR 0xffc00000 0x99a4778c 0xffc00000 0xe9372da0\n\
DCVR 0xffc00000 0x9a248790 0xffc00000 0xe9f74da4\n\
DCVR 0xffc00000 0x9a648790 0xffc00000 0xeaf75da8\n\
DCVR 0xffc00000 0x9ae49794 0xffc00000 0xeb776da8\n\
DCVR 0xffc00000 0x9b249794 0xffc00000 0xebf77dac\n\
DCVR 0xffc00000 0x9ba4a798 0xffc00000 0xecb78dac\n\
DCVR 0xffc00000 0x9c64b79c 0xffc00000 0xed379db0\n\
DCVR 0xffc00000 0x9ca4b79c 0xffc00000 0xedf7adb0\n\
DCVR 0xffc00000 0x9ce4b79c 0xffc00000 0xeeb7bdb4\n\
DCVR 0xffc00000 0x9de4d7a4 0xffc00000 0xf037ddb8\n\
DCVR 0xffc00000 0x9ee4e7a8 0xffc00000 0xf177fdbc\n\
DCVR 0xffc00000 0xa02507b0 0xffc00000 0xf3381dc0\n\
DCVR 0xffc00000 0xa1a537bc 0xffc00000 0xf4b84dc4\n\
";

#endif
