/*
 * Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.
 */

/*
 * The code contained herein is licensed under the GNU General Public
 * License. You may obtain a copy of the GNU General Public License
 * Version 2 or later at the following locations:
 *
 * http://www.opensource.org/licenses/gpl-license.html
 * http://www.gnu.org/copyleft/gpl.html
 */

/*!
 * @file mxc_pm_reg.h
 *
 * @brief This file provides all the Register Addresses, Bit definitions.
 *
 * @ingroup LPMD
 */


#ifndef MXC_PM_REG_H

#define MXC_PM_REG_H

#include <asm/arch/platform.h>

/* Address offsets of ArgonPlus CRM_MCU(CCM) registers */

#define CRM_MCU_MCR             IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x00)
#define CRM_MCU_MPDR0           IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x04)
#define CRM_MCU_MPDR1           IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x08)
#define CRM_MCU_MPCTL           IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x10)
#define CRM_MCU_MCGR0           IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x1c)
#define CRM_MCU_MCGR1           IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x20)
#define CRM_MCU_MCGR2           IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x24)
#define CRM_MCU_COSR            IO_ADDRESS(CRM_MCU_BASE_ADDR + 0x18)

/* Bit definitions of CRM_MCU registers */

#define MCR_LPMD1               0x40000000
#define MCR_LPMD0               0x20000000
#define MCR_WBEN                0x80000000
#define MCR_SBYOS               0x00002000
#define MCR_DPE                 0x00000002
#define MPDR0_IPG_PDF           0x00000C00
#define MPDR0_MAX_PDF           0x00000038
#define MPDR0_BRMM              0x00000007
#define MPCTL_PDF               0x00000000
#define MPCTL_MFD               0x00000000
#define MPCTL_MFI               0x00000000
#define MPCTL_MFN               0x00000000

#endif

