/*
 * File Name       : /drivers/video/FIFO.h
 * Function        : FIFO MMIO definitions
 * Release Version : Ver 1.00
 * Release Date    : 2005/05/25
 *
 * Copyright (C) NEC Electronics Corporation 2005
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
/* FIFO.h : FIFO MMIO definitions for uPD77601	2004/3/4 */

#ifndef __QFB_FIFO_H__
#define __QFB_FIFO_H__


/*****************************************************************************
 * FIFO MMIO definitions
 *****************************************************************************/

#if 0
/* from platform.h for uPD77601 */
#define BANK4_BASE			0x40000000
#define FIFO_OFFSET			0x00070000
#define FIFO_BASE			(BANK4_BASE+FIFO_OFFSET)
#define FIFO_SIZE			SZ_64K
#else
#include <asm/arch/hardware.h>
#define FIFO_OFFSET			MP200_FIFO_OFFSET
#define FIFO_BASE			MP200_FIFO_BASE
#define FIFO_SIZE			MP200_FIFO_SIZE
#endif

#ifdef CONFIG_MP201
#define FIF_WBUFCTRL			(0x0000)
#define FIF_WBUFSTATE			(0x0004)
#define FIF_REQPRI			(0x0008)
#define FIF_FCCTRL			(0x0100)
#define FIF_FRAMEAADDR			(0x0104)
#define FIF_FRAMEBADDR			(0x0108)
#define FIF_FRAMESIZE			(0x010c)
#define FIF_FCBASEADDR			(0x0110)
#define FIF_MODE			(0x0200)
#define FIF_STATE			(0x0204)
#define FIF_STATERST			(0x0208)
#define FIF_WBRBLRU			(0x020C)
#define FIF_SWT5ERR			(0x0400)
#define FIF_SWT6ERR			(0x0404)
#define FIF_SWT8ERR			(0x040c)
#else
/* from quhw_fif_reg.h */
#define FIF_MODE			(0x0000)
#define	FIF_STATE			(0x0004)
#define	FIF_STATERST			(0x0008)
#define FIF_WBUFCTRL		        (0x0010)
#define FIF_WBUFSTATE		        (0x0014)
#define FIF_WBRBLRU			(0x0018)
#define	FIF_REQPRI			(0x0020)
#define FIF_FCCTRL			(0x0100)
#define FIF_FRAMEAADDR		        (0x0104)
#define FIF_FRAMEBADDR		        (0x0108)
#define FIF_FRAMESIZE		        (0x010c)
#define FIF_FCBASEADDR		        (0x0110)
#define	FIF_SWT5ERR			(0x0400)
#define	FIF_SWT6ERR			(0x0404)
#define	FIF_SWT7ERR			(0x0408)
#define	FIF_SWT8ERR			(0x040c)
#endif				/* CONFIG_MP201 */


#endif /* __QFB_FIFO_H__ */
