
/*
 * Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/*!
 * @file sdma_script_code.h
 * @brief This file contains functions of SDMA scripts code initialization
 * 
 * The file was generated automatically. Based on sdma scripts library.
 * 
 * @ingroup SDMA
 */

#ifndef SDMA_SCRIPT_CODE_H
#define SDMA_SCRIPT_CODE_H


/*! 
* Following define start address of start script 
*/
#define start_ADDR	0
/*! 
* Following define size of start script 
*/
#define start_SIZE	21
 
/*! 
* Following define start address of core script 
*/
#define core_ADDR	80
/*! 
* Following define size of core script 
*/
#define core_SIZE	152
 
/*! 
* Following define start address of common script 
*/
#define common_ADDR	232
/*! 
* Following define size of common script 
*/
#define common_SIZE	191
 
/*! 
* Following define start address of burst_copy script 
*/
#define burst_copy_ADDR	423
/*! 
* Following define size of burst_copy script 
*/
#define burst_copy_SIZE	87
 
/*! 
* Following define start address of dsp_2_burst script 
*/
#define dsp_2_burst_ADDR	510
/*! 
* Following define size of dsp_2_burst script 
*/
#define dsp_2_burst_SIZE	24
 
/*! 
* Following define start address of burst_2_dsp script 
*/
#define burst_2_dsp_ADDR	534
/*! 
* Following define size of burst_2_dsp script 
*/
#define burst_2_dsp_SIZE	24
 
/*! 
* Following define start address of dsp_copy script 
*/
#define dsp_copy_ADDR	558
/*! 
* Following define size of dsp_copy script 
*/
#define dsp_copy_SIZE	86
 
/*! 
* Following define start address of mcu_2_mcu script 
*/
#define mcu_2_mcu_ADDR	644
/*! 
* Following define size of mcu_2_mcu script 
*/
#define mcu_2_mcu_SIZE	79
 
/*! 
* Following define start address of mcu_2_per script 
*/
#define mcu_2_per_ADDR	723
/*! 
* Following define size of mcu_2_per script 
*/
#define mcu_2_per_SIZE	88
 
/*! 
* Following define start address of test script 
*/
#define test_ADDR	811
/*! 
* Following define size of test script 
*/
#define test_SIZE	63
 
/*! 
* Following define start address of mcu_2_dsp script 
*/
#define mcu_2_dsp_ADDR	874
/*! 
* Following define size of mcu_2_dsp script 
*/
#define mcu_2_dsp_SIZE	30
 
/*! 
* Following define start address of mcu_2_dsp_2buf script 
*/
#define mcu_2_dsp_2buf_ADDR	904
/*! 
* Following define size of mcu_2_dsp_2buf script 
*/
#define mcu_2_dsp_2buf_SIZE	113
 
/*! 
* Following define start address of dsp_2_mcu script 
*/
#define dsp_2_mcu_ADDR	1017
/*! 
* Following define size of dsp_2_mcu script 
*/
#define dsp_2_mcu_SIZE	30
 
/*! 
* Following define start address of dsp_2_mcu_2buf script 
*/
#define dsp_2_mcu_2buf_ADDR	1047
/*! 
* Following define size of dsp_2_mcu_2buf script 
*/
#define dsp_2_mcu_2buf_SIZE	113
 
/*! 
* Following define start address of dsp_2_dsp script 
*/
#define dsp_2_dsp_ADDR	1160
/*! 
* Following define size of dsp_2_dsp script 
*/
#define dsp_2_dsp_SIZE	64
 
/*! 
* Following define start address of per_2_mcu script 
*/
#define per_2_mcu_ADDR	1224
/*! 
* Following define size of per_2_mcu script 
*/
#define per_2_mcu_SIZE	121
 
/*! 
* Following define start address of dsp_2_per_2buf script 
*/
#define dsp_2_per_2buf_ADDR	1345
/*! 
* Following define size of dsp_2_per_2buf script 
*/
#define dsp_2_per_2buf_SIZE	164
 
/*! 
* Following define start address of per_2_dsp_2buf script 
*/
#define per_2_dsp_2buf_ADDR	1509
/*! 
* Following define size of per_2_dsp_2buf script 
*/
#define per_2_dsp_2buf_SIZE	168
 
/*! 
* Following define start address of per_2_per script 
*/
#define per_2_per_ADDR	1677
/*! 
* Following define size of per_2_per script 
*/
#define per_2_per_SIZE	67
 
/*! 
* Following define start address of error_dsp script 
*/
#define error_dsp_ADDR	1744
/*! 
* Following define size of error_dsp script 
*/
#define error_dsp_SIZE	34
 
/*! 
* Following define start address of app_2_dsp script 
*/
#define app_2_dsp_ADDR	6144
/*! 
* Following define size of app_2_dsp script 
*/
#define app_2_dsp_SIZE	95
 
/*! 
* Following define start address of app_2_mcu script 
*/
#define app_2_mcu_ADDR	6239
/*! 
* Following define size of app_2_mcu script 
*/
#define app_2_mcu_SIZE	95
 
/*! 
* Following define start address of app_2_per script 
*/
#define app_2_per_ADDR	6334
/*! 
* Following define size of app_2_per script 
*/
#define app_2_per_SIZE	95
 
/*! 
* Following define start address of dsp_2_app script 
*/
#define dsp_2_app_ADDR	6429
/*! 
* Following define size of dsp_2_app script 
*/
#define dsp_2_app_SIZE	119
 
/*! 
* Following define start address of dsp_2_shp script 
*/
#define dsp_2_shp_ADDR	6548
/*! 
* Following define size of dsp_2_shp script 
*/
#define dsp_2_shp_SIZE	115
 
/*! 
* Following define start address of dsp_interrupt_only script 
*/
#define dsp_interrupt_only_ADDR	6663
/*! 
* Following define size of dsp_interrupt_only script 
*/
#define dsp_interrupt_only_SIZE	2
 
/*! 
* Following define start address of firi_2_mcu script 
*/
#define firi_2_mcu_ADDR	6665
/*! 
* Following define size of firi_2_mcu script 
*/
#define firi_2_mcu_SIZE	178
 
/*! 
* Following define start address of loopback_on_dsp_side script 
*/
#define loopback_on_dsp_side_ADDR	6843
/*! 
* Following define size of loopback_on_dsp_side script 
*/
#define loopback_on_dsp_side_SIZE	101
 
/*! 
* Following define start address of loopback_on_mcu_side script 
*/
#define loopback_on_mcu_side_ADDR	6944
/*! 
* Following define size of loopback_on_mcu_side script 
*/
#define loopback_on_mcu_side_SIZE	100
 
/*! 
* Following define start address of mcu_2_app script 
*/
#define mcu_2_app_ADDR	7044
/*! 
* Following define size of mcu_2_app script 
*/
#define mcu_2_app_SIZE	119
 
/*! 
* Following define start address of mcu_2_firi script 
*/
#define mcu_2_firi_ADDR	7163
/*! 
* Following define size of mcu_2_firi script 
*/
#define mcu_2_firi_SIZE	74
 
/*! 
* Following define start address of mcu_2_shp script 
*/
#define mcu_2_shp_ADDR	7237
/*! 
* Following define size of mcu_2_shp script 
*/
#define mcu_2_shp_SIZE	115
 
/*! 
* Following define start address of mcu_interrupt_only script 
*/
#define mcu_interrupt_only_ADDR	7352
/*! 
* Following define size of mcu_interrupt_only script 
*/
#define mcu_interrupt_only_SIZE	2
 
/*! 
* Following define start address of per_2_app script 
*/
#define per_2_app_ADDR	7354
/*! 
* Following define size of per_2_app script 
*/
#define per_2_app_SIZE	119
 
/*! 
* Following define start address of per_2_shp script 
*/
#define per_2_shp_ADDR	7473
/*! 
* Following define size of per_2_shp script 
*/
#define per_2_shp_SIZE	117
 
/*! 
* Following define start address of shp_2_dsp script 
*/
#define shp_2_dsp_ADDR	7590
/*! 
* Following define size of shp_2_dsp script 
*/
#define shp_2_dsp_SIZE	95
 
/*! 
* Following define start address of shp_2_mcu script 
*/
#define shp_2_mcu_ADDR	7685
/*! 
* Following define size of shp_2_mcu script 
*/
#define shp_2_mcu_SIZE	95
 
/*! 
* Following define start address of shp_2_per script 
*/
#define shp_2_per_ADDR	7780
/*! 
* Following define size of shp_2_per script 
*/
#define shp_2_per_SIZE	96
 
/*! 
* Following define start address of uart_2_mcu script 
*/
#define uart_2_mcu_ADDR	7876
/*! 
* Following define size of uart_2_mcu script 
*/
#define uart_2_mcu_SIZE	119
 
/*! 
* Following define start address of uartsh_2_mcu script 
*/
#define uartsh_2_mcu_ADDR	7995
/*! 
* Following define size of uartsh_2_mcu script 
*/
#define uartsh_2_mcu_SIZE	114
 
/*!
* Following define the start address of sdma ram 
*/

#define RAM_CODE_START_ADDR	6144
/*!
* Following define the size of sdma ram
*/
#define RAM_CODE_SIZE	1965

/*!
* This function returns buffer that holds the image of SDMA RAM
*
* @return pointer to buffer that holds the image of SDMA RAM
*/

static const short sdma_code[] =
{
0x0870, 0x0011, 0x5010, 0xc147, 0x7d58, 0x5ac0, 0x5bc8, 0x5ef8,
0xc158, 0x56f8, 0x7d02, 0x0600, 0x9806, 0x6ec3, 0x6d44, 0x5df0,
0x0dff, 0x0511, 0x1dff, 0x05bc, 0x4d00, 0x7d3d, 0x0b70, 0x0311,
0x522b, 0x5313, 0x02b9, 0x4a00, 0x7c05, 0x6a68, 0x624c, 0x7e32,
0x0400, 0x9816, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0, 0x0a03,
0x0212, 0x02bc, 0x0210, 0x4a00, 0x7d14, 0x4a02, 0x7d18, 0x4a01,
0x7d1b, 0x62c8, 0x7e1f, 0x0210, 0x0212, 0x6a49, 0x7f1b, 0x0212,
0x6a49, 0x7f18, 0x0212, 0x6a49, 0x7f15, 0x2003, 0x4800, 0x7cf1,
0x984f, 0x0015, 0x0015, 0x7802, 0x62c8, 0x6a4b, 0x984f, 0x0015,
0x7802, 0x62c8, 0x6a4a, 0x984f, 0x7802, 0x62c8, 0x6a49, 0x7c02,
0x0000, 0x9814, 0xc6d0, 0x6a68, 0x624c, 0x7efc, 0x008b, 0x52c3,
0x53cb, 0xc166, 0x7dab, 0x0600, 0x9806, 0x0600, 0x9803, 0x0870,
0x0011, 0x5010, 0xc0ec, 0x7d58, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe,
0x56f8, 0x7d02, 0x0200, 0x9865, 0x6ec3, 0x6d07, 0x5df0, 0x0dff,
0x0511, 0x1dff, 0x05bc, 0x4d00, 0x7d3d, 0x0b70, 0x0311, 0x522b,
0x5313, 0x02b9, 0x4a00, 0x7c05, 0x6a28, 0x620c, 0x7e32, 0x0400,
0x9875, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0, 0x0a03, 0x0212,
0x02bc, 0x0210, 0x4a00, 0x7d14, 0x4a02, 0x7d18, 0x4a01, 0x7d1b,
0x62c8, 0x7e1f, 0x0210, 0x0212, 0x6a09, 0x7f1b, 0x0212, 0x6a09,
0x7f18, 0x0212, 0x6a09, 0x7f15, 0x2003, 0x4800, 0x7cf1, 0x98ae,
0x0015, 0x0015, 0x7802, 0x62c8, 0x6a0b, 0x98ae, 0x0015, 0x7802,
0x62c8, 0x6a0a, 0x98ae, 0x7802, 0x62c8, 0x6a09, 0x7c02, 0x0000,
0x9873, 0xc6d8, 0x6a28, 0x620c, 0x7efc, 0x008b, 0x52c3, 0x53cb,
0xc10d, 0x7dab, 0x0200, 0x9865, 0x0200, 0x9862, 0x0870, 0x0011,
0x5010, 0xc0ec, 0x7d58, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8,
0x7d02, 0x0200, 0x98c4, 0x6ec3, 0x6dd7, 0x5df0, 0x0dff, 0x0511,
0x1dff, 0x05bc, 0x4d00, 0x7d3e, 0x0b70, 0x0311, 0x522b, 0x5313,
0x02b9, 0x4a00, 0x7c04, 0x62ff, 0x7e34, 0x0400, 0x98d4, 0x008f,
0x00d5, 0x7d01, 0x008d, 0x05a0, 0x0a03, 0x0212, 0x02bc, 0x0210,
0x4a00, 0x7d20, 0x4a02, 0x7d18, 0x4a01, 0x7d11, 0x6ddd, 0x62c8,
0x7e20, 0x0210, 0x0212, 0x6ac8, 0x7f1c, 0x0212, 0x6ac8, 0x7f19,
0x0212, 0x6ac8, 0x7f16, 0x2003, 0x4800, 0x7cf1, 0x990e, 0x6ddd,
0x7802, 0x62c8, 0x6ac8, 0x990e, 0x6dde, 0x0015, 0x7802, 0x62c8,
0x6ac8, 0x990e, 0x0015, 0x0015, 0x7801, 0x62d8, 0x7c02, 0x0000,
0x98d2, 0xc6d4, 0x62ff, 0x7efd, 0x008b, 0x52c3, 0x53cb, 0xc10d,
0x7dab, 0x0200, 0x98c4, 0x0200, 0x98c1, 0x0870, 0x0011, 0x5010,
0xc147, 0x7d70, 0x5ac0, 0x5bc8, 0x5ef8, 0xc158, 0x56f8, 0x7d02,
0x0600, 0x9923, 0x6d40, 0x6ed3, 0x0dff, 0x0511, 0x1dff, 0x05bc,
0x5df8, 0x4d00, 0x7d56, 0x0b70, 0x0311, 0x522b, 0x5313, 0x02b9,
0x4a00, 0x7c04, 0x62ff, 0x7e37, 0x0400, 0x9933, 0x008f, 0x00d5,
0x7d01, 0x008d, 0x05a0, 0x5ddb, 0x0d03, 0x0512, 0x05bc, 0x0510,
0x5dd0, 0x4d00, 0x7d1f, 0x4d02, 0x7d18, 0x4d01, 0x7d12, 0x6249,
0x7e22, 0x6549, 0x7e20, 0x0212, 0x02ad, 0x6549, 0x7e1c, 0x0212,
0x02ad, 0x0212, 0x0210, 0x6ac8, 0x7f16, 0x2003, 0x4800, 0x7cef,
0x996f, 0x7802, 0x6249, 0x6ac8, 0x996f, 0x0015, 0x7802, 0x624a,
0x6ac8, 0x996f, 0x0015, 0x0015, 0x7802, 0x624b, 0x6ac8, 0x7c03,
0x0000, 0x55db, 0x9931, 0x0007, 0x68cc, 0x684c, 0x55d3, 0x4d00,
0x7d03, 0x4d02, 0x7d02, 0x997e, 0x0017, 0x0017, 0x55db, 0x009d,
0x55fb, 0x05a0, 0x08ff, 0x0011, 0x18ff, 0x0010, 0x04b8, 0x04ad,
0x0454, 0x62ff, 0x7ee8, 0x008b, 0x52c0, 0x53c8, 0xc166, 0x7d93,
0x0600, 0x9923, 0x0600, 0x9920, 0xc19d, 0x0870, 0x0011, 0xc147,
0x7d6c, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc158, 0x56f8, 0x7d02,
0x0600, 0x999b, 0x6d40, 0x0d03, 0x0512, 0x05bc, 0x0510, 0x5dd0,
0x0dff, 0x0511, 0x1dff, 0x05bc, 0x5df8, 0x4d00, 0x7d4f, 0x0a70,
0x0211, 0x532a, 0x5212, 0x03b9, 0x4b00, 0x7c02, 0x0400, 0x99af,
0x008f, 0x05d8, 0x7d01, 0x008d, 0x05a0, 0x5dda, 0x55d2, 0x4d00,
0x7d1f, 0x4d02, 0x7d18, 0x4d01, 0x7d12, 0x6349, 0x7e22, 0x6549,
0x7e20, 0x0312, 0x03ad, 0x6549, 0x7e1c, 0x0312, 0x03ad, 0x0312,
0x0310, 0x5b06, 0x7f16, 0x2003, 0x4800, 0x7cef, 0x99e5, 0x7802,
0x6349, 0x5b06, 0x99e5, 0x0015, 0x7802, 0x634a, 0x5b06, 0x99e5,
0x0015, 0x0015, 0x7802, 0x634b, 0x5b06, 0x7c03, 0x55da, 0x0000,
0x99ad, 0x0007, 0x684c, 0x55d2, 0x4d00, 0x7d03, 0x4d02, 0x7d02,
0x99f3, 0x0017, 0x0017, 0x55da, 0x009d, 0x55fa, 0x05a0, 0x08ff,
0x0011, 0x18ff, 0x0010, 0x04b8, 0x04ad, 0x0454, 0x008a, 0x52c0,
0x53c8, 0xc166, 0x7d98, 0x0600, 0x999b, 0x0600, 0x9997, 0x0700,
0x9a07, 0x1e10, 0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d5e, 0x5ac0,
0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9a10, 0x6d07,
0x0b70, 0x0311, 0x0dff, 0x0511, 0x1dff, 0x05bc, 0x4d00, 0x7d4f,
0x6ec3, 0x522b, 0x02b9, 0x4a00, 0x7d2b, 0x62c8, 0x7e6e, 0x0264,
0x7c53, 0x0212, 0x3aff, 0x008a, 0x05d8, 0x7d03, 0x008d, 0x0b01,
0x9a35, 0x0a10, 0x6ed3, 0x6ac8, 0x0b00, 0xda9f, 0x4b00, 0x0b70,
0x0311, 0x7c35, 0x0478, 0x7d27, 0x522b, 0x02b9, 0x4a00, 0x7cde,
0x6a28, 0x620c, 0x7e58, 0x4d00, 0x7c09, 0x5013, 0x52c0, 0x53c8,
0x04a5, 0xc10d, 0x7d01, 0x0201, 0x0400, 0x9a10, 0x0400, 0x9a1e,
0x62c8, 0x7e43, 0x0212, 0x3aff, 0x008a, 0x0b00, 0x00d5, 0x7d05,
0x008d, 0x0a10, 0x6ed3, 0x6ac8, 0x0b01, 0xda9f, 0x4b00, 0x7d03,
0x0b70, 0x0311, 0x9a6f, 0x6a28, 0x620c, 0x7e35, 0x5013, 0x52c0,
0x53c8, 0x04a5, 0xc10d, 0x0200, 0x9a10, 0x0200, 0x9a0d, 0x6a28,
0x620c, 0x7e29, 0x0b70, 0x0311, 0x5013, 0x52c0, 0x53c8, 0x04a5,
0xc10d, 0x7d96, 0x0200, 0x9a10, 0x008f, 0x00d5, 0x7d01, 0x008d,
0xda9f, 0x522b, 0x02b9, 0x4a00, 0x7c99, 0x6a28, 0x620c, 0x7e13,
0x4d00, 0x7c09, 0x5013, 0x52c0, 0x53c8, 0x04a5, 0xc10d, 0x7d01,
0x0201, 0x0400, 0x9a10, 0x0400, 0x9a1e, 0x0007, 0x68cc, 0x6a28,
0x620c, 0x7e01, 0x9a9d, 0x0007, 0x6a0c, 0x0454, 0x9a6f, 0x05a0,
0x1e08, 0x6ec1, 0x0060, 0x7c04, 0x62c8, 0x6a09, 0x7ff4, 0x7eed,
0x0015, 0x0060, 0x7c05, 0x6ece, 0x62c8, 0x6a0a, 0x7fec, 0x7ee5,
0x6ecf, 0x0015, 0x7802, 0x62c8, 0x6a0b, 0x0000, 0x7fe4, 0x7edd,
0x6a28, 0x2608, 0x0006, 0xc0ec, 0x7d61, 0x0e70, 0x0611, 0x5016,
0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x5cd0, 0x7d02, 0x0200,
0x9ac1, 0x078d, 0x1a10, 0x5ad8, 0x6ae7, 0x63c8, 0x7eec, 0x0000,
0x4b00, 0x7dfa, 0x5be0, 0x0000, 0x5ef8, 0xc0fe, 0x56f8, 0x5ce8,
0x7cfa, 0x068f, 0x6ed5, 0x6dc5, 0x08ff, 0x0011, 0x28ff, 0x00bc,
0x0788, 0x0904, 0x00d1, 0x7d18, 0x0904, 0x06a5, 0x3e03, 0x3d03,
0x01a5, 0x3903, 0x0089, 0xdaff, 0x7e16, 0x07a1, 0x008f, 0x4e00,
0x7d01, 0x9afc, 0x6dcf, 0x6edf, 0x0015, 0x0015, 0xdaff, 0x7e0b,
0x3f03, 0x008f, 0x6dcd, 0x6edd, 0xdaff, 0x7e05, 0x9b04, 0x7802,
0x62d8, 0x0000, 0x0006, 0xc6d4, 0x078b, 0x0e70, 0x0611, 0x5016,
0x52d8, 0x53e0, 0x54e8, 0xc10d, 0x7d02, 0x0900, 0x9b10, 0x0901,
0x0e70, 0x0611, 0x5016, 0x52c0, 0x53c8, 0x54d0, 0xc10d, 0x7d01,
0x9b1a, 0x1901, 0x4902, 0x7da5, 0x0200, 0x9ac1, 0x0200, 0x9abb,
0xc147, 0x7d60, 0x0e70, 0x0611, 0x5016, 0x5ac0, 0x5bc8, 0x5ef8,
0xc158, 0x56f8, 0x5cd0, 0x7d02, 0x0600, 0x9b26, 0x078d, 0x1a10,
0x5ad8, 0x6a63, 0x634b, 0x7e33, 0x0000, 0x4b00, 0x7dfa, 0x5be0,
0x0000, 0x5ef8, 0xc158, 0x56f8, 0x038f, 0x5ce8, 0x7cf9, 0x068d,
0x058f, 0x6e44, 0x6d60, 0x08ff, 0x0011, 0x28ff, 0x00bc, 0x0788,
0x0904, 0x00d1, 0x7d16, 0x0f04, 0x06a5, 0x3e03, 0x3d03, 0x07a5,
0x3f03, 0xc23c, 0xdb64, 0x00a7, 0x0788, 0x4e00, 0x7d08, 0x0810,
0x07d8, 0x7c02, 0xc24b, 0xdb64, 0xc264, 0xdb64, 0x9b68, 0xc22e,
0x7f06, 0xc23c, 0xdb64, 0x9b68, 0x7f02, 0x7e01, 0x0006, 0xc6d0,
0x078b, 0x0e70, 0x0611, 0x5016, 0x52d8, 0x53e0, 0x54e8, 0xc166,
0x7d02, 0x0900, 0x9b74, 0x0901, 0x0e70, 0x0611, 0x5016, 0x52c0,
0x53c8, 0x54d0, 0xc166, 0x7d01, 0x9b7e, 0x1901, 0x4902, 0x7da6,
0x0600, 0x9b26, 0x0600, 0x9b20, 0x0870, 0x0011, 0x5010, 0xc0ec,
0x7d70, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200,
0x9b8a, 0x6d03, 0x6ed3, 0x0dff, 0x0511, 0x1dff, 0x05bc, 0x5df8,
0x4d00, 0x7d56, 0x0b70, 0x0311, 0x522b, 0x5313, 0x02b9, 0x4a00,
0x7c04, 0x62ff, 0x7e37, 0x0400, 0x9b9a, 0x008f, 0x00d5, 0x7d01,
0x008d, 0x05a0, 0x5ddb, 0x0d03, 0x0512, 0x05bc, 0x0510, 0x5dd3,
0x4d00, 0x7d1f, 0x4d02, 0x7d18, 0x4d01, 0x7d12, 0x6209, 0x7e22,
0x6509, 0x7e20, 0x0212, 0x02ad, 0x6509, 0x7e1c, 0x0212, 0x02ad,
0x0212, 0x0210, 0x6ac8, 0x7f16, 0x2003, 0x4800, 0x7cef, 0x9bd6,
0x7802, 0x6209, 0x6ac8, 0x9bd6, 0x0015, 0x7802, 0x620a, 0x6ac8,
0x9bd6, 0x0015, 0x0015, 0x7802, 0x620b, 0x6ac8, 0x7c03, 0x0000,
0x55db, 0x9b98, 0x0007, 0x68cc, 0x680c, 0x55d3, 0x4d00, 0x7d03,
0x4d02, 0x7d02, 0x9be5, 0x0017, 0x0017, 0x55db, 0x009d, 0x55fb,
0x05a0, 0x08ff, 0x0011, 0x18ff, 0x0010, 0x04b8, 0x04ad, 0x0454,
0x62ff, 0x7ee8, 0x008b, 0x52c0, 0x53c8, 0xc10d, 0x7d93, 0x0200,
0x9b8a, 0x0200, 0x9b87, 0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d43,
0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9c01,
0x0b70, 0x0311, 0x6ed3, 0x6d03, 0x0dff, 0x0511, 0x1dff, 0x05bc,
0x4d00, 0x7d28, 0x522b, 0x02b9, 0x4a00, 0x7c04, 0x62ff, 0x7e1c,
0x0400, 0x9c12, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0, 0x0060,
0x7c04, 0x6209, 0x6ac8, 0x7f10, 0x7e12, 0x0015, 0x0060, 0x7c04,
0x620a, 0x6ac8, 0x7f09, 0x7e0b, 0x0015, 0x7802, 0x620b, 0x6ac8,
0x0000, 0x7f02, 0x7e04, 0x9c10, 0x0007, 0x68cc, 0x9c39, 0x0007,
0x6a0c, 0x0454, 0x62ff, 0x7ef8, 0x5013, 0x52c0, 0x53c8, 0xc10d,
0x7dc0, 0x0200, 0x9c01, 0x0200, 0x9bfe, 0xc19d, 0x0870, 0x0011,
0xc0ec, 0x7d6c, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8,
0x7d02, 0x0200, 0x9c4c, 0x6d03, 0x0d03, 0x0512, 0x05bc, 0x0510,
0x5dd0, 0x0dff, 0x0511, 0x1dff, 0x05bc, 0x5df8, 0x4d00, 0x7d4f,
0x0a70, 0x0211, 0x532a, 0x5212, 0x03b9, 0x4b00, 0x7c02, 0x0400,
0x9c60, 0x008f, 0x05d8, 0x7d01, 0x008d, 0x05a0, 0x5dda, 0x55d2,
0x4d00, 0x7d1f, 0x4d02, 0x7d18, 0x4d01, 0x7d12, 0x6309, 0x7e22,
0x6509, 0x7e20, 0x0312, 0x03ad, 0x6509, 0x7e1c, 0x0312, 0x03ad,
0x0312, 0x0310, 0x5b06, 0x7f16, 0x2003, 0x4800, 0x7cef, 0x9c96,
0x7802, 0x6309, 0x5b06, 0x9c96, 0x0015, 0x7802, 0x630a, 0x5b06,
0x9c96, 0x0015, 0x0015, 0x7802, 0x630b, 0x5b06, 0x7c03, 0x55da,
0x0000, 0x9c5e, 0x0007, 0x680c, 0x55d2, 0x4d00, 0x7d03, 0x4d02,
0x7d02, 0x9ca4, 0x0017, 0x0017, 0x55da, 0x009d, 0x55fa, 0x05a0,
0x08ff, 0x0011, 0x18ff, 0x0010, 0x04b8, 0x04ad, 0x0454, 0x008a,
0x52c0, 0x53c8, 0xc10d, 0x7d98, 0x0200, 0x9c4c, 0x0200, 0x9c48,
0x0300, 0x9cb8, 0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d70, 0x5ac0,
0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9cc0, 0x6ed3,
0x6dc5, 0x0dff, 0x0511, 0x1dff, 0x05bc, 0x5df8, 0x4d00, 0x7d56,
0x0b70, 0x0311, 0x522b, 0x5313, 0x02b9, 0x4a00, 0x7c04, 0x62ff,
0x7f38, 0x0400, 0x9cd0, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0,
0x5ddb, 0x0d03, 0x0512, 0x05bc, 0x0510, 0x5dd3, 0x4d00, 0x7d20,
0x4d02, 0x7d18, 0x4d01, 0x7d12, 0x62c8, 0x7e23, 0x65c8, 0x7e21,
0x0212, 0x02ad, 0x65c8, 0x7e1d, 0x0212, 0x02ad, 0x0212, 0x0210,
0x6ac8, 0x7f17, 0x2003, 0x4800, 0x7cef, 0x9d0d, 0x7802, 0x62c8,
0x6ac8, 0x9d0d, 0x6dce, 0x0015, 0x7802, 0x62c8, 0x6ac8, 0x9d0d,
0x6dcf, 0x0015, 0x0015, 0x7801, 0x62d8, 0x7c03, 0x0000, 0x55db,
0x9cce, 0x0007, 0x68ff, 0x55d3, 0x4d00, 0x7d03, 0x4d02, 0x7d02,
0x9d1b, 0x0017, 0x0017, 0x55db, 0x009d, 0x55fb, 0x05a0, 0x08ff,
0x0011, 0x18ff, 0x0010, 0x04b8, 0x04ad, 0x0454, 0x62ff, 0x7fe9,
0x008b, 0x52c3, 0x53cb, 0xc10d, 0x7d93, 0x0200, 0x9cc0, 0x0200,
0x9cbd, 0xc19d, 0x0870, 0x0011, 0xc0ec, 0x7d6e, 0x5010, 0x5ac0,
0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9d38, 0x6dc5,
0x0d03, 0x0512, 0x05bc, 0x0510, 0x5dd0, 0x0dff, 0x0511, 0x1dff,
0x05bc, 0x5df8, 0x4d00, 0x7d51, 0x0a70, 0x0211, 0x532a, 0x5212,
0x03b9, 0x4b00, 0x7c02, 0x0400, 0x9d4c, 0x008f, 0x05d8, 0x7d01,
0x008d, 0x05a0, 0x5dda, 0x55d2, 0x4d00, 0x7d20, 0x4d02, 0x7d18,
0x4d01, 0x7d12, 0x63c8, 0x7e24, 0x65c8, 0x7e22, 0x0312, 0x03ad,
0x65c8, 0x7e1e, 0x0312, 0x03ad, 0x0312, 0x0310, 0x5b06, 0x7f18,
0x2003, 0x4800, 0x7cef, 0x9d84, 0x7802, 0x63c8, 0x5b06, 0x9d84,
0x6dce, 0x0015, 0x7802, 0x63c8, 0x5b06, 0x9d84, 0x6dcf, 0x0015,
0x0015, 0x7802, 0x63c8, 0x5b06, 0x7c03, 0x55da, 0x0000, 0x9d4a,
0x0007, 0x68ff, 0x55d2, 0x4d00, 0x7d03, 0x4d02, 0x7d02, 0x9d92,
0x0017, 0x0017, 0x55da, 0x009d, 0x55fa, 0x05a0, 0x08ff, 0x0011,
0x18ff, 0x0010, 0x04b8, 0x04ad, 0x0454, 0x008a, 0x52c0, 0x53c8,
0xc10d, 0x7d96, 0x0200, 0x9d38, 0x0200, 0x9d34, 0xc19d, 0x0870,
0x0011, 0xc147, 0x7d58, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc158,
0x56f8, 0x7d02, 0x0600, 0x9dad, 0x6d44, 0x5df0, 0x0dff, 0x0511,
0x1dff, 0x05bc, 0x4d00, 0x7d3d, 0x0a70, 0x0211, 0x532a, 0x5212,
0x03b9, 0x4b00, 0x7c05, 0x6968, 0x634c, 0x7e32, 0x0400, 0x9dbc,
0x008f, 0x05d8, 0x7d01, 0x008d, 0x05a0, 0x0b03, 0x0312, 0x03bc,
0x0310, 0x4b00, 0x7d14, 0x4b02, 0x7d18, 0x4b01, 0x7d1b, 0x5306,
0x7e1f, 0x0310, 0x0312, 0x6b49, 0x7f1b, 0x0312, 0x6b49, 0x7f18,
0x0312, 0x6b49, 0x7f15, 0x2003, 0x4800, 0x7cf1, 0x9df5, 0x0015,
0x0015, 0x7802, 0x5306, 0x6b4b, 0x9df5, 0x0015, 0x7802, 0x5306,
0x6b4a, 0x9df5, 0x7802, 0x5306, 0x6b49, 0x7c02, 0x0000, 0x9dba,
0xc6d0, 0x6968, 0x634c, 0x7efc, 0x008a, 0x52c0, 0x53c8, 0xc166,
0x7dac, 0x0600, 0x9dad, 0x0600, 0x9da9, 0xc19d, 0x0870, 0x0011,
0xc0ec, 0x7d58, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8,
0x7d02, 0x0200, 0x9e0c, 0x6d07, 0x5df0, 0x0dff, 0x0511, 0x1dff,
0x05bc, 0x4d00, 0x7d3d, 0x0a70, 0x0211, 0x532a, 0x5212, 0x03b9,
0x4b00, 0x7c05, 0x6a28, 0x630c, 0x7e32, 0x0400, 0x9e1b, 0x008f,
0x05d8, 0x7d01, 0x008d, 0x05a0, 0x0b03, 0x0312, 0x03bc, 0x0310,
0x4b00, 0x7d14, 0x4b02, 0x7d18, 0x4b01, 0x7d1b, 0x5306, 0x7e1f,
0x0310, 0x0312, 0x6b09, 0x7f1b, 0x0312, 0x6b09, 0x7f18, 0x0312,
0x6b09, 0x7f15, 0x2003, 0x4800, 0x7cf1, 0x9e54, 0x0015, 0x0015,
0x7802, 0x5306, 0x6b0b, 0x9e54, 0x0015, 0x7802, 0x5306, 0x6b0a,
0x9e54, 0x7802, 0x5306, 0x6b09, 0x7c02, 0x0000, 0x9e19, 0xc6d8,
0x6928, 0x630c, 0x7efc, 0x008a, 0x52c0, 0x53c8, 0xc10d, 0x7dac,
0x0200, 0x9e0c, 0x0200, 0x9e08, 0xc19d, 0x0870, 0x0011, 0xc0ec,
0x7d59, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02,
0x0200, 0x9e6b, 0x6dd7, 0x5df0, 0x0dff, 0x0511, 0x1dff, 0x05bc,
0x4d00, 0x7d3f, 0x0a70, 0x0211, 0x532a, 0x5212, 0x03b9, 0x4b00,
0x7c04, 0x63ff, 0x7e35, 0x0400, 0x9e7a, 0x008f, 0x05d8, 0x7d01,
0x008d, 0x05a0, 0x0b03, 0x0312, 0x03bc, 0x0310, 0x4b00, 0x7d20,
0x4b02, 0x7d18, 0x4b01, 0x7d11, 0x6ddd, 0x5306, 0x7e21, 0x0310,
0x0312, 0x6bc8, 0x7f1d, 0x0312, 0x6bc8, 0x7f1a, 0x0312, 0x6bc8,
0x7f17, 0x2003, 0x4800, 0x7cf1, 0x9eb5, 0x6ddd, 0x7802, 0x5306,
0x6bc8, 0x9eb5, 0x6dde, 0x0015, 0x7802, 0x5306, 0x6bc8, 0x9eb5,
0x0015, 0x0015, 0x7802, 0x5306, 0x6bc8, 0x7c02, 0x0000, 0x9e78,
0xc6d4, 0x63ff, 0x7efd, 0x008a, 0x52c0, 0x53c8, 0xc10d, 0x7dab,
0x0200, 0x9e6b, 0x0200, 0x9e67, 0x0870, 0x0011, 0x5010, 0xc0ec,
0x7d5b, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200,
0x9eca, 0x0b70, 0x0311, 0x6ec3, 0x6d07, 0x5df0, 0x0dff, 0x0511,
0x1dff, 0x05bc, 0x4d00, 0x7d3c, 0x522b, 0x02b9, 0x4a00, 0x7c05,
0x6a28, 0x620c, 0x7e31, 0x0400, 0x9edc, 0x028e, 0x1a94, 0x6ac3,
0x62c8, 0x0269, 0x7d19, 0x1e94, 0x6ec3, 0x6ed3, 0x62c8, 0x0248,
0x6ac8, 0x2694, 0x6ec3, 0x62c8, 0x026e, 0x7d30, 0x6a09, 0x7f1c,
0x2501, 0x4d00, 0x7d1d, 0x028e, 0x1a98, 0x6ac3, 0x62c8, 0x6ec3,
0x0260, 0x7df1, 0xdf28, 0x9f1b, 0x6ee3, 0x008f, 0x2001, 0x00d5,
0x7d01, 0x008d, 0x05a0, 0x62c8, 0x026e, 0x7d18, 0x6a09, 0x7f04,
0x2001, 0x7cf9, 0x0000, 0x9eda, 0x0007, 0x6a0c, 0xdf2b, 0x9f38,
0x6a28, 0x620c, 0x7ef9, 0x0b70, 0x0311, 0x5013, 0x52c0, 0x53c8,
0xc10d, 0x7da8, 0x0200, 0x9eca, 0x0200, 0x9ec7, 0xdf28, 0x9f38,
0x6a28, 0x620c, 0x7ee9, 0x6207, 0x0b70, 0x0311, 0x5013, 0x55f0,
0x02a5, 0x0bff, 0x0312, 0x1bff, 0x0312, 0x04bb, 0x049a, 0x0006,
0x0458, 0x0454, 0x9f1b, 0xc19d, 0x0870, 0x0011, 0xc0ec, 0x7d54,
0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200,
0x9f42, 0x0a70, 0x0211, 0x6d07, 0x5df0, 0x0dff, 0x0511, 0x1dff,
0x05bc, 0x4d00, 0x7d35, 0x532a, 0x03b9, 0x4b00, 0x7c05, 0x6928,
0x630c, 0x7e2a, 0x0400, 0x9f53, 0x038e, 0x1b94, 0x5303, 0x0369,
0x7d14, 0x1e94, 0x5306, 0x0348, 0x5b06, 0x2694, 0x5306, 0x036e,
0x7d2d, 0x6b09, 0x7f19, 0x2501, 0x4d00, 0x7d1a, 0x038e, 0x1b98,
0x5303, 0x0360, 0x7df3, 0xdf98, 0x9f8b, 0x008f, 0x2001, 0x00d5,
0x7d01, 0x008d, 0x05a0, 0x5306, 0x036e, 0x7d18, 0x6b09, 0x7f04,
0x2001, 0x7cf9, 0x0000, 0x9f51, 0x0007, 0x6b0c, 0xdf9b, 0x9faa,
0x6928, 0x630c, 0x7ef9, 0x0a70, 0x0211, 0x5012, 0x52c0, 0x53c8,
0xc10d, 0x7db0, 0x0200, 0x9f42, 0x0200, 0x9f3e, 0xdf98, 0x9faa,
0x6b28, 0x630c, 0x7ee9, 0x6307, 0x0a70, 0x0211, 0x5012, 0x55f0,
0x03a5, 0x0aff, 0x0212, 0x1aff, 0x0212, 0x04ba, 0x049b, 0x0a70,
0x0211, 0x0006, 0x0458, 0x0454, 0x9f8b, 0x9f8b
};
#endif
