/*
 *  File Name       : linux/include/asm-arm/arch-mp200/gio.h
 *  Function        : gpio
 *  Release Version : Ver 1.00
 *  Release Date    : 2006/04/28
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_GIO_H
#define __ASM_ARM_ARCH_MP200_GIO_H

#include <linux/spinlock.h>

#include <asm/arch/hardware.h>
#include <asm/io.h>

#ifdef CONFIG_MP201
#define GPIO0_EO	0x0000	/* set output */
#define GPIO0_EI	0x0004	/* set input */
#define GPIO0_DO	0x0008	/* data output */
#define GPIO0_DI	0x000C	/* data intput */
#define GPIO0_IA	0x0010	/* interrupt active */
#define GPIO0_IMN	0x0014	/* interrupt unmask */
#define GPIO0_IME	0x0018	/* interrupt mask */
#define GPIO0_RAW	0x001C	/* interrupt raw status */
#define GPIO0_MST	0x0020	/* interrupt status */
#define GPIO0_IR	0x0024	/* interrupt status reset */
#define GPIO0_ISC	0x0028	/* interrupt status connect */
#define GPIO0_IDTL	0x002C	/* interrupt detect control ( 0- 7) */
#define GPIO0_IDTH	0x0030	/* interrupt detect control ( 8-15) */

#define GPIO1_EO	0x0100	/* set output */
#define GPIO1_EI	0x0104	/* set input */
#define GPIO1_DO	0x0108	/* data output */
#define GPIO1_DI	0x010C	/* data intput */
#define GPIO1_IA	0x0110	/* interrupt active */
#define GPIO1_IMN	0x0114	/* interrupt unmask */
#define GPIO1_IME	0x0118	/* interrupt mask */
#define GPIO1_RAW	0x011C	/* interrupt raw status */
#define GPIO1_MST	0x0120	/* interrupt status */
#define GPIO1_IR	0x0124	/* interrupt status reset */
#define GPIO1_ISC	0x0128	/* interrupt status connect */
#define GPIO1_IDTL	0x012C	/* interrupt detect control (16-23) */
#define GPIO1_IDTH	0x0130	/* interrupt detect control (24-31) */

#define GPIO2_EO	0x0200	/* set output */
#define GPIO2_EI	0x0204	/* set input */
#define GPIO2_DO	0x0208	/* data output */
#define GPIO2_DI	0x020C	/* data intput */
#define GPIO2_IA	0x0210	/* interrupt active */
#define GPIO2_IMN	0x0214	/* interrupt unmask */
#define GPIO2_IME	0x0218	/* interrupt mask */
#define GPIO2_RAW	0x021C	/* interrupt raw status */
#define GPIO2_MST	0x0220	/* interrupt status */
#define GPIO2_IR	0x0224	/* interrupt status reset */
#define GPIO2_ISC	0x0228	/* interrupt status connect */
#define GPIO2_IDTL	0x022C	/* interrupt detect control (32-39) */
#define GPIO2_IDTH	0x0230	/* interrupt detect control (40-47) */

#define GPIO3_EO	0x0300	/* set output */
#define GPIO3_EI	0x0304	/* set input */
#define GPIO3_DO	0x0308	/* data output */
#define GPIO3_DI	0x030C	/* data intput */
#define GPIO3_IA	0x0310	/* interrupt active */
#define GPIO3_IMN	0x0314	/* interrupt unmask */
#define GPIO3_IME	0x0318	/* interrupt mask */
#define GPIO3_RAW	0x031C	/* interrupt raw status */
#define GPIO3_MST	0x0320	/* interrupt status */
#define GPIO3_IR	0x0324	/* interrupt status reset */
#define GPIO3_ISC	0x0328	/* interrupt status connect */
#define GPIO3_IDTL	0x032C	/* interrupt detect control (48-55) */
#define GPIO3_IDTH	0x0330	/* interrupt detect control (56-63) */
#else
#define GP_E1L		0x0000	/* set output */
#define GP_E0L		0x0004	/* set input */
#define GP_EML		0x0004	/* in/out setting monitor */
#define GP_OLL		0x0008	/* data output( 0-15) */
#define GP_OHL		0x000C	/* data output(16-31) */
#define GPIO_IL		0x0010	/* data intput */
#define GP_IIAL		0x0014	/* enable interrupt */
#define GP_IENL		0x0018	/* interrupt unmask */
#define GP_IDSL		0x001C	/* interrupt mask */
#define GP_IIML		0x001C	/* interrupt mask status */
#define GP_RAWL		0x0020	/* interrupt raw status */
#define GP_MSTL		0x0024	/* interrupt masked status */
#define GP_IIRL		0x0028	/* interrupt status reset */
#define GP_DT1L		0x002C	/* interrupt detect control ( 0-15) */
#define GP_DT2L		0x0030	/* interrupt detect control (16-31) */
#define GP_GSWL		0x003C	/* set INT_FIQ */
#define GIO_PLSL	0x0080	/* set 32KHz Synchronous/Asynchronous mode */

#define GP_E1H		0x0040	/* set output */
#define GP_E0H		0x0044	/* set input */
#define GP_EMH		0x0044	/* in/out setting monitor */
#define GP_OLH		0x0048	/* data output(32-47) */
#define GP_OHH		0x004C	/* data output(48-63) */
#define GPIO_IH		0x0050	/* data intput */
#define GP_IIAH		0x0054	/* enable interrupt */
#define GP_IENH		0x0058	/* interrupt unmask */
#define GP_IDSH		0x005C	/* interrupt mask */
#define GP_IIMH		0x005C	/* interrupt mask status */
#define GP_RAWH		0x0060	/* interrupt raw status */
#define GP_MSTH		0x0064	/* interrupt masked status */
#define GP_IIRH		0x0068	/* interrupt status reset */
#define GP_DT1H		0x006C	/* interrupt detect control (32-47) */
#define GP_DT2H		0x0070	/* interrupt detect control (48-63) */
#define GP_GSWH		0x007C	/* set INT_FIQ */
#define GIO_PLSH	0x0084	/* set 32KHz Synchronous/Asynchronous mode */
#endif				/* CONFIG_MP201 */

extern spinlock_t mp200_gio_lock;

/*
 *   X -- any indicates
 *   F -- local lock flags
 */
#define MP200_GIO_SPINLOCK(X,F)		spin_lock_irqsave(&mp200_gio_lock, F)
#define MP200_GIO_SPINUNLOCK(X,F)	spin_unlock_irqrestore(&mp200_gio_lock, F)

#define VA_GIO		IO_ADDRESS(MP200_GPIO_BASE)

static inline void mp200_gio_set_mode_input_low32(uint32_t inputs)
{
#ifdef CONFIG_MP201
	uint32_t bit31_16, bit15_0;

	bit31_16 = (inputs >> 16) & 0xffffU;
	bit15_0 = inputs & 0xffffU;

	if (bit31_16 != 0) {
		__raw_writel(bit31_16, (VA_GIO + GPIO1_EI));
	}
	if (bit15_0 != 0) {
		__raw_writel(bit15_0, (VA_GIO + GPIO0_EI));
	}
#else
	__raw_writel(inputs, (VA_GIO + GP_E0L));
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_set_mode_input_high32(uint32_t inputs)
{
#ifdef CONFIG_MP201
	uint32_t bit31_16, bit15_0;

	bit31_16 = (inputs >> 16) & 0xffffU;
	bit15_0 = inputs & 0xffffU;

	if (bit31_16 != 0) {
		__raw_writel(bit31_16, (VA_GIO + GPIO3_EI));
	}
	if (bit15_0 != 0) {
		__raw_writel(bit15_0, (VA_GIO + GPIO2_EI));
	}
#else
	__raw_writel(inputs, (VA_GIO + GP_E0H));
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_set_mode_input(uint64_t inputs)
{
#ifdef CONFIG_MP201
	uint32_t bit63_48, bit47_32, bit31_16, bit15_0;

	bit63_48 = (uint32_t) ((inputs >> 48) & 0xffffULL);
	bit47_32 = (uint32_t) ((inputs >> 32) & 0xffffULL);
	bit31_16 = (uint32_t) ((inputs >> 16) & 0xffffULL);
	bit15_0 = (uint32_t) (inputs & 0xffffULL);

	if (bit63_48 != 0) {
		__raw_writel(bit63_48, (VA_GIO + GPIO3_EI));
	}
	if (bit47_32 != 0) {
		__raw_writel(bit47_32, (VA_GIO + GPIO2_EI));
	}
	if (bit31_16 != 0) {
		__raw_writel(bit31_16, (VA_GIO + GPIO1_EI));
	}
	if (bit15_0 != 0) {
		__raw_writel(bit15_0, (VA_GIO + GPIO0_EI));
	}
#else
	uint32_t high, low;

	high = (uint32_t) ((inputs >> 32) & 0xffffffffULL);
	low = (uint32_t) (inputs & 0xffffffffULL);

	if (high != 0) {
		__raw_writel(high, (VA_GIO + GP_E0H));
	}
	if (low != 0) {
		__raw_writel(low, (VA_GIO + GP_E0L));
	}
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_set_mode_output_low32(uint32_t outputs)
{
#ifdef CONFIG_MP201
	uint32_t bit31_16, bit15_0;

	bit31_16 = (outputs >> 16) & 0xffffU;
	bit15_0 = outputs & 0xffffU;

	if (bit31_16 != 0) {
		__raw_writel(bit31_16, (VA_GIO + GPIO1_EO));
	}
	if (bit15_0 != 0) {
		__raw_writel(bit15_0, (VA_GIO + GPIO0_EO));
	}
#else
	__raw_writel(outputs, (VA_GIO + GP_E1L));
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_set_mode_output_high32(uint32_t outputs)
{
#ifdef CONFIG_MP201
	uint32_t bit31_16, bit15_0;

	bit31_16 = (outputs >> 16) & 0xffffU;
	bit15_0 = outputs & 0xffffU;

	if (bit31_16 != 0) {
		__raw_writel(bit31_16, (VA_GIO + GPIO3_EO));
	}
	if (bit15_0 != 0) {
		__raw_writel(bit15_0, (VA_GIO + GPIO2_EO));
	}
#else
	__raw_writel(outputs, (VA_GIO + GP_E1H));
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_set_mode_output(uint64_t outputs)
{
#ifdef CONFIG_MP201
	uint32_t bit63_48, bit47_32, bit31_16, bit15_0;

	bit63_48 = (uint32_t) ((outputs >> 48) & 0xffffULL);
	bit47_32 = (uint32_t) ((outputs >> 32) & 0xffffULL);
	bit31_16 = (uint32_t) ((outputs >> 16) & 0xffffULL);
	bit15_0 = (uint32_t) (outputs & 0xffffULL);

	if (bit63_48 != 0) {
		__raw_writel(bit63_48, (VA_GIO + GPIO3_EO));
	}
	if (bit47_32 != 0) {
		__raw_writel(bit47_32, (VA_GIO + GPIO2_EO));
	}
	if (bit31_16 != 0) {
		__raw_writel(bit31_16, (VA_GIO + GPIO1_EO));
	}
	if (bit15_0 != 0) {
		__raw_writel(bit15_0, (VA_GIO + GPIO0_EO));
	}
#else
	uint32_t high, low;

	high = (uint32_t) ((outputs >> 32) & 0xffffffffULL);
	low = (uint32_t) (outputs & 0xffffffffULL);

	if (high != 0) {
		__raw_writel(high, (VA_GIO + GP_E1H));
	}
	if (low != 0) {
		__raw_writel(low, (VA_GIO + GP_E1L));
	}
#endif				/* CONFIG_MP201 */
}

static inline uint64_t mp200_gio_get_mode(void)
{
#ifdef CONFIG_MP201
	uint32_t bit63_48, bit47_32, bit31_16, bit15_0;

	bit63_48 = __raw_readl(VA_GIO + GPIO3_EO) & 0xffffU;
	bit47_32 = __raw_readl(VA_GIO + GPIO2_EO) & 0xffffU;
	bit31_16 = __raw_readl(VA_GIO + GPIO1_EO) & 0xffffU;
	bit15_0 = __raw_readl(VA_GIO + GPIO0_EO) & 0xffffU;

	return ((uint64_t) bit63_48 << 48) | ((uint64_t) bit47_32 << 32) |
	    ((uint64_t) bit31_16 << 16) | (uint64_t) bit15_0;
#else
	uint32_t high, low;

	high = __raw_readl(VA_GIO + GP_EMH);
	low = __raw_readl(VA_GIO + GP_EML);

	return ((uint64_t) high << 32) | (uint64_t) low;
#endif				/* CONFIG_MP201 */
}

static inline uint32_t mp200_gio_read_inputs_low32(void)
{
#ifdef CONFIG_MP201
	uint32_t bit31_16, bit15_0;

	bit31_16 = __raw_readl(VA_GIO + GPIO1_DI) & 0xffffU;
	bit15_0 = __raw_readl(VA_GIO + GPIO0_DI) & 0xffffU;

	return (bit31_16 << 16) | bit15_0;
#else
	return __raw_readl(VA_GIO + GPIO_IL);
#endif				/* CONFIG_MP201 */
}

static inline uint32_t mp200_gio_read_inputs_high32(void)
{
#ifdef CONFIG_MP201
	uint32_t bit31_16, bit15_0;

	bit31_16 = __raw_readl(VA_GIO + GPIO3_DI) & 0xffffU;
	bit15_0 = __raw_readl(VA_GIO + GPIO2_DI) & 0xffffU;

	return (bit31_16 << 16) | bit15_0;
#else
	return __raw_readl(VA_GIO + GPIO_IH);
#endif				/* CONFIG_MP201 */
}

static inline uint64_t mp200_gio_read_inputs(void)
{
#ifdef CONFIG_MP201
	uint32_t bit63_48, bit47_32, bit31_16, bit15_0;

	bit63_48 = __raw_readl(VA_GIO + GPIO3_DI) & 0xffffU;
	bit47_32 = __raw_readl(VA_GIO + GPIO2_DI) & 0xffffU;
	bit31_16 = __raw_readl(VA_GIO + GPIO1_DI) & 0xffffU;
	bit15_0 = __raw_readl(VA_GIO + GPIO0_DI) & 0xffffU;

	return ((uint64_t) bit63_48 << 48) | ((uint64_t) bit47_32 << 32) |
	    ((uint64_t) bit31_16 << 16) | (uint64_t) bit15_0;
#else
	uint32_t high, low;

	high = __raw_readl(VA_GIO + GPIO_IH);
	low = __raw_readl(VA_GIO + GPIO_IL);

	return ((uint64_t) high << 32) | (uint64_t) low;
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_write_outputs_low32(uint32_t mask, uint32_t val)
{
	uint32_t goe, gos;

#ifdef CONFIG_MP201
	if ((mask & 0xffffU) != 0) {
		goe = (mask & 0xffffU) << 16;
		gos = val & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GPIO0_DO));
	}
	if (((mask >> 16) & 0xffffU) != 0) {
		goe = mask & 0xffff0000U;
		gos = (val >> 16) & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GPIO1_DO));
	}
#else
	if ((mask & 0xffffU) != 0) {
		/* OLL */
		goe = (mask & 0xffffU) << 16;
		gos = val & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GP_OLL));
	}
	if (((mask >> 16) & 0xffffU) != 0) {
		/* OHL */
		goe = mask & 0xffff0000U;
		gos = (val >> 16) & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GP_OHL));
	}
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_write_outputs_high32(uint32_t mask, uint32_t val)
{
	uint32_t goe, gos;

#ifdef CONFIG_MP201
	if ((mask & 0xffffU) != 0) {
		goe = (mask & 0xffffU) << 16;
		gos = val & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GPIO2_DO));
	}
	if (((mask >> 16) & 0xffffU) != 0) {
		goe = mask & 0xffff0000U;
		gos = (val >> 16) & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GPIO3_DO));
	}
#else
	if ((mask & 0xffffU) != 0) {
		/* OLH */
		goe = (mask & 0xffffU) << 16;
		gos = val & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GP_OLH));
	}
	if (((mask >> 16) & 0xffffU) != 0) {
		/* OHH */
		goe = mask & 0xffff0000U;
		gos = (val >> 16) & 0xffffU;
		__raw_writel((goe | gos), (VA_GIO + GP_OHH));
	}
#endif				/* CONFIG_MP201 */
}

static inline void mp200_gio_write_outputs(uint64_t mask, uint64_t val)
{
	uint32_t goe, gos;

#ifdef CONFIG_MP201
	if ((mask & 0xffffULL) != 0) {
		goe = (uint32_t) ((mask & 0xffffULL) << 16);
		gos = (uint32_t) (val & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GPIO0_DO));
	}
	if (((mask >> 16) & 0xffffULL) != 0) {
		goe = (uint32_t) (mask & 0xffff0000ULL);
		gos = (uint32_t) ((val >> 16) & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GPIO1_DO));
	}
	if (((mask >> 32) & 0xffffULL) != 0) {
		goe = (uint32_t) ((mask >> 16) & 0xffff0000ULL);
		gos = (uint32_t) ((val >> 32) & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GPIO2_DO));
	}
	if (((mask >> 48) & 0xffffULL) != 0) {
		goe = (uint32_t) ((mask >> 32) & 0xffff0000ULL);
		gos = (uint32_t) ((val >> 48) & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GPIO3_DO));
	}
#else
	if ((mask & 0xffffULL) != 0) {
		/* OLL */
		goe = (uint32_t) ((mask & 0xffffULL) << 16);
		gos = (uint32_t) (val & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GP_OLL));
	}
	if (((mask >> 16) & 0xffffULL) != 0) {
		/* OHL */
		goe = (uint32_t) (mask & 0xffff0000ULL);
		gos = (uint32_t) ((val >> 16) & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GP_OHL));
	}
	if (((mask >> 32) & 0xffffULL) != 0) {
		/* OLH */
		goe = (uint32_t) ((mask >> 16) & 0xffff0000ULL);
		gos = (uint32_t) ((val >> 32) & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GP_OLH));
	}
	if (((mask >> 48) & 0xffffULL) != 0) {
		/* OHH */
		goe = (uint32_t) ((mask >> 32) & 0xffff0000ULL);
		gos = (uint32_t) ((val >> 48) & 0xffffULL);
		__raw_writel((goe | gos), (VA_GIO + GP_OHH));
	}
#endif				/* CONFIG_MP201 */
}

static inline uint32_t mp200_gio_read_outputs_low32(void)
{
	uint32_t high, low;

#ifdef CONFIG_MP201
	high = __raw_readl(VA_GIO + GPIO1_DO);
	low = __raw_readl(VA_GIO + GPIO0_DO);
#else
	high = __raw_readl(VA_GIO + GP_OHL);
	low = __raw_readl(VA_GIO + GP_OLL);
#endif				/* CONFIG_MP201 */

	return (high << 16) | (low & 0xffffU);
}

static inline uint32_t mp200_gio_read_outputs_high32(void)
{
	uint32_t high, low;

#ifdef CONFIG_MP201
	high = __raw_readl(VA_GIO + GPIO3_DO);
	low = __raw_readl(VA_GIO + GPIO2_DO);
#else
	high = __raw_readl(VA_GIO + GP_OHH);
	low = __raw_readl(VA_GIO + GP_OLH);
#endif				/* CONFIG_MP201 */

	return (high << 16) | (low & 0xffffU);
}

static inline uint64_t mp200_gio_read_outputs(void)
{
	uint32_t high, low;

	low = mp200_gio_read_outputs_low32();
	high = mp200_gio_read_outputs_high32();
	return ((uint64_t) high << 32) | (uint64_t) low;
}

#endif				/* __ASM_ARM_ARCH_MP200_GIO_H */
