/*
 *  File Name       : linux/include/asm-arm/arch-mp200/gpiocore.h
 *  Function        : gpiocore
 *  Release Version : Ver 1.01
 *  Release Date    : 2006/07/27
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_GPIOCORE_H
#define __ASM_ARM_ARCH_MP200_GPIOCORE_H

#include <asm/arch/gio.h>
#include <asm/arch/pwc.h>

/* GPIO port */
#define GPIOCORE_GPIO_P0		0x00
#define GPIOCORE_GPIO_P1		0x01
#define GPIOCORE_GPIO_P2		0x02
#define GPIOCORE_GPIO_P3		0x03
#define GPIOCORE_GPIO_P4		0x04
#define GPIOCORE_GPIO_P5		0x05
#define GPIOCORE_GPIO_P6		0x06
#define GPIOCORE_GPIO_P7		0x07
#define GPIOCORE_GPIO_P8		0x08
#define GPIOCORE_GPIO_P9		0x09
#define GPIOCORE_GPIO_P10		0x0a
#define GPIOCORE_GPIO_P11		0x0b
#define GPIOCORE_GPIO_P12		0x0c
#define GPIOCORE_GPIO_P13		0x0d
#define GPIOCORE_GPIO_P14		0x0e
#define GPIOCORE_GPIO_P15		0x0f
#define GPIOCORE_GPIO_P16		0x10
#define GPIOCORE_GPIO_P17		0x11
#define GPIOCORE_GPIO_P18		0x12
#define GPIOCORE_GPIO_P19		0x13
#define GPIOCORE_GPIO_P20		0x14
#define GPIOCORE_GPIO_P21		0x15
#define GPIOCORE_GPIO_P22		0x16
#define GPIOCORE_GPIO_P23		0x17
#define GPIOCORE_GPIO_P24		0x18
#define GPIOCORE_GPIO_P25		0x19
#define GPIOCORE_GPIO_P26		0x1a
#define GPIOCORE_GPIO_P27		0x1b
#define GPIOCORE_GPIO_P28		0x1c
#define GPIOCORE_GPIO_P29		0x1d
#define GPIOCORE_GPIO_P30		0x1e
#define GPIOCORE_GPIO_P31		0x1f
#define GPIOCORE_GPIO_P32		0x20
#define GPIOCORE_GPIO_P33		0x21
#define GPIOCORE_GPIO_P34		0x22
#define GPIOCORE_GPIO_P35		0x23
#define GPIOCORE_GPIO_P36		0x24
#define GPIOCORE_GPIO_P37		0x25
#define GPIOCORE_GPIO_P38		0x26
#define GPIOCORE_GPIO_P39		0x27
#define GPIOCORE_GPIO_P40		0x28
#define GPIOCORE_GPIO_P41		0x29
#define GPIOCORE_GPIO_P42		0x2a
#define GPIOCORE_GPIO_P43		0x2b
#define GPIOCORE_GPIO_P44		0x2c
#define GPIOCORE_GPIO_P45		0x2d
#define GPIOCORE_GPIO_P46		0x2e
#define GPIOCORE_GPIO_P47		0x2f
#define GPIOCORE_GPIO_P48		0x30
#define GPIOCORE_GPIO_P49		0x31
#define GPIOCORE_GPIO_P50		0x32
#define GPIOCORE_GPIO_P51		0x33
#define GPIOCORE_GPIO_P52		0x34
#define GPIOCORE_GPIO_P53		0x35
#define GPIOCORE_GPIO_P54		0x36
#define GPIOCORE_GPIO_P55		0x37
#define GPIOCORE_GPIO_P56		0x38
#define GPIOCORE_GPIO_P57		0x39
#define GPIOCORE_GPIO_P58		0x3a
#define GPIOCORE_GPIO_P59		0x3b
#define GPIOCORE_GPIO_P60		0x3c
#define GPIOCORE_GPIO_P61		0x3d
#define GPIOCORE_GPIO_P62		0x3e
#define GPIOCORE_GPIO_P63		0x3f

/* kind of GPIO port */
#ifdef CONFIG_MP201
#define GPIOCORE_GPIO_INTOUT		GPIOCORE_GPIO_P0	/* <I> */
#define GPIOCORE_GPIO_ETHER_INT		GPIOCORE_GPIO_P2	/* <I> */
#define GPIOCORE_GPIO_TS_INT		GPIOCORE_GPIO_P3	/* <I> */
#define GPIOCORE_GPIO_EXT_INT		GPIOCORE_GPIO_P6	/* <I> */
#define GPIOCORE_GPIO_PWM1		GPIOCORE_GPIO_P7	/* <O> */
#define GPIOCORE_GPIO_PWM0		GPIOCORE_GPIO_P8	/* <O> */
#define GPIOCORE_GPIO_NAND_RBZ1		GPIOCORE_GPIO_P37	/* <O> */
#else
#define GPIOCORE_GPIO_PDCOMB2		GPIOCORE_GPIO_P0	/* <O> */
#define GPIOCORE_GPIO_SNDPDN		GPIOCORE_GPIO_P1	/* <O> */
#define GPIOCORE_GPIO_ETHER_RST		GPIOCORE_GPIO_P2	/* <O> */
#define GPIOCORE_GPIO_LCD_RSTZ		GPIOCORE_GPIO_P3	/* <O> */
#define GPIOCORE_GPIO_LCD_POWCNT	GPIOCORE_GPIO_P4	/* <O> */
#define GPIOCORE_GPIO_LCD_BL		GPIOCORE_GPIO_P5	/* <O> */
#define GPIOCORE_GPIO_MOD0_CDZ		GPIOCORE_GPIO_P6	/* <I> */
#define GPIOCORE_GPIO_MOD0_WPZ		GPIOCORE_GPIO_P7	/* <I> */
#define GPIOCORE_GPIO_CAM_RSTZ		GPIOCORE_GPIO_P8	/* <O> */
#define GPIOCORE_GPIO_CAM_CNT		GPIOCORE_GPIO_P9	/* <O> */
#define GPIOCORE_GPIO_TS_INT		GPIOCORE_GPIO_P10	/* <I> */
#define GPIOCORE_GPIO_EXT_INT		GPIOCORE_GPIO_P11	/* <I> */
#define GPIOCORE_GPIO_U73_CTSZ		GPIOCORE_GPIO_P14	/* <I> */
#define GPIOCORE_GPIO_U73_RSTZ		GPIOCORE_GPIO_P15	/* <O> */
#define GPIOCORE_GPIO_ELTANIN_INT	GPIOCORE_GPIO_P16	/* <I> */
#define GPIOCORE_GPIO_NAND_RDY		GPIOCORE_GPIO_P17	/* <I> */
#define GPIOCORE_GPIO_KEY_DATA0		GPIOCORE_GPIO_P18	/* <I> */
#define GPIOCORE_GPIO_KEY_DATA1		GPIOCORE_GPIO_P19	/* <I> */
#define GPIOCORE_GPIO_KEY_DATA2		GPIOCORE_GPIO_P20	/* <I> */
#define GPIOCORE_GPIO_KEY_DATA3		GPIOCORE_GPIO_P21	/* <I> */
#define GPIOCORE_GPIO_KEY_SCAN0		GPIOCORE_GPIO_P22	/* <O> */
#define GPIOCORE_GPIO_KEY_SCAN1		GPIOCORE_GPIO_P23	/* <O> */
#define GPIOCORE_GPIO_ETHER_INT		GPIOCORE_GPIO_P24	/* <I> */
#define GPIOCORE_GPIO_U73_SOUT		GPIOCORE_GPIO_P25	/* <O> */
#define GPIOCORE_GPIO_U73_SRIN		GPIOCORE_GPIO_P26	/* <I> */
#define GPIOCORE_GPIO_U72_CTSZ		GPIOCORE_GPIO_P27	/* <I> */
#define GPIOCORE_GPIO_U72_RTSZ		GPIOCORE_GPIO_P28	/* <O> */
#define GPIOCORE_GPIO_U72_SOUT		GPIOCORE_GPIO_P29	/* <O> */
#define GPIOCORE_GPIO_U72_SRIN		GPIOCORE_GPIO_P30	/* <I> */
#define GPIOCORE_GPIO_ETM_TRACESYNC	GPIOCORE_GPIO_P31	/* <O> */
#define GPIOCORE_GPIO_EXTCNT1		GPIOCORE_GPIO_P60	/* <O> */
#define GPIOCORE_GPIO_EXTCNT2		GPIOCORE_GPIO_P61	/* <O> */
#define GPIOCORE_GPIO_SNDCDA		GPIOCORE_GPIO_P62	/* <O> */
#define GPIOCORE_GPIO_EXTONZ		GPIOCORE_GPIO_P63	/* <I> */
#endif				/* CONFIG_MP201 */

/* PWC */
#define GPIOCORE_INT_PWC_B0		PWC_INT_B0
#define GPIOCORE_INT_PWC_B1		PWC_INT_B1
#define GPIOCORE_INT_PWC_B2		PWC_INT_B2
#define GPIOCORE_INT_PWC_B3		PWC_INT_B3
#define GPIOCORE_INT_PWC_B4		PWC_INT_B4
#define GPIOCORE_INT_PWC_B5		PWC_INT_B5
#define GPIOCORE_INT_PWC_B6		PWC_INT_B6
#define GPIOCORE_INT_PWC_B7		PWC_INT_B7
#define GPIOCORE_INT_PWC_MAX		PWC_INT_MAX

/* board specific */
#ifdef CONFIG_MP201
#define GPIOCORE_INT_PWC_IO00		GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_IO01		GPIOCORE_INT_PWC_B1
#define GPIOCORE_INT_PWC_IO02		GPIOCORE_INT_PWC_B2
#define GPIOCORE_INT_PWC_IO03		GPIOCORE_INT_PWC_B3
#define GPIOCORE_INT_PWC_IO04		GPIOCORE_INT_PWC_B4
#define GPIOCORE_INT_PWC_IO05		GPIOCORE_INT_PWC_B5
#define GPIOCORE_INT_PWC_IO06		GPIOCORE_INT_PWC_B6
#define GPIOCORE_INT_PWC_IO07		GPIOCORE_INT_PWC_B7

#define GPIOCORE_INT_PWC_IO08		GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_IO09		GPIOCORE_INT_PWC_B1
#define GPIOCORE_INT_PWC_IO10		GPIOCORE_INT_PWC_B2
#define GPIOCORE_INT_PWC_IO11		GPIOCORE_INT_PWC_B3
#define GPIOCORE_INT_PWC_IO12		GPIOCORE_INT_PWC_B4
#define GPIOCORE_INT_PWC_IO13		GPIOCORE_INT_PWC_B5
#define GPIOCORE_INT_PWC_IO14		GPIOCORE_INT_PWC_B6
#define GPIOCORE_INT_PWC_IO15		GPIOCORE_INT_PWC_B7

#define GPIOCORE_INT_PWC_ADINT		GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_RTCINT		GPIOCORE_INT_PWC_B1
#define GPIOCORE_INT_PWC_CHGINT		GPIOCORE_INT_PWC_B2
#define GPIOCORE_INT_PWC_PWOFINT	GPIOCORE_INT_PWC_B3
#define GPIOCORE_INT_PWC_PWUPINT	GPIOCORE_INT_PWC_B4
#define GPIOCORE_INT_PWC_USBWAKINT	GPIOCORE_INT_PWC_B4
#define GPIOCORE_INT_PWC_DETBATINT	GPIOCORE_INT_PWC_B5
#define GPIOCORE_INT_PWC_DETADPINT	GPIOCORE_INT_PWC_B6
#define GPIOCORE_INT_PWC_DETUSBINT	GPIOCORE_INT_PWC_B7

#define GPIOCORE_INT_PWC_KEY_DATA0	GPIOCORE_INT_PWC_IO00
#define GPIOCORE_INT_PWC_KEY_DATA1	GPIOCORE_INT_PWC_IO01
#define GPIOCORE_INT_PWC_KEY_DATA2	GPIOCORE_INT_PWC_IO02
#define GPIOCORE_INT_PWC_KEY_DATA3	GPIOCORE_INT_PWC_IO03
#define GPIOCORE_INT_PWC_KEY_SCAN_D	GPIOCORE_INT_PWC_IO04
#define GPIOCORE_INT_PWC_KEY_SCAN_P	GPIOCORE_INT_PWC_IO05
#define GPIOCORE_INT_PWC_KEY_SCAN_E	GPIOCORE_INT_PWC_IO06
#define GPIOCORE_INT_PWC_ETHER_RST	GPIOCORE_INT_PWC_IO07
#define GPIOCORE_INT_PWC_SNDCDA		GPIOCORE_INT_PWC_IO08
#define GPIOCORE_INT_PWC_SNDPDN		GPIOCORE_INT_PWC_IO09
#define GPIOCORE_INT_PWC_LED_ON		GPIOCORE_INT_PWC_IO10
#define GPIOCORE_INT_PWC_LCD_OE		GPIOCORE_INT_PWC_IO11
#define GPIOCORE_INT_PWC_CAM_RSTZ	GPIOCORE_INT_PWC_IO12
#define GPIOCORE_INT_PWC_CAM_CNT	GPIOCORE_INT_PWC_IO13
#define GPIOCORE_INT_PWC_SDCDZ		GPIOCORE_INT_PWC_IO14
#define GPIOCORE_INT_PWC_SDWP		GPIOCORE_INT_PWC_IO15
#else
#define GPIOCORE_INT_PWC_OFINT		GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_IO01		GPIOCORE_INT_PWC_B1
#define GPIOCORE_INT_PWC_IO02		GPIOCORE_INT_PWC_B2
#define GPIOCORE_INT_PWC_IO03		GPIOCORE_INT_PWC_B3
#define GPIOCORE_INT_PWC_IO04		GPIOCORE_INT_PWC_B4
#define GPIOCORE_INT_PWC_IO05		GPIOCORE_INT_PWC_B5
#define GPIOCORE_INT_PWC_IO06		GPIOCORE_INT_PWC_B6
#define GPIOCORE_INT_PWC_RTCINT		GPIOCORE_INT_PWC_B7

#define GPIOCORE_INT_PWC_INTMODE	GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_INTRETRY	GPIOCORE_INT_PWC_B1

#define GPIOCORE_INT_PWC_IRINT		GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_DDINT		GPIOCORE_INT_PWC_B1

#define GPIOCORE_INT_PWC_VBUSL		GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_VBUSM		GPIOCORE_INT_PWC_B1
#define GPIOCORE_INT_PWC_VBUSH		GPIOCORE_INT_PWC_B2
#define GPIOCORE_INT_PWC_ID		GPIOCORE_INT_PWC_B3
#define GPIOCORE_INT_PWC_DPSRP		GPIOCORE_INT_PWC_B4
#define GPIOCORE_INT_PWC_BDISACON	GPIOCORE_INT_PWC_B5
#define GPIOCORE_INT_PWC_TVINT		GPIOCORE_INT_PWC_B6
#define GPIOCORE_INT_PWC_VBUSDET	GPIOCORE_INT_PWC_B7

#define GPIOCORE_INT_PWC_TVINTG		GPIOCORE_INT_PWC_B0
#define GPIOCORE_INT_PWC_IRINTG		GPIOCORE_INT_PWC_B1
#define GPIOCORE_INT_PWC_USBINTG	GPIOCORE_INT_PWC_B2
#define GPIOCORE_INT_PWC_DDINTG		GPIOCORE_INT_PWC_B3
#endif				/* CONFIG_MP201 */

/* GPIO registers */
#ifdef CONFIG_MP201
#define GPIOCORE_GP_DO0			GPIO0_DO
#define GPIOCORE_GP_DI			GPIO0_DI

#define GPIOCORE_GP_O			GPIOCORE_GP_DO0
#define GPIOCORE_GPIO_I			GPIOCORE_GP_DI
#else
#define GPIOCORE_GP_O			GP_OLL
#define GPIOCORE_GPIO_I			GPIO_IL
#endif				/* CONFIG_MP201 */

/* PWC registers */
#ifdef CONFIG_MP201
#define GPIOCORE_PWC_REGA		PWC_REGA	/* write */
#define GPIOCORE_PWC_PSCNT1		PWC_PSCNT1	/* write */
#define GPIOCORE_PWC_PSCNT2		PWC_PSCNT2	/* write */
#define GPIOCORE_PWC_MODESET1		PWC_MODESET1	/* write */
#define GPIOCORE_PWC_VOUTSET1		PWC_VOUTSET1	/* write */
#define GPIOCORE_PWC_VOUTSET2		PWC_VOUTSET2	/* write */
#define GPIOCORE_PWC_VOUTSET3		PWC_VOUTSET3	/* write */
#define GPIOCORE_PWC_IOSEL1		PWC_IOSEL1	/* write */
#define GPIOCORE_PWC_IOSEL2		PWC_IOSEL2	/* write */
#define GPIOCORE_PWC_IOOUT1		PWC_IOOUT1	/* write */
#define GPIOCORE_PWC_IOIN1		PWC_IOIN1	/* read  */
#define GPIOCORE_PWC_IOOUT2		PWC_IOOUT2	/* write */
#define GPIOCORE_PWC_IOIN2		PWC_IOIN2	/* read  */
#define GPIOCORE_PWC_GPPUPD1		PWC_GPPUPD1	/* write */
#define GPIOCORE_PWC_GPPUPD2		PWC_GPPUPD2	/* write */
#define GPIOCORE_PWC_GPPUPD3		PWC_GPPUPD3	/* write */
#define GPIOCORE_PWC_GPPUPD4		PWC_GPPUPD4	/* write */
#define GPIOCORE_PWC_FMASK1		PWC_FMASK1	/* write */
#define GPIOCORE_PWC_FACTOR1		PWC_FACTOR1	/* read  */
#define GPIOCORE_PWC_FMASK2		PWC_FMASK2	/* write */
#define GPIOCORE_PWC_FACTOR2		PWC_FACTOR2	/* read  */
#define GPIOCORE_PWC_FMASK3		PWC_FMASK3	/* write */
#define GPIOCORE_PWC_FACTOR3		PWC_FACTOR3	/* read  */
#define GPIOCORE_PWC_STATE1		PWC_STATE1	/* write */
#define GPIOCORE_PWC_STATE2		PWC_STATE2	/* write */
#define GPIOCORE_PWC_STATE3		PWC_STATE3	/* write */
#define GPIOCORE_PWC_CLRFACT1		PWC_CLRFACT1	/* write */
#define GPIOCORE_PWC_CLRFACT2		PWC_CLRFACT2	/* write */
#define GPIOCORE_PWC_CLRFACT3		PWC_CLRFACT3	/* write */
#define GPIOCORE_PWC_DETMOD1L		PWC_DETMOD1L	/* write */
#define GPIOCORE_PWC_DETMOD1H		PWC_DETMOD1H	/* write */
#define GPIOCORE_PWC_DETMOD2L		PWC_DETMOD2L	/* write */
#define GPIOCORE_PWC_DETMOD2H		PWC_DETMOD2H	/* write */
#define GPIOCORE_PWC_DETMOD3L		PWC_DETMOD3L	/* write */
#define GPIOCORE_PWC_DETMOD3H		PWC_DETMOD3H	/* write */
#define GPIOCORE_PWC_BMASK1		PWC_BMASK1	/* write */
#define GPIOCORE_PWC_BMASK2		PWC_BMASK2	/* write */
#define GPIOCORE_PWC_BMASK3		PWC_BMASK3	/* write */
#define GPIOCORE_PWC_REGRSTMSK1		PWC_REGRSTMSK1	/* write */
#define GPIOCORE_PWC_REGRSTMSK2		PWC_REGRSTMSK2	/* write */
#define GPIOCORE_PWC_SYSRSTMSK1		PWC_SYSRSTMSK1	/* write */
#define GPIOCORE_PWC_SYSRSTMSK2		PWC_SYSRSTMSK2	/* write */
#define GPIOCORE_PWC_REGPWONMSK		PWC_REGPWONMSK	/* write */
#define GPIOCORE_PWC_ADDATA1		PWC_ADDATA1	/* read  */
#define GPIOCORE_PWC_ADMODE		PWC_ADMODE	/* write */
#define GPIOCORE_PWC_ADDATA2		PWC_ADDATA2	/* read  */
#define GPIOCORE_PWC_VCCVBATSW		PWC_VCCVBATSW	/* write */
#define GPIOCORE_PWC_ADDATA3		PWC_ADDATA3	/* read  */
#define GPIOCORE_PWC_VCCADPSW		PWC_VCCADPSW	/* write */
#define GPIOCORE_PWC_VCCVBUSSW		PWC_VCCVBUSSW	/* write */
#define GPIOCORE_PWC_ADDATA4		PWC_ADDATA4	/* read  */
#define GPIOCORE_PWC_ADDATA5		PWC_ADDATA5	/* read  */
#define GPIOCORE_PWC_ADDATA6		PWC_ADDATA6	/* read  */
#define GPIOCORE_PWC_ADDATA7		PWC_ADDATA7	/* read  */
#define GPIOCORE_PWC_ADDATA8		PWC_ADDATA8	/* read  */
#define GPIOCORE_PWC_CHGCNTR1		PWC_CHGCNTR1	/* write */
#define GPIOCORE_PWC_CHGIRR		PWC_CHGIRR	/* read  */
#define GPIOCORE_PWC_CHGIRCL		PWC_CHGIRCL	/* write */
#define GPIOCORE_PWC_CHGSTATE		PWC_CHGSTATE	/* read  */
#define GPIOCORE_PWC_TIMCNTR		PWC_TIMCNTR	/* write */
#define GPIOCORE_PWC_CVSETR		PWC_CVSETR	/* write */
#define GPIOCORE_PWC_CHGCNTR2		PWC_CHGCNTR2	/* write */
#define GPIOCORE_PWC_PSW_STATE		PWC_PSW_STATE	/* read  */
#define GPIOCORE_PWC_SFTRST		PWC_SFTRST	/* write */
#define GPIOCORE_PWC_RDET_EN		PWC_RDET_EN	/* write */
#define GPIOCORE_PWC_PWRSWCONT		PWC_PWRSWCONT	/* write */
#define GPIOCORE_PWC_DETIOCONT		PWC_DETIOCONT	/* write */
#define GPIOCORE_PWC_WRSTFCT		PWC_WRSTFCT	/* read  */
#define GPIOCORE_PWC_WRSTCL		PWC_WRSTCL	/* write */
#define GPIOCORE_PWC_LSIVER		PWC_LSIVER	/* read  */
#define GPIOCORE_PWC_SEC		PWC_SEC	/* write */
#define GPIOCORE_PWC_SEC_RD		PWC_SEC_RD	/* read  */
#define GPIOCORE_PWC_MIN		PWC_MIN	/* write */
#define GPIOCORE_PWC_MIN_RD		PWC_MIN_RD	/* read  */
#define GPIOCORE_PWC_HOUR		PWC_HOUR	/* write */
#define GPIOCORE_PWC_HOUR_RD		PWC_HOUR_RD	/* read  */
#define GPIOCORE_PWC_WEEK		PWC_WEEK	/* write */
#define GPIOCORE_PWC_WEEK_RD		PWC_WEEK_RD	/* read  */
#define GPIOCORE_PWC_DAY		PWC_DAY	/* write */
#define GPIOCORE_PWC_DAY_RD		PWC_DAY_RD	/* read  */
#define GPIOCORE_PWC_MONTH		PWC_MONTH	/* write */
#define GPIOCORE_PWC_MONTH_RD		PWC_MONTH_RD	/* read  */
#define GPIOCORE_PWC_YEAR		PWC_YEAR	/* write */
#define GPIOCORE_PWC_YEAR_RD		PWC_YEAR_RD	/* read  */
#define GPIOCORE_PWC_TRIM		PWC_TRIM	/* write */
#define GPIOCORE_PWC_TRIM_RD		PWC_TRIM_RD	/* read  */
#define GPIOCORE_PWC_ALM_WM		PWC_ALM_WM	/* write */
#define GPIOCORE_PWC_ALM_WM_RD		PWC_ALM_WM_RD	/* read  */
#define GPIOCORE_PWC_ALM_WH		PWC_ALM_WH	/* write */
#define GPIOCORE_PWC_ALM_WH_RD		PWC_ALM_WH_RD	/* read  */
#define GPIOCORE_PWC_ALM_WW		PWC_ALM_WW	/* write */
#define GPIOCORE_PWC_ALM_WW_RD		PWC_ALM_WW_RD	/* read  */
#define GPIOCORE_PWC_ALM_DM		PWC_ALM_DM	/* write */
#define GPIOCORE_PWC_ALM_DM_RD		PWC_ALM_DM_RD	/* read  */
#define GPIOCORE_PWC_ALM_DH		PWC_ALM_DH	/* write */
#define GPIOCORE_PWC_ALM_DH_RD		PWC_ALM_DH_RD	/* read  */
#define GPIOCORE_PWC_RTC1		PWC_RTC1	/* write */
#define GPIOCORE_PWC_RTC1_RD		PWC_RTC1_RD	/* read  */
#define GPIOCORE_PWC_RTC2		PWC_RTC2	/* write */
#define GPIOCORE_PWC_RTC2_RD		PWC_RTC2_RD	/* read  */
#define GPIOCORE_PWC_USBCONT		PWC_USBCONT	/* write */
#define GPIOCORE_PWC_WRSTMSK		PWC_WRSTMSK	/* write */
#define GPIOCORE_PWC_WAKECONT		PWC_WAKECONT	/* write */
#else
#define GPIOCORE_PWC_INTCLR2		PWC_INTCLR2
#define GPIOCORE_PWC_CLRMODE		PWC_CLRMODE
#define GPIOCORE_PWC_INTCLR		PWC_INTCLR
#define GPIOCORE_PWC_BKUP2		PWC_BKUP2
#define GPIOCORE_PWC_BKUP2_RD		PWC_BKUP2_RD
#define GPIOCORE_PWC_BKUP3		PWC_BKUP3
#define GPIOCORE_PWC_BKUP3_RD		PWC_BKUP3_RD
#define GPIOCORE_PWC_BKUP4		PWC_BKUP4
#define GPIOCORE_PWC_BKUP4_RD		PWC_BKUP4_RD
#define GPIOCORE_PWC_BKUP5		PWC_BKUP5
#define GPIOCORE_PWC_BKUP5_RD		PWC_BKUP5_RD
#define GPIOCORE_PWC_BKUP6		PWC_BKUP6
#define GPIOCORE_PWC_BKUP6_RD		PWC_BKUP6_RD
#define GPIOCORE_PWC_BKUP7		PWC_BKUP7
#define GPIOCORE_PWC_BKUP7_RD		PWC_BKUP7_RD
#define GPIOCORE_PWC_BKUP8		PWC_BKUP8
#define GPIOCORE_PWC_BKUP8_RD		PWC_BKUP8_RD
#define GPIOCORE_PWC_INTR3		PWC_INTR3
#define GPIOCORE_PWC_INTM3		PWC_INTM3
#define GPIOCORE_PWC_INTCLR3		PWC_INTCLR3
#define GPIOCORE_PWC_VFBMON		PWC_VFBMON
#define GPIOCORE_PWC_MCARD		PWC_MCARD
#define GPIOCORE_PWC_REGMODE		PWC_REGMODE
#define GPIOCORE_PWC_MODESET		PWC_MODESET
#define GPIOCORE_PWC_USBPDB		PWC_USBPDB
#define GPIOCORE_PWC_USBSW		PWC_USBSW
#define GPIOCORE_PWC_MCARDEN		PWC_MCARDEN
#define GPIOCORE_PWC_PWR_C_H_C		PWC_PWR_C_H_C
#define GPIOCORE_PWC_PWR_C_H_R		PWC_PWR_C_H_R
#define GPIOCORE_PWC_BKUP1		PWC_BKUP1
#define GPIOCORE_PWC_BKUP1_RD		PWC_BKUP1_RD
#define GPIOCORE_PWC_STEP		PWC_STEP

#define GPIOCORE_PWC_RGBCNT1		PWC_RGBCNT1
#define GPIOCORE_PWC_RGBCNT2		PWC_RGBCNT2
#define GPIOCORE_PWC_RPWMON		PWC_RPWMON
#define GPIOCORE_PWC_RPWMOFF		PWC_RPWMOFF
#define GPIOCORE_PWC_GPWMON		PWC_GPWMON
#define GPIOCORE_PWC_GPWMOFF		PWC_GPWMOFF
#define GPIOCORE_PWC_BPWMON		PWC_BPWMON
#define GPIOCORE_PWC_BPWMOFF		PWC_BPWMOFF
#define GPIOCORE_PWC_LPWMON		PWC_LPWMON
#define GPIOCORE_PWC_LPWMOFF		PWC_LPWMOFF
#define GPIOCORE_PWC_PWMMODE		PWC_PWMMODE
#define GPIOCORE_PWC_USBINTM		PWC_USBINTM
#define GPIOCORE_PWC_USBINTR		PWC_USBINTR
#define GPIOCORE_PWC_USBINT		PWC_USBINT
#define GPIOCORE_PWC_LED		PWC_LED

#define GPIOCORE_PWC_PSCONT		PWC_PSCONT
#define GPIOCORE_PWC_DDCONT		PWC_DDCONT
#define GPIOCORE_PWC_DDPWM		PWC_DDPWM
#define GPIOCORE_PWC_VFBSET		PWC_VFBSET
#define GPIOCORE_PWC_PSCNT2		PWC_PSCNT2
#define GPIOCORE_PWC_REGL0VAL		PWC_REGL0VAL
#define GPIOCORE_PWC_DDVFM		PWC_DDVFM
#define GPIOCORE_PWC_TVCNT		PWC_TVCNT
#define GPIOCORE_PWC_RSTMASK		PWC_RSTMASK
#define GPIOCORE_PWC_SFTRST		PWC_SFTRST
#define GPIOCORE_PWC_RDET_EN		PWC_RDET_EN
#define GPIOCORE_PWC_RSTFACTCLR		PWC_RSTFACTCLR
#define GPIOCORE_PWC_RSTFACTOR		PWC_RSTFACTOR
#define GPIOCORE_PWC_RSTRD		PWC_RSTRD
#define GPIOCORE_PWC_COUNTCLR		PWC_COUNTCLR
#define GPIOCORE_PWC_MASK3		PWC_MASK3

#define GPIOCORE_PWC_IOSEL2		PWC_IOSEL2
#define GPIOCORE_PWC_MASK2		PWC_MASK2
#define GPIOCORE_PWC_IOOUT2		PWC_IOOUT2
#define GPIOCORE_PWC_IOOUTSEL		PWC_IOOUTSEL
#define GPIOCORE_PWC_FACTOR2		PWC_FACTOR2
#define GPIOCORE_PWC_IOSTATE2		PWC_IOSTATE2
#define GPIOCORE_PWC_CHTTIM1H		PWC_CHTTIM1H
#define GPIOCORE_PWC_CHTTIM2H		PWC_CHTTIM2H
#define GPIOCORE_PWC_PSCNTA		PWC_PSCNTA

#define GPIOCORE_PWC_SEC		PWC_SEC
#define GPIOCORE_PWC_MIN		PWC_MIN
#define GPIOCORE_PWC_HOUR		PWC_HOUR
#define GPIOCORE_PWC_WEEK		PWC_WEEK
#define GPIOCORE_PWC_DAY		PWC_DAY
#define GPIOCORE_PWC_MONTH		PWC_MONTH
#define GPIOCORE_PWC_YEAR		PWC_YEAR
#define GPIOCORE_PWC_TRIM		PWC_TRIM
#define GPIOCORE_PWC_ALM_WM		PWC_ALM_WM
#define GPIOCORE_PWC_ALM_WH		PWC_ALM_WH
#define GPIOCORE_PWC_ALM_WW		PWC_ALM_WW
#define GPIOCORE_PWC_ALM_DM		PWC_ALM_DM
#define GPIOCORE_PWC_ALM_DH		PWC_ALM_DH
#define GPIOCORE_PWC_RTC1		PWC_RTC1
#define GPIOCORE_PWC_RTC2		PWC_RTC2
#define GPIOCORE_PWC_PDBRTC		PWC_PDBRTC

#define GPIOCORE_PWC_SEC_RD		PWC_SEC_RD
#define GPIOCORE_PWC_MIN_RD		PWC_MIN_RD
#define GPIOCORE_PWC_HOUR_RD		PWC_HOUR_RD
#define GPIOCORE_PWC_WEEK_RD		PWC_WEEK_RD
#define GPIOCORE_PWC_DAY_RD		PWC_DAY_RD
#define GPIOCORE_PWC_MONTH_RD		PWC_MONTH_RD
#define GPIOCORE_PWC_YEAR_RD		PWC_YEAR_RD
#define GPIOCORE_PWC_TRIM_RD		PWC_TRIM_RD
#define GPIOCORE_PWC_ALM_WM_RD		PWC_ALM_WM_RD
#define GPIOCORE_PWC_ALM_WH_RD		PWC_ALM_WH_RD
#define GPIOCORE_PWC_ALM_WW_RD		PWC_ALM_WW_RD
#define GPIOCORE_PWC_ALM_DM_RD		PWC_ALM_DM_RD
#define GPIOCORE_PWC_ALM_DH_RD		PWC_ALM_DH_RD
#define GPIOCORE_PWC_RTC1_RD		PWC_RTC1_RD
#define GPIOCORE_PWC_RTC2_RD		PWC_RTC2_RD
#define GPIOCORE_PWC_LSIVER		PWC_LSIVER

#define GPIOCORE_PWC_IRCNT1		PWC_IRCNT1
#define GPIOCORE_PWC_IRCNT2		PWC_IRCNT2
#define GPIOCORE_PWC_IRBCK		PWC_IRBCK
#define GPIOCORE_PWC_IRCL1		PWC_IRCL1
#define GPIOCORE_PWC_IRCL2		PWC_IRCL2
#define GPIOCORE_PWC_IRCH1		PWC_IRCH1
#define GPIOCORE_PWC_IRCH2		PWC_IRCH2
#define GPIOCORE_PWC_IRHL1		PWC_IRHL1
#define GPIOCORE_PWC_IRHL0		PWC_IRHL0
#define GPIOCORE_PWC_IRHH1		PWC_IRHH1
#define GPIOCORE_PWC_IRHH0		PWC_IRHH0
#define GPIOCORE_PWC_IRD0L1		PWC_IRD0L1
#define GPIOCORE_PWC_IRD0L0		PWC_IRD0L0
#define GPIOCORE_PWC_IRD0H1		PWC_IRD0H1
#define GPIOCORE_PWC_IRD0H0		PWC_IRD0H0
#define GPIOCORE_PWC_IRD1L1		PWC_IRD1L1
#define GPIOCORE_PWC_IRD1L0		PWC_IRD1L0
#define GPIOCORE_PWC_IRD1H1		PWC_IRD1H1
#define GPIOCORE_PWC_IRD1H0		PWC_IRD1H0
#define GPIOCORE_PWC_IREND1		PWC_IREND1
#define GPIOCORE_PWC_IREND0		PWC_IREND0
#define GPIOCORE_PWC_IRBIT		PWC_IRBIT
#define GPIOCORE_PWC_IRFRM1		PWC_IRFRM1
#define GPIOCORE_PWC_IRFRM0		PWC_IRFRM0
#define GPIOCORE_PWC_IROUT0A		PWC_IROUT0A
#define GPIOCORE_PWC_IROUT1A		PWC_IROUT1A
#define GPIOCORE_PWC_IROUT2A		PWC_IROUT2A
#define GPIOCORE_PWC_IROUT3A		PWC_IROUT3A
#define GPIOCORE_PWC_IROUT4A		PWC_IROUT4A
#define GPIOCORE_PWC_IROUT5A		PWC_IROUT5A
#define GPIOCORE_PWC_IROUT6A		PWC_IROUT6A
#define GPIOCORE_PWC_IROUT7A		PWC_IROUT7A
#define GPIOCORE_PWC_IROUT0B		PWC_IROUT0B
#define GPIOCORE_PWC_IROUT1B		PWC_IROUT1B
#define GPIOCORE_PWC_IROUT2B		PWC_IROUT2B
#define GPIOCORE_PWC_IROUT3B		PWC_IROUT3B
#define GPIOCORE_PWC_IROUT4B		PWC_IROUT4B
#define GPIOCORE_PWC_IROUT5B		PWC_IROUT5B
#define GPIOCORE_PWC_IROUT6B		PWC_IROUT6B
#define GPIOCORE_PWC_IROUT7B		PWC_IROUT7B

#define GPIOCORE_PWC_IRRQC		PWC_IRRQC
#define GPIOCORE_PWC_IRSND		PWC_IRSND
#define GPIOCORE_PWC_IRRST		PWC_IRRST

#define GPIOCORE_PWC_ENCCTRL0		PWC_ENCCTRL0
#define GPIOCORE_PWC_CCEH		PWC_CCEH
#define GPIOCORE_PWC_CCEL		PWC_CCEL
#define GPIOCORE_PWC_CCOH		PWC_CCOH
#define GPIOCORE_PWC_CCOL		PWC_CCOL
#define GPIOCORE_PWC_CGMS_WSSR		PWC_CGMS_WSSR
#define GPIOCORE_PWC_CGMS_WSSR1		PWC_CGMS_WSSR1
#define GPIOCORE_PWC_CGMS_WSSR2		PWC_CGMS_WSSR2
#define GPIOCORE_PWC_MACROV0		PWC_MACROV0
#define GPIOCORE_PWC_MACROV1		PWC_MACROV1
#define GPIOCORE_PWC_MACROV2		PWC_MACROV2
#define GPIOCORE_PWC_MACROV3		PWC_MACROV3
#define GPIOCORE_PWC_MACROV4		PWC_MACROV4
#define GPIOCORE_PWC_MACROV5		PWC_MACROV5
#define GPIOCORE_PWC_MACROV6		PWC_MACROV6
#define GPIOCORE_PWC_MACROV7		PWC_MACROV7
#define GPIOCORE_PWC_MACROV8		PWC_MACROV8
#define GPIOCORE_PWC_MACROV9		PWC_MACROV9
#define GPIOCORE_PWC_MACROV10		PWC_MACROV10
#define GPIOCORE_PWC_MACROV11		PWC_MACROV11
#define GPIOCORE_PWC_MACROV12		PWC_MACROV12
#define GPIOCORE_PWC_MACROV13		PWC_MACROV13
#define GPIOCORE_PWC_MACROV14		PWC_MACROV14
#define GPIOCORE_PWC_MACROV15		PWC_MACROV15
#define GPIOCORE_PWC_MACROV16		PWC_MACROV16
#define GPIOCORE_PWC_MACROV17		PWC_MACROV17
#define GPIOCORE_PWC_MACROV18		PWC_MACROV18
#endif				/* CONFIG_MP201 */

#define GPIOCORE_PWC_MAX		PWC_MAX

static inline int gpiocore_read(unsigned short offset, unsigned char port)
{
	uint32_t val;
	int ret;

	if (port > GPIOCORE_GPIO_P63) {
		return -EINVAL;
	}
#ifdef CONFIG_MP201
	if (offset == GPIOCORE_GP_O) {
		if (port < GPIOCORE_GPIO_P16) {
			val = __raw_readl(VA_GIO + GPIO0_DO);
		} else if (port < GPIOCORE_GPIO_P32) {
			val = __raw_readl(VA_GIO + GPIO1_DO);
		} else if (port < GPIOCORE_GPIO_P48) {
			val = __raw_readl(VA_GIO + GPIO2_DO);
		} else {
			val = __raw_readl(VA_GIO + GPIO3_DO);
		}
		ret = (val & (1U << (port & 0xf))) ? 1 : 0;
	} else if (offset == GPIOCORE_GPIO_I) {
		if (port < GPIOCORE_GPIO_P32) {
			val = mp200_gio_read_inputs_low32();
		} else {
			val = mp200_gio_read_inputs_high32();
		}
		ret = (val & (1U << (port & 0x1f))) ? 1 : 0;
	} else {
		ret = -EINVAL;
	}
#else
	if (offset == GPIOCORE_GP_O) {
		if (port < GPIOCORE_GPIO_P16) {
			val = __raw_readl(VA_GIO + GP_OLL);
		} else if (port < GPIOCORE_GPIO_P32) {
			val = __raw_readl(VA_GIO + GP_OHL);
		} else if (port < GPIOCORE_GPIO_P48) {
			val = __raw_readl(VA_GIO + GP_OLH);
		} else {
			val = __raw_readl(VA_GIO + GP_OHH);
		}
		ret = (val & (1U << (port & 0xf))) ? 1 : 0;
	} else if (offset == GPIOCORE_GPIO_I) {
		if (port < GPIOCORE_GPIO_P32) {
			val = mp200_gio_read_inputs_low32();
		} else {
			val = mp200_gio_read_inputs_high32();
		}
		ret = (val & (1U << (port & 0x1f))) ? 1 : 0;
	} else {
		ret = -EINVAL;
	}
#endif				/* CONFIG_MP201 */
	return ret;
}

static inline int gpiocore_write(unsigned short offset,
				 unsigned char port, int data)
{
	uint32_t goe = (0x10000U << (port & 0xf));
	uint32_t gos = data ? (1U << (port & 0xf)) : 0;

	if (port > GPIOCORE_GPIO_P63) {
		return -EINVAL;
	}
#ifdef CONFIG_MP201
	if (offset == GPIOCORE_GP_O) {
		if (port < GPIOCORE_GPIO_P16) {
			__raw_writel((goe | gos), (VA_GIO + GPIO0_DO));
		} else if (port < GPIOCORE_GPIO_P32) {
			__raw_writel((goe | gos), (VA_GIO + GPIO1_DO));
		} else if (port < GPIOCORE_GPIO_P48) {
			__raw_writel((goe | gos), (VA_GIO + GPIO2_DO));
		} else {
			__raw_writel((goe | gos), (VA_GIO + GPIO3_DO));
		}
#else
	if (offset == GPIOCORE_GP_O) {
		if (port < GPIOCORE_GPIO_P16) {
			__raw_writel((goe | gos), (VA_GIO + GP_OLL));
		} else if (port < GPIOCORE_GPIO_P32) {
			__raw_writel((goe | gos), (VA_GIO + GP_OHL));
		} else if (port < GPIOCORE_GPIO_P48) {
			__raw_writel((goe | gos), (VA_GIO + GP_OLH));
		} else {
			__raw_writel((goe | gos), (VA_GIO + GP_OHH));
		}
#endif				/* CONFIG_MP201 */
	} else {
		return -EINVAL;
	}
	return 0;
}

#define gpiocore_pwc_read(offset, data)		pwc_read(offset, data)
#define gpiocore_pwc_write(offset, data, mask)	pwc_write(offset, data, mask)

#endif				/* __ASM_ARM_ARCH_MP200_GPIOCORE_H */
