/*
 *
 * Copyright 2006 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ASM_ARM_ARCH_ICX1087_CRADLE_H
#define __ASM_ARM_ARCH_ICX1087_CRADLE_H

#include <asm/ioctl.h>

#define ICX1087_CRADLE_NAME  "icx1087_cradle"
#define ICX1087_CRADLE_DEV   "/dev/"ICX1087_CRADLE_NAME


typedef struct _icx1087_cradle_state {
    int connect;                /* 0: disconnect, 1: connect */
    int id;                     /* ICX1087_CRADLE_ID_X */
    int count;                  /* detected count */
} icx1087_cradle_state_t;


#define ICX1087_CRADLE_IOC_MAGIC  'c'
#define ICX1087_CRADLE_GET_STATE _IOR( ICX1087_CRADLE_IOC_MAGIC, 1, icx1087_cradle_state_t )

#define ICX1087_CRADLE_ID_0  0x01
#define ICX1087_CRADLE_ID_1  0x02
#define ICX1087_CRADLE_ID_2  0x03
#define ICX1087_CRADLE_ID_3  0x04
#define ICX1087_CRADLE_ID_4  0x05
#define ICX1087_CRADLE_ID_5  0x06
#define ICX1087_CRADLE_ID_6  0x11
#define ICX1087_CRADLE_ID_7  0x12
#define ICX1087_CRADLE_ID_8  0x13
#define ICX1087_CRADLE_ID_9  0x14
#define ICX1087_CRADLE_ID_A  0x15
#define ICX1087_CRADLE_ID_B  0xFF

#endif /* __ASM_ARM_ARCH_ICX1087_CRADLE_H */
