/*
 * Copyright 2006 Sony Corporation. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef _ICX1087_KEY_H_
#define _ICX1087_KEY_H_

/* Key code for AD0 */
#define ICX1087_KEY_PLAY     0x00
#define ICX1087_KEY_RIGHT    0x01
#define ICX1087_KEY_LEFT     0x02
#define ICX1087_KEY_UP       0x03
#define ICX1087_KEY_DOWN     0x04
#define ICX1087_KEY_AD05     0x05
#define ICX1087_KEY_AD06     0x06
#define ICX1087_KEY_AD07     0x07

/* Key code for AD1 */
#define ICX1087_KEY_VOLDOWN  0x10
#define ICX1087_KEY_VOLUP    0x11
#define ICX1087_KEY_BACK     0x12
#define ICX1087_KEY_OPTION   0x13
#define ICX1087_KEY_AD14     0x14
#define ICX1087_KEY_AD15     0x15
#define ICX1087_KEY_AD16     0x16
#define ICX1087_KEY_AD17     0x17

/* Mask value for Hold key. */
/* NOTE: MSB shows hold key state */
#define ICX1087_KEY_HOLD_MASK 0x80

/* Key code for nothing pressed */
#define ICX1087_KEY_NONE     0x0f

extern int sonykpd_get_code(int);

#endif /* _ICX1087_KEY_H_ */

