#ifndef ICX1087_USBCONN_H
#define ICX1087_USBCONN_H
/*
 * icx1087_usbconn.h -- Sony ICX1087 platform audio interface
 *
 * Copyright 2006 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <asm/ioctl.h>

/* Command Code       */
#define MSC_CONN_IOC_MAGIC  'g'
#define MSC_GET_CSTAT _IOR(MSC_CONN_IOC_MAGIC, 1, int)
#define MSC_ALLOW_ACC _IOW(MSC_CONN_IOC_MAGIC, 2, int)
#define MSC_CONN_IOC_MAXNR 2

/* USB Connect Status   */
#define USB_DISCONNECT 0
#define USB_CONNECT    1
#define USB_FW_UPDATE  2

/* USB Access Authority */
#define USB_AUTH_APL   0
#define USB_AUTH_PC    1

/* CONN TO MSC CallBack */
struct conn_to_msc_func{
    int (*chg_sts)(int);
};

/* MSC TO CONN CallBack */
struct msc_to_conn_func{
    unsigned int (*get_conn_sts)(void);
    void         (*allow_acc)(void);
};

void usbconn_bind_msc(struct msc_to_conn_func *, struct conn_to_msc_func *);
#endif  /* ICX1087_USBCONN_H */

