#ifndef ICX1087_USBTRNS_H
#define ICX1087_USBTRNS_H
/*
 * icx1087_usbtrns.h -- Sony ICX1087 platform audio interface
 *
 * Copyright 2006 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <asm/ioctl.h>

/* Command Code       */
#define MSC_TRNS_IOC_MAGIC  'g'
#define MSC_GET_LAPSED_TIME _IOR(MSC_TRNS_IOC_MAGIC, 1, int)
#define MSC_TRNS_IOC_MAXNR 1

/* Define             */
#define MSC_MAX_JIFF_TIME 0xFFFFFFFF  /* jiffies max value */

/* TRNS TO MSC CallBack */
struct trns_to_msc_func{
    void (*trns_start)(void);
};

/* MSC TO TRNS callback */
struct msc_to_trns_func{
    int (*get_lapsed_time)(unsigned long *);
};

void usbtrns_bind_msc(struct msc_to_trns_func *, struct trns_to_msc_func *);
#endif
