/*
 *  File Name       : linux/include/asm-arm/arch-mp200/irqs.h
 *  Function        : irq
 *  Release Version : Ver 1.01
 *  Release Date    : 2006/07/27
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef __ASM_ARM_ARCH_MP200_IRQS_H
#define __ASM_ARM_ARCH_MP200_IRQS_H

/*
 * Interrupt numbers
 */
#ifdef CONFIG_MP201
#define INT_CPU			0
#define INT_DSP			1
#define INT_MSE			2
#define INT_CPI			3
#define INT_TI0			4
#define INT_TI1			5
#define INT_TI2			6
#define INT_TI3			7
#define INT_TI4			8
#define INT_TI5			9
#define INT_DMACPU		10
#define INT_DMADSP		11
#define INT_DMACPI		12
#define INT_LCD			13
#define INT_IMG			14
#define INT_ROT			15
#define INT_ATA			16
#define INT_NAND		17
#define INT_GMI			18
#define INT_SP0			20
#define INT_SP1			21
#define INT_PCM0		22
#define INT_PCM1		23
#define INT_USB			25
#define INT_SDMSD		28
#define INT_SDMCC		29
#define INT_MSP			30
#define INT_MG			31
#define INT_SWT			32
#define INT_SMU			33
#define INT_MWI			34
#define INT_IIC			35
#define INT_UART0		36
#define INT_PWM			37
#define INT_STM			38
#define INT_NTS			40
#define INT_DTV			41
#define INT_CAM			42
#define INT_CPIIF		43
#define INT_SCN			44
#define INT_IIS0		48
#define INT_IIS1		49
#define INT_IIS2		50
#define INT_IIS3		51
#define INT_IIS4		52
#define INT_IIS5		53
#define INT_IIS6		54
#define INT_IIS7		55
#define INT_GIO0		56
#define INT_GIO1		57
#define INT_GIO2		58
#define INT_GIO3		59
#define INT_TW0			60
#define INT_TW1			61
#else
#define INT_PE0			0
#define INT_PE1			1
#define INT_PE2			2
#define INT_DSP			3
#define INT_S1_IM		4
#define INT_SIO0TX		5
#define INT_SIO0RX		6
#define INT_SIO1TX		7
#define INT_SIO1RX		8
#define INT_UART0		9
#define INT_UART1		10
#define INT_UART2		11
#define INT_UART3		12
#define INT_PCM0		13
#define INT_PCM1		14
#define INT_PCM2		15
#define INT_MWI			16
#define INT_SMU			17
#define INT_RMTTX		18
#define INT_RMTRX		19
#define INT_LCD			20
#define INT_CAM			21
#define INT_IMG			22
#define INT_ROT			23
#define INT_SP0			24
#define INT_SP1			25
#define INT_SP2			26
#define INT_MOD0R		27
#define INT_MOD0B		28
#define INT_MSP			29
#define INT_MMM			30
#define INT_A3D			31
#define INT_SWT			32
#define INT_IIC			33
#define INT_TG0			34
#define INT_TG1			35
#define INT_TG2			36
#define INT_DMAPE0		37
#define INT_DMAPE1		38
#define INT_DMAPE2		39
#define INT_DMADSP		40
#define INT_USBCTRL		41
#define INT_USBIIC		42
#define INT_USBDMA		43
#define INT_TG3			44
#define INT_TG4			45
#define INT_TG5			46
#define INT_NTS			47
#define INT_DTV			48
#define INT_CCP			49
#define INT_GIO0		50
#define INT_GIO1		51
#define INT_GIO2		52
#define INT_GIO3		53
#define INT_TIMER0		54
#define INT_TIMER1		55
#define INT_TIMER2		56
#define INT_TIMER3		57
#define INT_WDT0		58
#define INT_WDT1		59
#define INT_WDT2		60
#define INT_WDT3		61
#endif				/* CONFIG_MP201 */

#define INT_LAST		63
/*
 * IRQ Numbers for interrupts muxed through GPIO
 */
#define INT_GPIO_BASE		(INT_LAST + 1)
#define INT_GPIO_0		(INT_GPIO_BASE + 0)
#define INT_GPIO_1		(INT_GPIO_BASE + 1)
#define INT_GPIO_2		(INT_GPIO_BASE + 2)
#define INT_GPIO_3		(INT_GPIO_BASE + 3)
#define INT_GPIO_4		(INT_GPIO_BASE + 4)
#define INT_GPIO_5		(INT_GPIO_BASE + 5)
#define INT_GPIO_6		(INT_GPIO_BASE + 6)
#define INT_GPIO_7		(INT_GPIO_BASE + 7)
#define INT_GPIO_8		(INT_GPIO_BASE + 8)
#define INT_GPIO_9		(INT_GPIO_BASE + 9)
#define INT_GPIO_10		(INT_GPIO_BASE + 10)
#define INT_GPIO_11		(INT_GPIO_BASE + 11)
#define INT_GPIO_12		(INT_GPIO_BASE + 12)
#define INT_GPIO_13		(INT_GPIO_BASE + 13)
#define INT_GPIO_14		(INT_GPIO_BASE + 14)
#define INT_GPIO_15		(INT_GPIO_BASE + 15)
#define INT_GPIO_16		(INT_GPIO_BASE + 16)
#define INT_GPIO_17		(INT_GPIO_BASE + 17)
#define INT_GPIO_18		(INT_GPIO_BASE + 18)
#define INT_GPIO_19		(INT_GPIO_BASE + 19)
#define INT_GPIO_20		(INT_GPIO_BASE + 20)
#define INT_GPIO_21		(INT_GPIO_BASE + 21)
#define INT_GPIO_22		(INT_GPIO_BASE + 22)
#define INT_GPIO_23		(INT_GPIO_BASE + 23)
#define INT_GPIO_24		(INT_GPIO_BASE + 24)
#define INT_GPIO_25		(INT_GPIO_BASE + 25)
#define INT_GPIO_26		(INT_GPIO_BASE + 26)
#define INT_GPIO_27		(INT_GPIO_BASE + 27)
#define INT_GPIO_28		(INT_GPIO_BASE + 28)
#define INT_GPIO_29		(INT_GPIO_BASE + 29)
#define INT_GPIO_30		(INT_GPIO_BASE + 30)
#define INT_GPIO_31		(INT_GPIO_BASE + 31)
#define INT_GPIO_32		(INT_GPIO_BASE + 32)
#define INT_GPIO_33		(INT_GPIO_BASE + 33)
#define INT_GPIO_34		(INT_GPIO_BASE + 34)
#define INT_GPIO_35		(INT_GPIO_BASE + 35)
#define INT_GPIO_36		(INT_GPIO_BASE + 36)
#define INT_GPIO_37		(INT_GPIO_BASE + 37)
#define INT_GPIO_38		(INT_GPIO_BASE + 38)
#define INT_GPIO_39		(INT_GPIO_BASE + 39)
#define INT_GPIO_40		(INT_GPIO_BASE + 40)
#define INT_GPIO_41		(INT_GPIO_BASE + 41)
#define INT_GPIO_42		(INT_GPIO_BASE + 42)
#define INT_GPIO_43		(INT_GPIO_BASE + 43)
#define INT_GPIO_44		(INT_GPIO_BASE + 44)
#define INT_GPIO_45		(INT_GPIO_BASE + 45)
#define INT_GPIO_46		(INT_GPIO_BASE + 46)
#define INT_GPIO_47		(INT_GPIO_BASE + 47)
#define INT_GPIO_48		(INT_GPIO_BASE + 48)
#define INT_GPIO_49		(INT_GPIO_BASE + 49)
#define INT_GPIO_50		(INT_GPIO_BASE + 50)
#define INT_GPIO_51		(INT_GPIO_BASE + 51)
#define INT_GPIO_52		(INT_GPIO_BASE + 52)
#define INT_GPIO_53		(INT_GPIO_BASE + 53)
#define INT_GPIO_54		(INT_GPIO_BASE + 54)
#define INT_GPIO_55		(INT_GPIO_BASE + 55)
#define INT_GPIO_56		(INT_GPIO_BASE + 56)
#define INT_GPIO_57		(INT_GPIO_BASE + 57)
#define INT_GPIO_58		(INT_GPIO_BASE + 58)
#define INT_GPIO_59		(INT_GPIO_BASE + 59)
#define INT_GPIO_60		(INT_GPIO_BASE + 60)
#define INT_GPIO_61		(INT_GPIO_BASE + 61)
#define INT_GPIO_62		(INT_GPIO_BASE + 62)
#define INT_GPIO_63		(INT_GPIO_BASE + 63)

#define INT_GPIO_LAST		INT_GPIO_63

#ifdef CONFIG_MP201
#define INT_GPIO_INTOUT		INT_GPIO_0
/* 2006.05.10 has */
#ifdef CONFIG_SONY_ICX1087
#define INT_GPIO_ETHER_INT	INT_GPIO_30
#else
#define INT_GPIO_ETHER_INT	INT_GPIO_2
#endif
#define INT_GPIO_TS_INT		INT_GPIO_3
#define INT_GPIO_EXT_INT	INT_GPIO_6
#define INT_GPIO_PWM1		INT_GPIO_7
#define INT_GPIO_PWM0		INT_GPIO_8
/* 2006.10.18 has */
#ifdef CONFIG_SONY_ICX1087
#define INT_GPIO_EXTUSB_INT	INT_GPIO_16
#endif
#else
#define INT_GPIO_PDCOMB2	INT_GPIO_0
#define INT_GPIO_SNDPDN		INT_GPIO_1
#define INT_GPIO_ETHER_RST	INT_GPIO_2
#define INT_GPIO_LCD_RSTZ	INT_GPIO_3
#define INT_GPIO_LCD_POWCNT	INT_GPIO_4
#define INT_GPIO_LCD_BL		INT_GPIO_5
#define INT_GPIO_MOD0_CDZ	INT_GPIO_6
#define INT_GPIO_MOD0_WPZ	INT_GPIO_7
#define INT_GPIO_CAM_RSTZ	INT_GPIO_8
#define INT_GPIO_CAM_CNT	INT_GPIO_9
#define INT_GPIO_TS_INT		INT_GPIO_10
#define INT_GPIO_EXT_INT	INT_GPIO_11
#define INT_GPIO_U73_CTSZ	INT_GPIO_14
#define INT_GPIO_U73_RSTZ	INT_GPIO_15
#define INT_GPIO_ELTANIN_INT	INT_GPIO_16
#define INT_GPIO_NAND_RDY	INT_GPIO_17
#define INT_GPIO_KEY_DATA0	INT_GPIO_18
#define INT_GPIO_KEY_DATA1	INT_GPIO_19
#define INT_GPIO_KEY_DATA2	INT_GPIO_20
#define INT_GPIO_KEY_DATA3	INT_GPIO_21
#define INT_GPIO_KEY_SCAN0	INT_GPIO_22
#define INT_GPIO_KEY_SCAN1	INT_GPIO_23
#define INT_GPIO_ETHER_INT	INT_GPIO_24
#define INT_GPIO_U73_SOUT	INT_GPIO_25
#define INT_GPIO_U73_SRIN	INT_GPIO_26
#define INT_GPIO_U72_CTSZ	INT_GPIO_27
#define INT_GPIO_U72_RTSZ	INT_GPIO_28
#define INT_GPIO_U72_SOUT	INT_GPIO_29
#define INT_GPIO_U72_SRIN	INT_GPIO_30
#define INT_GPIO_ETM_TRACESYNC	INT_GPIO_31
#define INT_GPIO_EXTCNT1	INT_GPIO_60
#define INT_GPIO_EXTCNT2	INT_GPIO_61
#define INT_GPIO_SNDCDA		INT_GPIO_62
#define INT_GPIO_EXTONZ		INT_GPIO_63
#endif				/* CONFIG_MP201 */

/*
 * IRQ Numbers for interrupts muxed through PWC
 */
#ifdef CONFIG_MP201
#define INT_PWC_MASK1_BASE	(INT_GPIO_LAST + 1)
#define INT_PWC_IO00		(INT_PWC_MASK1_BASE + 0)
#define INT_PWC_IO01		(INT_PWC_MASK1_BASE + 1)
#define INT_PWC_IO02		(INT_PWC_MASK1_BASE + 2)
#define INT_PWC_IO03		(INT_PWC_MASK1_BASE + 3)
#define INT_PWC_IO04		(INT_PWC_MASK1_BASE + 4)
#define INT_PWC_IO05		(INT_PWC_MASK1_BASE + 5)
#define INT_PWC_IO06		(INT_PWC_MASK1_BASE + 6)
#define INT_PWC_IO07		(INT_PWC_MASK1_BASE + 7)

#define INT_PWC_MASK1_LAST	INT_PWC_IO07

#define INT_PWC_MASK2_BASE	(INT_PWC_MASK1_LAST + 1)
#define INT_PWC_IO08		(INT_PWC_MASK2_BASE + 0)
#define INT_PWC_IO09		(INT_PWC_MASK2_BASE + 1)
#define INT_PWC_IO10		(INT_PWC_MASK2_BASE + 2)
#define INT_PWC_IO11		(INT_PWC_MASK2_BASE + 3)
#define INT_PWC_IO12		(INT_PWC_MASK2_BASE + 4)
#define INT_PWC_IO13		(INT_PWC_MASK2_BASE + 5)
#define INT_PWC_IO14		(INT_PWC_MASK2_BASE + 6)
#define INT_PWC_IO15		(INT_PWC_MASK2_BASE + 7)

#define INT_PWC_MASK2_LAST	INT_PWC_IO15

#define INT_PWC_MASK3_BASE	(INT_PWC_MASK2_LAST + 1)
#define INT_PWC_ADINT		(INT_PWC_MASK3_BASE + 0)
#define INT_PWC_RTCINT		(INT_PWC_MASK3_BASE + 1)
#define INT_PWC_CHGINT		(INT_PWC_MASK3_BASE + 2)
#define INT_PWC_PWOFINT		(INT_PWC_MASK3_BASE + 3)
#define INT_PWC_PWUPINT		(INT_PWC_MASK3_BASE + 4)
#define INT_PWC_USBWAKINT	(INT_PWC_MASK3_BASE + 4)
#define INT_PWC_DETBATINT	(INT_PWC_MASK3_BASE + 5)
#define INT_PWC_DETADPINT	(INT_PWC_MASK3_BASE + 6)
#define INT_PWC_DETUSBINT	(INT_PWC_MASK3_BASE + 7)

#define INT_PWC_MASK3_LAST	INT_PWC_DETUSBINT
#define INT_PWC_LAST		INT_PWC_MASK3_LAST

#define INT_PWC_GPIO_KEY_DATA0	INT_PWC_IO00
#define INT_PWC_GPIO_KEY_DATA1	INT_PWC_IO01
#define INT_PWC_GPIO_KEY_DATA2	INT_PWC_IO02
#define INT_PWC_GPIO_KEY_DATA3	INT_PWC_IO03
#define INT_PWC_GPIO_SDCDZ	INT_PWC_IO14
#define INT_PWC_GPIO_SDWP	INT_PWC_IO15
#else
#define INT_PWC_MASK2_BASE	(INT_GPIO_LAST + 1)
#define INT_PWC_OFINT		(INT_PWC_MASK2_BASE + 0)
#define INT_PWC_IO01		(INT_PWC_MASK2_BASE + 1)
#define INT_PWC_IO02		(INT_PWC_MASK2_BASE + 2)
#define INT_PWC_IO03		(INT_PWC_MASK2_BASE + 3)
#define INT_PWC_IO04		(INT_PWC_MASK2_BASE + 4)
#define INT_PWC_IO05		(INT_PWC_MASK2_BASE + 5)
#define INT_PWC_IO06		(INT_PWC_MASK2_BASE + 6)
#define INT_PWC_RTCINT		(INT_PWC_MASK2_BASE + 7)

#define INT_PWC_MASK2_LAST	INT_PWC_RTCINT

#define INT_PWC_MASK3_BASE	(INT_PWC_MASK2_LAST + 1)
#define INT_PWC_TVINT		(INT_PWC_MASK3_BASE + 0)
#define INT_PWC_IRINT		(INT_PWC_MASK3_BASE + 1)
#define INT_PWC_USBINT		(INT_PWC_MASK3_BASE + 2)
#define INT_PWC_DDINT		(INT_PWC_MASK3_BASE + 3)

#define INT_PWC_MASK3_LAST	INT_PWC_DDINT
#define INT_PWC_LAST		INT_PWC_MASK3_LAST
#endif				/* CONFIG_MP201 */

/* 
 *  IRQ interrupts definitions are the same as INT definitions
 */
#ifdef CONFIG_MP201
#define IRQ_UARTINT0		INT_UART0

#define IRQ_TIMERINT0		INT_TI0
#define IRQ_TIMERINT1		INT_TI1
#define IRQ_TIMERINT2		INT_TI2
#define IRQ_TIMERINT3		INT_TI3
#define IRQ_TIMERINT4		INT_TI4
#define IRQ_TIMERINT5		INT_TI5
#else
#define IRQ_UARTINT0		INT_UART0
#define IRQ_UARTINT1		INT_UART1
#define IRQ_UARTINT2		INT_UART2
#define IRQ_UARTINT3		INT_UART3

#define IRQ_TIMERINT0		INT_TIMER0
#define IRQ_TIMERINT1		INT_TIMER1
#define IRQ_TIMERINT2		INT_TIMER2
#endif				/* CONFIG_MP201 */

#define MAXIRQNUM		INT_PWC_LAST
#define MAXFIQNUM		MAXIRQNUM
#define MAXSWINUM		MAXIRQNUM

#define NR_IRQS			(MAXIRQNUM + 1)

/*
 * Interrupt detection
 */
#ifdef CONFIG_MP201
#define __IRQT_ASYNC		(1 << 31)

#define IRQT_RISING_ASYNC	(IRQT_RISING | __IRQT_ASYNC)
#define IRQT_FALLING_ASYNC	(IRQT_FALLING | __IRQT_ASYNC)
#define IRQT_BOTHEDGE_ASYNC	(IRQT_BOTHEDGE | __IRQT_ASYNC)
#else
#define __IRQT_32KPLS		(1 << 31)
#endif				/* CONFIG_MP201 */

#ifndef __ASSEMBLY__
extern void mp200_init_irq(void);
#endif

#include <asm/arch/hardware.h>

/* 
 * Define the timer interrupt for PREEMPT_RT case
 */
#ifdef CONFIG_MP201
#define ARCH_TIMER_IRQ		INT_TI0
#else
#define ARCH_TIMER_IRQ		INT_TIMER0
#endif				/* CONFIG_MP201 */

#endif				/* __ASM_ARM_ARCH_MP200_IRQS_H */
