/*
 *  File Name       : linux/include/asm-arm/arch-mp200/mp200_board.h
 *  Function        : mp200_board
 *  Release Version : Ver 1.01
 *  Release Date    : 2006/02/22
 *
 *  Copyright (C) NEC Electronics Corporation 2005-2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef __ASM_ARCH_MP200_BOARD_H
#define __ASM_ARCH_MP200_BOARD_H

/* BANK 0 -- ASYNC0 1/3 [FLASH] */
#define MP200_BANK0_BASE	0x00000000

#define MP200_FLASH_BASE	MP200_BANK0_BASE
#define MP200_FLASH_SIZE	(SZ_32M * 2)

#ifndef CONFIG_MP201
#define MP200_NAND_IO_BASE      MP200_BANK0_BASE + MP200_FLASH_SIZE
#define MP200_NAND_IO_SIZE      0x10
#endif

/* BANK 1 -- ASYNC0 2/3 [FLASH] not yet HN2 */
#define MP200_BANK1_BASE	0x10000000

/* BANK 2 -- ASYNC0 3/3 [LCD] */
#define MP200_BANK2_BASE	0x20000000

#define MP200_ETHER_OFFSET	0x00010000
#define MP200_ETHER_SIZE	SZ_64K

/* 2006.10.19 has */
#ifdef CONFIG_SONY_ICX1087
#define MP200_EXTUSB_OFFSET	0x00080000
#define MP200_EXTUSB_SIZE	SZ_64K
#endif

/* 2006.10.19 has */
#ifndef CONFIG_SONY_ICX1087
#define MP200_EXTDEVICE_OFFSET	0x00050000
#define MP200_EXTDEVICE_SIZE	SZ_64K
#endif

#define MP200_ASYNC0_OFFSET	0x0fff0000
#define MP200_ASYNC0_SIZE	SZ_64K

#define MP200_ETHER_BASE	(MP200_BANK2_BASE + MP200_ETHER_OFFSET)

/* 2006.10.19 has */
#ifdef CONFIG_SONY_ICX1087
#define MP200_EXTUSB_BASE	(MP200_BANK2_BASE + MP200_EXTUSB_OFFSET)
#endif

/* 2006.10.19 has */
#ifndef CONFIG_SONY_ICX1087
#define MP200_EXTDEVICE_BASE	(MP200_BANK2_BASE + MP200_EXTDEVICE_OFFSET)
#endif

#define MP200_ASYNC0_BASE	(MP200_BANK2_BASE + MP200_ASYNC0_OFFSET)

#endif				/* __ASM_ARCH_MP200_BOARD_H */
