/*
 *  File Name       : arch-mp200/mp200_cam.h
 *  Function        : CAMERA I/F Driver
 *  Release Version : Ver 1.00
 *  Release Date    : 2005/07/15
 *
 *  Copyright (C) NEC Electronics Corporation 2005
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */
#ifndef MP200_CAM_IOCTL_H
#define MP200_CAM_IOCTL_H

typedef struct mp200_cam_gain {
        unsigned char y_gain;
        unsigned char u_gain;
        unsigned char v_gain;
        char y_offset;
        char u_offset;
        char v_offset;
} MP200_CAM_GAIN;

#define MP200_CAM_CID_HFLIP 0x00000001
#define MP200_CAM_CID_VFLIP 0x00000002

/*
 *  1 : IMG processor mode
 *  2 : CPU convert mode
 *  3 : MP200 YUV plane mode
 */
#define MP200_CAM_MODES_IMGPR		_IO('C', 0x01)
#define MP200_CAM_MODES_CPUCV 		_IO('C', 0x02)
#define MP200_CAM_MODES_MP200YUV	_IO('C', 0x03)
#define MP200_CAM_GET_MODE		_IOR('C',0x04,unsigned int)

/* Camera angle Portrait or Landscape */
#define MP200_CAM_ROTATION_PORTRAIT	_IO('C', 0x05)
#define MP200_CAM_ROTATION_LANDSCAPE	_IO('C', 0x06)
#define MP200_CAM_GET_ROTATION 		_IOR('C',0x07,unsigned int)

/* Camera gain adjust */
#define MP200_CAM_S_GAIN		_IOW('C',0x08,struct mp200_cam_gain*)
#define MP200_CAM_G_GAIN		_IOR('C',0x09,struct mp200_cam_gain*)

/* Camera mirror control */
#define MP200_CAM_G_CTRL		_IOW('C',0x0a,int*)
#define MP200_CAM_S_CTRL		_IOR('C',0x0b,int*)

#endif /* MP200_CAM_IOCTL_H */

