/*
 * mp200_pm_ext.h -- MP200 PM extention interface.
 *
 * Copyright 2006 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef MP200_PM_EXT_H
#define MP200_PM_EXT_H

#include <asm/ioctl.h>


#define MP200_PM_EXT_IOC_MAGIC  'p'

#define MP200_PM_EXT_GET_FACTOR _IOR(MP200_PM_EXT_IOC_MAGIC, 0, int)

#define MP200_PM_EXT_FACTOR_USB 0x8000
#define MP200_PM_EXT_FACTOR_ADP 0x4000
#define MP200_PM_EXT_FACTOR_RTC 0x0200


int mp200_pm_ext_notify(int nFactor);


#endif /* MP200_PM_EXT_H */

