/*
 *  File Name       : arch-mp200/ntsc_ioctl.h
 *  Function        : NTSC I/F Driver
 *  Release Version : Ver 1.00
 *  Release Date    : 2005/07/15
 *
 *  Copyright (C) NEC Electronics Corporation 2005
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of 
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2 
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program; 
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, 
 *  MA 02111-1307, USA.
 *
 */

#ifndef MP200_NTSC_IOCTL_H
#define MP200_NTSC_IOCTL_H

#include <asm/ioctl.h>

#define NTSC_MAX_FRAME          3

struct ntsc_fbuf
{
        int voffset;
        unsigned long paddr;
};

struct ntsc_mbuf
{
        int     vsize;
        int     nframe;
        struct ntsc_fbuf frame[NTSC_MAX_FRAME];
};

/*
 *  Control
 */
#define NTSC_SET_OUTMODE	_IOW('N',0x01,int*)
#define NTSC_GET_OUTMODE	_IOR('N',0x02,int*)
#define NTSC_BLUEBACK		_IO ('N',0x03)
#define NTSC_BLACKBACK		_IO ('N',0x04)
#define NTSC_SYNC		_IOW('N',0x05,int*)
#define NTSC_QBUF		_IOW('N',0x06,int*)
#define NTSC_GMBUF		_IOR('N',0x07,struct ntsc_mbuf*)
#define NTSC_SET_TIMEOUT	_IOW('N',0x08,int*)
#define NTSC_GET_TIMEOUT	_IOR('N',0x09,int*)

#endif
