/*
 *  File Name       : linux/include/asm-arm/arch-mp200/pwc.h
 *  Function        : pwc
 *  Release Version : Ver 1.02
 *  Release Date    : 2006/07/27
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef __ASM_ARM_ARCH_MP200_PWC_H
#define __ASM_ARM_ARCH_MP200_PWC_H

#define PWC_INT_B0		0x00
#define PWC_INT_B1		0x01
#define PWC_INT_B2		0x02
#define PWC_INT_B3		0x03
#define PWC_INT_B4		0x04
#define PWC_INT_B5		0x05
#define PWC_INT_B6		0x06
#define PWC_INT_B7		0x07
#define PWC_INT_MAX		0x07

/* board specific */
#ifdef CONFIG_MP201
#define PWC_INT_IO00		PWC_INT_B0
#define PWC_INT_IO01		PWC_INT_B1
#define PWC_INT_IO02		PWC_INT_B2
#define PWC_INT_IO03		PWC_INT_B3
#define PWC_INT_IO04		PWC_INT_B4
#define PWC_INT_IO05		PWC_INT_B5
#define PWC_INT_IO06		PWC_INT_B6
#define PWC_INT_IO07		PWC_INT_B7

#define PWC_INT_IO08		PWC_INT_B0
#define PWC_INT_IO09		PWC_INT_B1
#define PWC_INT_IO10		PWC_INT_B2
#define PWC_INT_IO11		PWC_INT_B3
#define PWC_INT_IO12		PWC_INT_B4
#define PWC_INT_IO13		PWC_INT_B5
#define PWC_INT_IO14		PWC_INT_B6
#define PWC_INT_IO15		PWC_INT_B7

#define PWC_INT_ADINT		PWC_INT_B0
#define PWC_INT_RTCINT		PWC_INT_B1
#define PWC_INT_CHGINT		PWC_INT_B2
#define PWC_INT_PWOFINT		PWC_INT_B3
#define PWC_INT_PWUPINT		PWC_INT_B4
#define PWC_INT_USBWAKINT	PWC_INT_B4
#define PWC_INT_DETBATINT	PWC_INT_B5
#define PWC_INT_DETADPINT	PWC_INT_B6
#define PWC_INT_DETUSBINT	PWC_INT_B7

#define PWC_INT_KEY_DATA0	PWC_INT_IO00
#define PWC_INT_KEY_DATA1	PWC_INT_IO01
#define PWC_INT_KEY_DATA2	PWC_INT_IO02
#define PWC_INT_KEY_DATA3	PWC_INT_IO03
#define PWC_INT_KEY_SCAN_D	PWC_INT_IO04
#define PWC_INT_KEY_SCAN_P	PWC_INT_IO05
#define PWC_INT_KEY_SCAN_E	PWC_INT_IO06
#define PWC_INT_ETHER_RST	PWC_INT_IO07
#define PWC_INT_SNDCDA		PWC_INT_IO08
#define PWC_INT_SNDPDN		PWC_INT_IO09
#define PWC_INT_LED_ON		PWC_INT_IO10
#define PWC_INT_LCD_OE		PWC_INT_IO11
#define PWC_INT_CAM_RSTZ	PWC_INT_IO12
#define PWC_INT_CAM_CNT		PWC_INT_IO13
#define PWC_INT_SDCDZ		PWC_INT_IO14
#define PWC_INT_SDWP		PWC_INT_IO15
#else
#define PWC_INT_OFINT		PWC_INT_B0
#define PWC_INT_IO01		PWC_INT_B1
#define PWC_INT_IO02		PWC_INT_B2
#define PWC_INT_IO03		PWC_INT_B3
#define PWC_INT_IO04		PWC_INT_B4
#define PWC_INT_IO05		PWC_INT_B5
#define PWC_INT_IO06		PWC_INT_B6
#define PWC_INT_RTCINT		PWC_INT_B7

#define PWC_INT_INTMODE		PWC_INT_B0
#define PWC_INT_INTRETRY	PWC_INT_B1

#define PWC_INT_IRINT		PWC_INT_B0
#define PWC_INT_DDINT		PWC_INT_B1

#define PWC_INT_VBUSL		PWC_INT_B0
#define PWC_INT_VBUSM		PWC_INT_B1
#define PWC_INT_VBUSH		PWC_INT_B2
#define PWC_INT_ID		PWC_INT_B3
#define PWC_INT_DPSRP		PWC_INT_B4
#define PWC_INT_BDISACON	PWC_INT_B5
#define PWC_INT_TVINT		PWC_INT_B6
#define PWC_INT_VBUSDET		PWC_INT_B7

#define PWC_INT_TVINTG		PWC_INT_B0
#define PWC_INT_IRINTG		PWC_INT_B1
#define PWC_INT_USBINTG		PWC_INT_B2
#define PWC_INT_DDINTG		PWC_INT_B3
#endif				/* CONFIG_MP201 */

/* PWC registers */
#ifdef CONFIG_MP201
#define PWC_REGA		0x0002	/* write */
#define PWC_PSCNT1		0x0004	/* write */
#define PWC_PSCNT2		0x0006	/* write */
#define PWC_MODESET1		0x0008	/* write */
#define PWC_VOUTSET1		0x000A	/* write */
#define PWC_VOUTSET2		0x000C	/* write */
#define PWC_VOUTSET3		0x000E	/* write */
#define PWC_IOSEL1		0x0010	/* write */
#define PWC_IOSEL2		0x0012	/* write */
#define PWC_IOOUT1		0x0014	/* write */
#define PWC_IOIN1		0x0015	/* read  */
#define PWC_IOOUT2		0x0016	/* write */
#define PWC_IOIN2		0x0017	/* read  */
#define PWC_GPPUPD1		0x0018	/* write */
#define PWC_GPPUPD2		0x001A	/* write */
#define PWC_GPPUPD3		0x001C	/* write */
#define PWC_GPPUPD4		0x001E	/* write */
#define PWC_FMASK1		0x0020	/* write */
#define PWC_FACTOR1		0x0021	/* read  */
#define PWC_FMASK2		0x0022	/* write */
#define PWC_FACTOR2		0x0023	/* read  */
#define PWC_FMASK3		0x0024	/* write */
#define PWC_FACTOR3		0x0025	/* read  */
#define PWC_STATE1		0x0026	/* write */
#define PWC_STATE2		0x0028	/* write */
#define PWC_STATE3		0x002A	/* write */
#define PWC_CLRFACT1		0x002C	/* write */
#define PWC_CLRFACT2		0x002E	/* write */
#define PWC_CLRFACT3		0x0030	/* write */
#define PWC_DETMOD1L		0x0032	/* write */
#define PWC_DETMOD1H		0x0034	/* write */
#define PWC_DETMOD2L		0x0036	/* write */
#define PWC_DETMOD2H		0x0038	/* write */
#define PWC_DETMOD3L		0x003A	/* write */
#define PWC_DETMOD3H		0x003C	/* write */
#define PWC_BMASK1		0x003E	/* write */
#define PWC_BMASK2		0x0040	/* write */
#define PWC_BMASK3		0x0042	/* write */
#define PWC_REGRSTMSK1		0x0044	/* write */
#define PWC_REGRSTMSK2		0x0046	/* write */
#define PWC_SYSRSTMSK1		0x0048	/* write */
#define PWC_SYSRSTMSK2		0x004A	/* write */
#define PWC_REGPWONMSK		0x004C	/* write */
#define PWC_ADDATA1		0x004D	/* read  */
#define PWC_ADMODE		0x004E	/* write */
#define PWC_ADDATA2		0x004F	/* read  */
#define PWC_VCCVBATSW		0x0050	/* write */
#define PWC_ADDATA3		0x0051	/* read  */
#define PWC_VCCADPSW		0x0052	/* write */
#define PWC_VCCVBUSSW		0x0052	/* write */
#define PWC_ADDATA4		0x0053	/* read  */
#define PWC_ADDATA5		0x0055	/* read  */
#define PWC_ADDATA6		0x0057	/* read  */
#define PWC_ADDATA7		0x0059	/* read  */
#define PWC_ADDATA8		0x005B	/* read  */
#define PWC_CHGCNTR1		0x005C	/* write */
#define PWC_CHGIRR		0x005D	/* read  */
#define PWC_CHGIRCL		0x005E	/* write */
#define PWC_CHGSTATE		0x005F	/* read  */
#define PWC_TIMCNTR		0x0060	/* write */
#define PWC_CVSETR		0x0062	/* write */
#define PWC_CHGCNTR2		0x0064	/* write */
#define PWC_PSW_STATE		0x0065	/* read  */
#define PWC_SFTRST		0x0066	/* write */
#define PWC_RDET_EN		0x0068	/* write */
#define PWC_PWRSWCONT		0x006A	/* write */
#define PWC_DETIOCONT		0x006C	/* write */
#define PWC_WRSTFCT		0x006D	/* read  */
#define PWC_WRSTCL		0x006E	/* write */
#define PWC_LSIVER		0x006F	/* read  */
#define PWC_SEC			0x0070	/* write */
#define PWC_SEC_RD		0x0071	/* read  */
#define PWC_MIN			0x0072	/* write */
#define PWC_MIN_RD		0x0073	/* read  */
#define PWC_HOUR		0x0074	/* write */
#define PWC_HOUR_RD		0x0075	/* read  */
#define PWC_WEEK		0x0076	/* write */
#define PWC_WEEK_RD		0x0077	/* read  */
#define PWC_DAY			0x0078	/* write */
#define PWC_DAY_RD		0x0079	/* read  */
#define PWC_MONTH		0x007A	/* write */
#define PWC_MONTH_RD		0x007B	/* read  */
#define PWC_YEAR		0x007C	/* write */
#define PWC_YEAR_RD		0x007D	/* read  */
#define PWC_TRIM		0x007E	/* write */
#define PWC_TRIM_RD		0x007F	/* read  */
#define PWC_ALM_WM		0x0080	/* write */
#define PWC_ALM_WM_RD		0x0081	/* read  */
#define PWC_ALM_WH		0x0082	/* write */
#define PWC_ALM_WH_RD		0x0083	/* read  */
#define PWC_ALM_WW		0x0084	/* write */
#define PWC_ALM_WW_RD		0x0085	/* read  */
#define PWC_ALM_DM		0x0086	/* write */
#define PWC_ALM_DM_RD		0x0087	/* read  */
#define PWC_ALM_DH		0x0088	/* write */
#define PWC_ALM_DH_RD		0x0089	/* read  */
#define PWC_RTC1		0x008A	/* write */
#define PWC_RTC1_RD		0x008B	/* read  */
#define PWC_RTC2		0x008C	/* write */
#define PWC_RTC2_RD		0x008D	/* read  */
#define PWC_USBCONT		0x0090	/* write */
#define PWC_WRSTMSK		0x0092	/* write */
#define PWC_WAKECONT		0x0094	/* write */

#define PWC_MAX			0x0095
#else
#define PWC_INTCLR2		0x000E
#define PWC_CLRMODE		0x0010
#define PWC_INTCLR		0x0011
#define PWC_BKUP2		0x0012
#define PWC_BKUP2_RD		0x0013
#define PWC_BKUP3		0x0014
#define PWC_BKUP3_RD		0x0015
#define PWC_BKUP4		0x0016
#define PWC_BKUP4_RD		0x0017
#define PWC_BKUP5		0x0018
#define PWC_BKUP5_RD		0x0019
#define PWC_BKUP6		0x001A
#define PWC_BKUP6_RD		0x001B
#define PWC_BKUP7		0x001C
#define PWC_BKUP7_RD		0x001D
#define PWC_BKUP8		0x001E
#define PWC_BKUP8_RD		0x001F
#define PWC_INTR3		0x0020
#define PWC_INTM3		0x0021
#define PWC_INTCLR3		0x0022
#define PWC_VFBMON		0x0023
#define PWC_MCARD		0x0024
#define PWC_REGMODE		0x0025
#define PWC_MODESET		0x0026
#define PWC_USBPDB		0x0027
#define PWC_USBSW		0x0028
#define PWC_MCARDEN		0x0029
#define PWC_PWR_C_H_C		0x002A
#define PWC_PWR_C_H_R		0x002B
#define PWC_BKUP1		0x002C
#define PWC_BKUP1_RD		0x002D
#define PWC_STEP		0x002E

#define PWC_RGBCNT1		0x0030
#define PWC_RGBCNT2		0x0031
#define PWC_RPWMON		0x0032
#define PWC_RPWMOFF		0x0033
#define PWC_GPWMON		0x0034
#define PWC_GPWMOFF		0x0035
#define PWC_BPWMON		0x0036
#define PWC_BPWMOFF		0x0037
#define PWC_LPWMON		0x0038
#define PWC_LPWMOFF		0x0039
#define PWC_PWMMODE		0x003A
#define PWC_USBINTM		0x003B
#define PWC_USBINTR		0x003C
#define PWC_USBINT		0x003D
#define PWC_LED			0x003E

#define PWC_PSCONT		0x0040
#define PWC_DDCONT		0x0041
#define PWC_DDPWM		0x0042
#define PWC_VFBSET		0x0043
#define PWC_PSCNT2		0x0044
#define PWC_REGL0VAL		0x0045
#define PWC_DDVFM		0x0046
#define PWC_TVCNT		0x0047
#define PWC_RSTMASK		0x0048
#define PWC_SFTRST		0x0049
#define PWC_RDET_EN		0x004A
#define PWC_RSTFACTCLR		0x004B
#define PWC_RSTFACTOR		0x004C
#define PWC_RSTRD		0x004D
#define PWC_COUNTCLR		0x004E
#define PWC_MASK3		0x004F

#define PWC_IOSEL2		0x0050
#define PWC_MASK2		0x0051
#define PWC_IOOUT2		0x0052
#define PWC_IOOUTSEL		0x0053
#define PWC_FACTOR2		0x0054
#define PWC_IOSTATE2		0x0055
#define PWC_CHTTIM1H		0x0056
#define PWC_CHTTIM2H		0x0057
#define PWC_PSCNTA		0x0058

#define PWC_SEC			0x0060
#define PWC_MIN			0x0061
#define PWC_HOUR		0x0062
#define PWC_WEEK		0x0063
#define PWC_DAY			0x0064
#define PWC_MONTH		0x0065
#define PWC_YEAR		0x0066
#define PWC_TRIM		0x0067
#define PWC_ALM_WM		0x0068
#define PWC_ALM_WH		0x0069
#define PWC_ALM_WW		0x006A
#define PWC_ALM_DM		0x006B
#define PWC_ALM_DH		0x006C
#define PWC_RTC1		0x006D
#define PWC_RTC2		0x006E
#define PWC_PDBRTC		0x006F

#define PWC_SEC_RD		0x0070
#define PWC_MIN_RD		0x0071
#define PWC_HOUR_RD		0x0072
#define PWC_WEEK_RD		0x0073
#define PWC_DAY_RD		0x0074
#define PWC_MONTH_RD		0x0075
#define PWC_YEAR_RD		0x0076
#define PWC_TRIM_RD		0x0077
#define PWC_ALM_WM_RD		0x0078
#define PWC_ALM_WH_RD		0x0079
#define PWC_ALM_WW_RD		0x007A
#define PWC_ALM_DM_RD		0x007B
#define PWC_ALM_DH_RD		0x007C
#define PWC_RTC1_RD		0x007D
#define PWC_RTC2_RD		0x007E
#define PWC_LSIVER		0x007F

#define PWC_IRCNT1		0x0080
#define PWC_IRCNT2		0x0081
#define PWC_IRBCK		0x0082
#define PWC_IRCL1		0x0083
#define PWC_IRCL2		0x0084
#define PWC_IRCH1		0x0085
#define PWC_IRCH2		0x0086
#define PWC_IRHL1		0x0087
#define PWC_IRHL0		0x0088
#define PWC_IRHH1		0x0089
#define PWC_IRHH0		0x008A
#define PWC_IRD0L1		0x008B
#define PWC_IRD0L0		0x008C
#define PWC_IRD0H1		0x008D
#define PWC_IRD0H0		0x008E
#define PWC_IRD1L1		0x008F
#define PWC_IRD1L0		0x0090
#define PWC_IRD1H1		0x0091
#define PWC_IRD1H0		0x0092
#define PWC_IREND1		0x0093
#define PWC_IREND0		0x0094
#define PWC_IRBIT		0x0095
#define PWC_IRFRM1		0x0096
#define PWC_IRFRM0		0x0097
#define PWC_IROUT0A		0x0098
#define PWC_IROUT1A		0x0099
#define PWC_IROUT2A		0x009A
#define PWC_IROUT3A		0x009B
#define PWC_IROUT4A		0x009C
#define PWC_IROUT5A		0x009D
#define PWC_IROUT6A		0x00A0
#define PWC_IROUT7A		0x00A1
#define PWC_IROUT0B		0x00A2
#define PWC_IROUT1B		0x00A3
#define PWC_IROUT2B		0x00A4
#define PWC_IROUT3B		0x00A5
#define PWC_IROUT4B		0x00A6
#define PWC_IROUT5B		0x00A7
#define PWC_IROUT6B		0x00A8
#define PWC_IROUT7B		0x00A9

#define PWC_IRRQC		0x00AA
#define PWC_IRSND		0x00AC
#define PWC_IRRST		0x00AD

#define PWC_ENCCTRL0		0x00D0
#define PWC_CCEH		0x00D1
#define PWC_CCEL		0x00D2
#define PWC_CCOH		0x00D3
#define PWC_CCOL		0x00D4
#define PWC_CGMS_WSSR		0x00D5
#define PWC_CGMS_WSSR1		0x00D6
#define PWC_CGMS_WSSR2		0x00D7
#define PWC_MACROV0		0x00D8
#define PWC_MACROV1		0x00D9
#define PWC_MACROV2		0x00DA
#define PWC_MACROV3		0x00DB
#define PWC_MACROV4		0x00DC
#define PWC_MACROV5		0x00DD
#define PWC_MACROV6		0x00DE
#define PWC_MACROV7		0x00DF
#define PWC_MACROV8		0x00E0
#define PWC_MACROV9		0x00E1
#define PWC_MACROV10		0x00E2
#define PWC_MACROV11		0x00E3
#define PWC_MACROV12		0x00E4
#define PWC_MACROV13		0x00E5
#define PWC_MACROV14		0x00E6
#define PWC_MACROV15		0x00E7
#define PWC_MACROV16		0x00E8
#define PWC_MACROV17		0x00E9
#define PWC_MACROV18		0x00EA

#define PWC_MAX			0x0100
#endif				/* CONFIG_MP201 */

/* 2006.07.21 has */
#ifdef CONFIG_SONY_ICX1087

#define PWC_PSCNTMIC 0x00001004
#define PWC_PSCNTLOG 0x00010804
#define PWC_PSCNTHP  0x00020404
#define PWC_PSCNTANA 0x00030204
#define PWC_PSCNTDSP 0x00040104
#define PWC_PSCNTGP5 0x00050806
#define PWC_PSCNTGP4 0x00060406
#define PWC_PSCNTGP3 0x00070206
#define PWC_PSCNTGP2 0x00080106

#define PWC_MAX_REGULATOR 9

#endif

extern int pwc_read(unsigned short offset, unsigned int *data);
extern int pwc_write(unsigned short offset, unsigned int data,
		     unsigned int mask);

/* 2006.07.21 has */
#ifdef CONFIG_SONY_ICX1087
extern int pwc_regulator_on(unsigned long regulator);
extern int pwc_regulator_off(unsigned long regulator);
#endif

#endif				/* __ASM_ARM_ARCH_MP200_PWC_H */
