/*
 *  File Name	    : linux/include/asm-arm/arch-mp200/smu.h
 *  Function	    : smu
 *  Release Version : Ver 1.00
 *  Release Date    : 2005/10/20
 *
 *  Copyright (C) NEC Electronics Corporation 2005
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_SMU_H
#define __ASM_ARM_ARCH_MP200_SMU_H

/* SMU register */

#ifdef CONFIG_MP201
/* for MP201 */
#define SMU_RESETREQ0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0000)
#define SMU_RESETREQ1A		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0004)
#define SMU_RESETREQ1B		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0008)
#define SMU_RESETREQDSP		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x000C)
#define SMU_RESETREQ0_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0010)
#define SMU_RESETREQ1A_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0014)
#define SMU_RESETREQ1B_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0018)
#define SMU_RESETREQDSP_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x001C)
#define SMU_WDT_INT_RESET	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0020)

#define SMU_PLLSEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0040)
#define SMU_PLLSEL2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0044)
#define SMU_CLK_DOMAIN_DIV	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0048)
#define SMU_OSC_CTRL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x004C)
#define SMU_LPLL_CTRL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0050)
#define SMU_LPLL_CTRL2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0054)
#define SMU_HPLL_CTRL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0058)
#define SMU_HPLL_CTRL2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x005C)
#define SMU_HPLL_CTRL3		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0060)
#define SMU_HPLL_CTRL4		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0064)
#define SMU_PLLLOCK_CTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0068)

#define SMU_GCLKCTRL0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0080)
#define SMU_GCLKCTRL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0084)
#define SMU_GCLKCTRL2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0088)
#define SMU_GCLKCTRL0_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x008C)
#define SMU_GCLKCTRL1_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0090)
#define SMU_GCLKCTRL2_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0094)
#define SMU_GCLKEN_POL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0098)
#define SMU_AHBCLKCTRL0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00A0)
#define SMU_AHBCLKCTRL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00A4)
#define SMU_APBCLKCTRL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00A8)
#define SMU_CLKCTRL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00AC)
#define SMU_AUTO_FRQ_CHANGE	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00B0)
#define SMU_PLL_DOWN_EN		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00B4)
#define SMU_GCLKCTRLTST		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00B8)
#define SMU_GCLKCTRLTST_ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00BC)
#define SMU_CLKSTOPSIG_ST	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00E0)

#define SMU_LCD_LCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0100)
#define SMU_CAM_SCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0104)
#define SMU_ATA_DCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0108)
#define SMU_U70_SCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x010C)
#define SMU_PM0_SCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0110)
#define SMU_PM1_SCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0114)
#define SMU_GIO_INT_CLK_SEL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0118)
#define SMU_STM_SCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x011C)
#define SMU_TI0_TIN_SEL         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0120)
#define SMU_TI1_TIN_SEL         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0124)
#define SMU_PWM_SCLK_SEL        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0128)
#define SMU_REFCLKO_SEL         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x012C)
#define SMU_LCD_LCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0130)
#define SMU_TFD_LCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0134)
#define SMU_CAM_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0138)
#define SMU_ATA_DCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x013C)
#define SMU_SPI0_SCLK_DIV       (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0140)
#define SMU_SPI1_SCLK_DIV       (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0144)
#define SMU_U70_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0148)
#define SMU_IIC_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x014C)
#define SMU_PM0_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0150)
#define SMU_PM1_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0154)
#define SMU_MWI_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0158)
#define SMU_SDM_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x015C)
#define SMU_MSP_SCLK_DIV        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0160)
#define SMU_REFCLKO_DIV         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0164)

#define SMU_INT_STATUS          (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0190)
#define SMU_INT_RAW_STATUS      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0194)
#define SMU_INT_ENSET           (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0198)
#define SMU_INT_ENCLR           (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x019C)
#define SMU_INT_ENMON           (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01A0)
#define SMU_INT_CLEAR           (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01A4)

#define SMU_FLASHCLK_DLY        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01C0)
#define SMU_SDR_CLK_DLY         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01C4)
#define SMU_SDR_UDCLK_DLY       (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01C8)
#define SMU_SDR_LDCLK_DLY       (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01CC)

#define SMU_PCTL_ASYNC		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0200)
#define SMU_PCTL_SDR		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0204)
#define SMU_PCTL_NAND		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0208)
#define SMU_PCTL_C1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x020C)
#define SMU_PCTL_DJTAG		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0210)
#define SMU_PCTL_CAM		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0214)
#define SMU_GIOCTL_PM1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0218)
#define SMU_PCTL_SPI		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x021C)
#define SMU_PCTL_C2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0220)
#define SMU_PULLCTL_ASYNC       (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0224)
#define SMU_PULLCTL_SDR         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0228)
#define SMU_PULLCTL_NAND        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x022C)
#define SMU_PULLCTL_P1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0230)
#define SMU_PULLCTL_CPUDEBUG    (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0234)
#define SMU_PULLCTL_DSPDEBUG    (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0238)
#define SMU_PULLCTL_CAM         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x023C)
#define SMU_PULLCTL_PCM		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0240)
#define SMU_PULLCTL_SPI         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0244)
#define SMU_PULLCTL_P2          (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0248)
#define SMU_PULLCTL_TEST        (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x024C)
#define SMU_DRV_LCD		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0250)
#define SMU_DRV_SDRAM		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0254)
#define SMU_DRV_D1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0258)
#define SMU_DRV_D2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x025C)

#define SMU_SMU_RESET_STATE     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0280)
#define SMU_MODE_ST             (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0284)
#define SMU_SMU_GPO             (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0288)

#define SMU_AB0_CS0BASEADD      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0300)
#define SMU_AB0_CS1BASEADD      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0304)
#define SMU_AB0_CS2BASEADD      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0308)
#define SMU_AB0_CS3BASEADD      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x030C)
#define SMU_AB0_CS0BITCOMP      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0310)
#define SMU_AB0_CS1BITCOMP      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0314)
#define SMU_AB0_CS2BITCOMP      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0318)
#define SMU_AB0_CS3BITCOMP      (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x031C)
#define SMU_AB0_CS0WAITCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0320)
#define SMU_AB0_CS1WAITCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0324)
#define SMU_AB0_CS2WAITCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0328)
#define SMU_AB0_CS3WAITCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x032C)
#define SMU_AB0_CS0READCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0330)
#define SMU_AB0_CS1READCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0334)
#define SMU_AB0_CS2READCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0338)
#define SMU_AB0_CS3READCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x033C)
#define SMU_AB0_FLASHCLKCTRL    (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0340)
#define SMU_AB0_CS0WAITCTRL_W   (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0344)
#define SMU_AB0_CS1WAITCTRL_W   (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0348)
#define SMU_AB0_CS2WAITCTRL_W   (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x034C)
#define SMU_AB0_CS3WAITCTRL_W   (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0350)

#define SMU_AB0_FLASHRCR	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0354)
#define SMU_AB0_FLASHCOMADD0	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0360)
#define SMU_AB0_FLASHCOMDATA0	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0364)
#define SMU_AB0_FLASHCOMADD1	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0368)
#define SMU_AB0_FLASHCOMDATA1	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x036C)

#define SMU_AB1_U70WAITCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0380)
#define SMU_AB1_U70READCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0384)
#define SMU_AB1_IICWAITCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0388)
#define SMU_AB1_IICREADCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x038C)
#define SMU_AB1_SDMWAITCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0390)
#define SMU_AB1_SDMREADCTRL     (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0394)

#define SMU_CPI_OFFSET0         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03A0)
#define SMU_CPI_OFFSET1         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03A4)
#define SMU_CPI_OFFSET2         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03A8)
#define SMU_CPI_OFFSET3         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03AC)
#define SMU_CPI_OFFCTRL         (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03B0)
#define SMU_CPI_MODE            (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03B4)
#define SMU_CPI_POL             (IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03B8)

#define SMU_MSP_SYSC_OPT0	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03C0)

/* use of SMU_PLLSEL */
#define SMU_PLLSEL_OSC		0x00000000
#define SMU_PLLSEL_RTC          0x00000001
#define SMU_PLLSEL_PLL          0x00000002
#define MASK_SMU_PLLSEL		0x00000003

/* SMU_PLLSEL2 */
#define SMU_PLL_DDR_HS_VALID    0x00000001
#define SMU_PLL_AUTO_STANDBY    0x00000002
#define SMU_NRM_CK_SEL          0x00000004
#define SMU_NRM_SEL_LPLL	0x00000004
#define SMU_NRM_SEL_HPLL	0x00000000

/* use of SMU_LPLL_CTRL1,SMU_HPLL_CTRL1-3 */
#define MASK_LPLL_N		0x0000000F	/* LPLL_CTRL1 */
#define MASK_HPLL_N		0x0000007F	/* HPLL_CTRL1 */
#define MASK_HPLL_M		0x0000001F	/* HPLL_CTRL2 */
#define MASK_HPLL_P		0x00000001	/* HPLL_CTRL3 */

#else
/* for MP211 */
#define SMU_RESETCTRL0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0000)
#define SMU_RESETREQ0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0004)
#define SMU_RESETREQ0ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0008)
#define SMU_RESETREQ1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x000c)
#define SMU_RESETREQ1ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0010)
#define SMU_WDT_INT_RESET	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0018)
#define SMU_PLLSEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0080)
#define SMU_PLL1CTRL0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0084)
#define SMU_PLL1CTRL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0088)
#define SMU_PLL1CTRL2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x008c)
#define SMU_PLL3CTRL0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00a8)
#define SMU_PLL3CTRL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00ac)
#define SMU_LCD_PLLSEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00b0)
#define SMU_UART_PLLSEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00b4)
#define SMU_USB_PLLSEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00b8)
#define SMU_CAM_PLLSEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00bc)
#define SMU_OSC12		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00d0)
#define SMU_OSC12_LOCKTIME	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00d4)
#define SMU_CLKSTOPSIG_ST	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00e0)
#define SMU_CLK_POWER_STATUS	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00e4)
#define SMU_POWER_RECORD	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00e8)
#define SMU_SMU_INT_STATUS	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00ec)
#define SMU_SMU_INT_RAW_STATUS	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00f0)
#define SMU_SMU_INT_ENSET	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00f4)
#define SMU_SMU_INT_ENCLR	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00f8)
#define SMU_SMU_INT_ENMON	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x00fc)
#define SMU_SMU_INT_CLEAR	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0100)
#define SMU_DIVLCDMCDCLK	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0110)
#define SMU_DIVSP0SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0114)
#define SMU_DIVSP1SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0118)
#define SMU_DIVSP2SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x011c)
#define SMU_CPU0DOMAIN_DIV	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0120)
#define SMU_CPU1DOMAIN_DIV	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0124)
#define SMU_FLADOMAIN_DIV	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0128)
#define SMU_DIVMOD0SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x012c)
#define SMU_DIVCAMCHGL1SCLK	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0130)
#define SMU_DIVLCDLCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0134)
#define SMU_DIVIICSCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0138)
#define SMU_TI0TIN_SEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x013c)
#define SMU_TI1TIN_SEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0140)
#define SMU_TI2TIN_SEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0144)
#define SMU_TI3TIN_SEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0148)
#define SMU_TGNTIN_SEL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x014c)
#define SMU_DIVMOD1SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0150)
#define SMU_DIVSI0SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0154)
#define SMU_DIVSI1SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0158)
#define SMU_DIVMWISCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x015c)
#define SMU_DIVU70SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0160)
#define SMU_DIVU71SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0164)
#define SMU_DIVU72SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0168)
#define SMU_DIVU73SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x016c)
#define SMU_DIVPM0SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0170)
#define SMU_DIVPM1SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0174)
#define SMU_DIVPM2SCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0178)
#define SMU_DIVUSBSCLK		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x017c)
#define SMU_AHBCLKCTRL0 	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0180)
#define SMU_AHBCLKCTRL1 	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0188)
#define SMU_APBCLKCTRL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0190)
#define SMU_AUTO_FRQ_CHANGE	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0194)
#define SMU_GCLKCTRL0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0198)
#define SMU_GCLKCTRL0ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x019c)
#define SMU_GCLKCTRL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01a0)
#define SMU_GCLKCTRL1ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01a4)
#define SMU_GCLKCTRL2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01a8)
#define SMU_GCLKCTRL2ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01ac)
#define SMU_CLKCTRL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01b8)
#define SMU_CLKEN_POL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01bc)
#define SMU_FLA_CLK_DLY		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01c0)
#define SMU_DDR_M1CLKR_DLY	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01d0)
#define SMU_DDR_M4CLKW_DLY	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01d4)
#define SMU_DDR_MCLK_DLY	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01dc)
#define SMU_DDR_DQSOUT_DLY	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01e0)
#define SMU_DDR_DQSOUT12M_DLY	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01e4)
#define SMU_DDR_DQS_I_DLY	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01e8)
#define SMU_DDR_M1CLKR_ST	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01ec)
#define SMU_CCP_DATA_DLY	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x01f0)
#define SMU_SMU_PE0_ETMSYSOPT	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0200)
#define SMU_SMU_PE1_ETMSYSOPT	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0204)
#define SMU_SMU_PE2_ETMSYSOPT	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0208)
#define SMU_SMU_IOCTRL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0218)
#define SMU_SMU_DSP_ADDRCONV	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x021c)
#define SMU_CHGL		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0220)
#define SMU_GCLKCTRL3		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0224)
#define SMU_GCLKCTRL3ENA	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0228)
#define SMU_SMU_T_DBG_SEL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0230)
#define SMU_BUFSEL0		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0300)
#define SMU_BUFSEL1		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0304)
#define SMU_BUFSEL2		(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0308)

#define SMU_AB0_CS0BASEADD	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0320)
#define SMU_AB0_CS1BASEADD	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0324)
#define SMU_AB0_CS2BASEADD	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0328)
#define SMU_AB0_CS3BASEADD	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x032c)
#define SMU_AB0_CS4BASEADD	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0330)
#define SMU_AB0_CS5BASEADD	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0334)
#define SMU_AB0_CS0BITCOMP	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0338)
#define SMU_AB0_CS1BITCOMP	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x033c)
#define SMU_AB0_CS2BITCOMP	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0340)
#define SMU_AB0_CS3BITCOMP	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0344)
#define SMU_AB0_CS4BITCOMP	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0348)
#define SMU_AB0_CS5BITCOMP	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x034c)
#define SMU_AB0_CS0WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0350)
#define SMU_AB0_CS1WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0354)
#define SMU_AB0_CS2WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0358)
#define SMU_AB0_CS3WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x035c)
#define SMU_AB0_CS4WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0360)
#define SMU_AB0_CS5WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0364)
#define SMU_AB0_CS0READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0368)
#define SMU_AB0_CS1READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x036c)
#define SMU_AB0_CS2READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0370)
#define SMU_AB0_CS3READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0374)
#define SMU_AB0_CS4READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0378)
#define SMU_AB0_CS5READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x037c)
#define SMU_AB0_FLASHRCR	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0380)
#define SMU_AB0_FLASHCOMADD0	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0384)
#define SMU_AB0_FLASHCOMDATA0	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0388)
#define SMU_AB0_FLASHCOMADD1	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x038c)
#define SMU_AB0_FLASHCOMDATA1	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x0390)
#define SMU_AB0_FLASHCLKCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x039c)
#define SMU_AB0_CS0WAITCTRL_W	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03a0)
#define SMU_AB0_CS1WAITCTRL_W	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03a4)
#define SMU_AB0_CS2WAITCTRL_W	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03a8)
#define SMU_AB0_CS3WAITCTRL_W	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03ac)
#define SMU_AB0_CS4WAITCTRL_W	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03b0)
#define SMU_AB0_CS5WAITCTRL_W	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03b4)

#define SMU_AB1_U70WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03c0)
#define SMU_AB1_U71WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03c4)
#define SMU_AB1_U72WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03c8)
#define SMU_AB1_U73WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03cc)
#define SMU_AB1_IICWAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03d0)
#define SMU_AB1_U70READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03d4)
#define SMU_AB1_U71READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03d8)
#define SMU_AB1_U72READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03dc)
#define SMU_AB1_U73READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03e0)
#define SMU_AB1_IICREADCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03e4)
#define SMU_AB1_MOD0WAITCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03e8)
#define SMU_AB1_MOD0READCTRL	(IO_ADDRESS(MP200_SMU_S0_BASE) + 0x03ec)

#define SMU_SWTTRACECLK_CTRL	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0000)
#define SMU_SMU_AB0_L3GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0200)
#define SMU_SMU_FIF_L3GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0204)
#define SMU_SMU_SRC_L3GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0208)
#define SMU_SMU_DSP_L3GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x020c)
#define SMU_SMU_APB_L3GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0210)
#define SMU_SMU_AB0_L2GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0214)
#define SMU_SMU_FIF_L2GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0218)
#define SMU_SMU_SRC_L2GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x021c)
#define SMU_SMU_APB_L2GUARD	(IO_ADDRESS(MP200_SMU_S1_BASE) + 0x0220)

/* use of SMU_PLLSEL */
#define SMU_PLLSEL_12M		0x00000000
#define SMU_PLLSEL_32K		0x00000001
#define SMU_PLLSEL_PLL		0x00000002
#define SMU_PLL_DDR_HS_VALID	0x00000008
#define SMU_PLL_AUTO_STANDBY	0x00000010
#define MASK_SMU_PLLSEL 	0x00000003

/* use of SMU_PLL1CTRL0 */
#define MASK_SMU_PLL1_MPFIX 	0x00000100
#define MASK_SMU_PLL1_N_VAL 	0x000000ff

/* use of SMU_PLL1CTRL1 */
#define MASK_SMU_PLL1_P_VAL 	0x00000020
#define MASK_SMU_PLL1_M_VAL 	0x0000001f
#endif				/* CONFIG_MP201 */

#endif				/* ASM_ARM_ARCH_MP200_SMU_H */
