/*
 *  File Name       : linux/include/asm-arm/arch-mp200/uwire.h
 *  Function        : uwire
 *  Release Version : Ver 1.00
 *  Release Date    : 2005/05/16
 *
 *  Copyright (C) NEC Electronics Corporation 2005
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_UWIRE_H
#define __ASM_ARM_ARCH_MP200_UWIRE_H

#define UWIRE_CS0 		0
#define UWIRE_CS1 		1

#define	UWIRE_CS_PWC		UWIRE_CS0
#define UWIRE_CS_BOARD_B  	UWIRE_CS1

#define UWIRE_SCLOCK_1500KHz	(64-1)
#define UWIRE_SCLOCK_3MHz	(32-1)
#define UWIRE_SCLOCK_6MHz	(16-1)
#define UWIRE_SCLOCK_12MHz	(8-1)
#define UWIRE_SCLOCK_24MHz	(4-1)
#define UWIRE_SCLOCK_48MHz	(2-1)
#define UWIRE_SCLOCK_ANY	(-1)

extern int uwire_read(int cs, u_char addr, u_char * data);
extern int uwire_write(int cs, u_char addr, u_char data);

extern int uwire_set_active_level(int cs, int high);

extern int uwire_vl_read(int cs, int clk, u_char addr, u_int len,
			 u_long * data);
extern int uwire_vl_write(int cs, int clk, u_char addr, u_int len, u_long data);

#endif				/* __ASM_ARM_ARCH_MP200_UWIRE_H */
