
/*
 * Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/*!
 * @file sdma_script_code.h
 * @brief This file contains functions of SDMA scripts code initialization
 * 
 * The file was generated automatically. Based on sdma scripts library.
 * 
 * @ingroup SDMA
 */

#ifndef SDMA_SCRIPT_CODE_H
#define SDMA_SCRIPT_CODE_H


/*! 
* Following define start address of start script 
*/
#define start_ADDR	0
/*! 
* Following define size of start script 
*/
#define start_SIZE	21
 
/*! 
* Following define start address of core script 
*/
#define core_ADDR	80
/*! 
* Following define size of core script 
*/
#define core_SIZE	152
 
/*! 
* Following define start address of common script 
*/
#define common_ADDR	232
/*! 
* Following define size of common script 
*/
#define common_SIZE	191
 
/*! 
* Following define start address of burst_copy script 
*/
#define burst_copy_ADDR	423
/*! 
* Following define size of burst_copy script 
*/
#define burst_copy_SIZE	87
 
/*! 
* Following define start address of dsp_2_burst script 
*/
#define dsp_2_burst_ADDR	510
/*! 
* Following define size of dsp_2_burst script 
*/
#define dsp_2_burst_SIZE	24
 
/*! 
* Following define start address of burst_2_dsp script 
*/
#define burst_2_dsp_ADDR	534
/*! 
* Following define size of burst_2_dsp script 
*/
#define burst_2_dsp_SIZE	24
 
/*! 
* Following define start address of dsp_copy script 
*/
#define dsp_copy_ADDR	558
/*! 
* Following define size of dsp_copy script 
*/
#define dsp_copy_SIZE	86
 
/*! 
* Following define start address of mcu_2_mcu script 
*/
#define mcu_2_mcu_ADDR	644
/*! 
* Following define size of mcu_2_mcu script 
*/
#define mcu_2_mcu_SIZE	79
 
/*! 
* Following define start address of mcu_2_per script 
*/
#define mcu_2_per_ADDR	723
/*! 
* Following define size of mcu_2_per script 
*/
#define mcu_2_per_SIZE	88
 
/*! 
* Following define start address of test script 
*/
#define test_ADDR	811
/*! 
* Following define size of test script 
*/
#define test_SIZE	63
 
/*! 
* Following define start address of mcu_2_dsp script 
*/
#define mcu_2_dsp_ADDR	874
/*! 
* Following define size of mcu_2_dsp script 
*/
#define mcu_2_dsp_SIZE	30
 
/*! 
* Following define start address of mcu_2_dsp_2buf script 
*/
#define mcu_2_dsp_2buf_ADDR	904
/*! 
* Following define size of mcu_2_dsp_2buf script 
*/
#define mcu_2_dsp_2buf_SIZE	113
 
/*! 
* Following define start address of dsp_2_mcu script 
*/
#define dsp_2_mcu_ADDR	1017
/*! 
* Following define size of dsp_2_mcu script 
*/
#define dsp_2_mcu_SIZE	30
 
/*! 
* Following define start address of dsp_2_mcu_2buf script 
*/
#define dsp_2_mcu_2buf_ADDR	1047
/*! 
* Following define size of dsp_2_mcu_2buf script 
*/
#define dsp_2_mcu_2buf_SIZE	113
 
/*! 
* Following define start address of dsp_2_dsp script 
*/
#define dsp_2_dsp_ADDR	1160
/*! 
* Following define size of dsp_2_dsp script 
*/
#define dsp_2_dsp_SIZE	64
 
/*! 
* Following define start address of per_2_mcu script 
*/
#define per_2_mcu_ADDR	1224
/*! 
* Following define size of per_2_mcu script 
*/
#define per_2_mcu_SIZE	121
 
/*! 
* Following define start address of dsp_2_per_2buf script 
*/
#define dsp_2_per_2buf_ADDR	1345
/*! 
* Following define size of dsp_2_per_2buf script 
*/
#define dsp_2_per_2buf_SIZE	164
 
/*! 
* Following define start address of per_2_dsp_2buf script 
*/
#define per_2_dsp_2buf_ADDR	1509
/*! 
* Following define size of per_2_dsp_2buf script 
*/
#define per_2_dsp_2buf_SIZE	168
 
/*! 
* Following define start address of per_2_per script 
*/
#define per_2_per_ADDR	1677
/*! 
* Following define size of per_2_per script 
*/
#define per_2_per_SIZE	67
 
/*! 
* Following define start address of error_dsp script 
*/
#define error_dsp_ADDR	1744
/*! 
* Following define size of error_dsp script 
*/
#define error_dsp_SIZE	34
 
/*! 
* Following define start address of app_2_mcu script 
*/
#define app_2_mcu_ADDR	6144
/*! 
* Following define size of app_2_mcu script 
*/
#define app_2_mcu_SIZE	95
 
/*! 
* Following define start address of ata_2_mcu script 
*/
#define ata_2_mcu_ADDR	6239
/*! 
* Following define size of ata_2_mcu script 
*/
#define ata_2_mcu_SIZE	100
 
/*! 
* Following define start address of dptc_dvfs script 
*/
#define dptc_dvfs_ADDR	6339
/*! 
* Following define size of dptc_dvfs script 
*/
#define dptc_dvfs_SIZE	258
 
/*! 
* Following define start address of firi_2_mcu script 
*/
#define firi_2_mcu_ADDR	6597
/*! 
* Following define size of firi_2_mcu script 
*/
#define firi_2_mcu_SIZE	178
 
/*! 
* Following define start address of mcu_2_app script 
*/
#define mcu_2_app_ADDR	6775
/*! 
* Following define size of mcu_2_app script 
*/
#define mcu_2_app_SIZE	119
 
/*! 
* Following define start address of mcu_2_ata script 
*/
#define mcu_2_ata_ADDR	6894
/*! 
* Following define size of mcu_2_ata script 
*/
#define mcu_2_ata_SIZE	85
 
/*! 
* Following define start address of mcu_2_firi script 
*/
#define mcu_2_firi_ADDR	6979
/*! 
* Following define size of mcu_2_firi script 
*/
#define mcu_2_firi_SIZE	74
 
/*! 
* Following define start address of mcu_2_mshc script 
*/
#define mcu_2_mshc_ADDR	7053
/*! 
* Following define size of mcu_2_mshc script 
*/
#define mcu_2_mshc_SIZE	47
 
/*! 
* Following define start address of mcu_2_shp script 
*/
#define mcu_2_shp_ADDR	7100
/*! 
* Following define size of mcu_2_shp script 
*/
#define mcu_2_shp_SIZE	115
 
/*! 
* Following define start address of mshc_2_mcu script 
*/
#define mshc_2_mcu_ADDR	7215
/*! 
* Following define size of mshc_2_mcu script 
*/
#define mshc_2_mcu_SIZE	53
 
/*! 
* Following define start address of shp_2_mcu script 
*/
#define shp_2_mcu_ADDR	7268
/*! 
* Following define size of shp_2_mcu script 
*/
#define shp_2_mcu_SIZE	95
 
/*! 
* Following define start address of uart_2_mcu script 
*/
#define uart_2_mcu_ADDR	7363
/*! 
* Following define size of uart_2_mcu script 
*/
#define uart_2_mcu_SIZE	119
 
/*! 
* Following define start address of uartsh_2_mcu script 
*/
#define uartsh_2_mcu_ADDR	7482
/*! 
* Following define size of uartsh_2_mcu script 
*/
#define uartsh_2_mcu_SIZE	114
 
/*!
* Following define the start address of sdma ram 
*/

#define RAM_CODE_START_ADDR	6144
/*!
* Following define the size of sdma ram
*/
#define RAM_CODE_SIZE	1452

/*!
* This function returns buffer that holds the image of SDMA RAM
*
* @return pointer to buffer that holds the image of SDMA RAM
*/

static const short sdma_code[] =
{
0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d58, 0x5ac0, 0x5bc8, 0x5ef8,
0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9806, 0x6ec3, 0x6d07, 0x5df0,
0x0dff, 0x0511, 0x1dff, 0x05bc, 0x4d00, 0x7d3d, 0x0b70, 0x0311,
0x522b, 0x5313, 0x02b9, 0x4a00, 0x7c05, 0x6a28, 0x620c, 0x7e32,
0x0400, 0x9816, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0, 0x0a03,
0x0212, 0x02bc, 0x0210, 0x4a00, 0x7d14, 0x4a02, 0x7d18, 0x4a01,
0x7d1b, 0x62c8, 0x7e1f, 0x0210, 0x0212, 0x6a09, 0x7f1b, 0x0212,
0x6a09, 0x7f18, 0x0212, 0x6a09, 0x7f15, 0x2003, 0x4800, 0x7cf1,
0x984f, 0x0015, 0x0015, 0x7802, 0x62c8, 0x6a0b, 0x984f, 0x0015,
0x7802, 0x62c8, 0x6a0a, 0x984f, 0x7802, 0x62c8, 0x6a09, 0x7c02,
0x0000, 0x9814, 0xc6d8, 0x6a28, 0x620c, 0x7efc, 0x008b, 0x52c3,
0x53cb, 0xc10d, 0x7dab, 0x0200, 0x9806, 0x0200, 0x9803, 0xc19d,
0xc0ec, 0x7d5f, 0x0c70, 0x0411, 0x5414, 0x5ac4, 0x5ef8, 0xc0fe,
0x56f8, 0x7d02, 0x0200, 0x9866, 0x6d07, 0x0d70, 0x0511, 0x5215,
0x5bca, 0x5cd2, 0x0bff, 0x0311, 0x1bff, 0x04bb, 0x0415, 0x0388,
0x4c00, 0x7d3c, 0x522d, 0x008a, 0x00bb, 0x4800, 0x7c08, 0x02b9,
0x4a00, 0x7c13, 0x6928, 0x620c, 0x7e2b, 0x0400, 0x987a, 0x008f,
0x0015, 0x04d8, 0x7d01, 0x008c, 0x04a0, 0x0015, 0x7802, 0x52c6,
0x6a0b, 0x0000, 0x7e1e, 0x7f1c, 0x9878, 0x1e20, 0x5206, 0x2620,
0x008a, 0x0260, 0x7c08, 0x065f, 0x52c6, 0x063f, 0x7e12, 0x6a0a,
0x7f0f, 0x4c00, 0x7d13, 0x04d8, 0x7d02, 0x008c, 0x0020, 0x04a0,
0x0015, 0x7802, 0x52c6, 0x6a0b, 0x0000, 0x7e03, 0x7f01, 0x98b6,
0x680c, 0x0007, 0x5015, 0x54d0, 0x0454, 0x98bb, 0x6928, 0x630c,
0x7ef7, 0x5015, 0x54d0, 0x52c0, 0x53c8, 0xc10d, 0x7da7, 0x0200,
0x9866, 0x0200, 0x9860, 0xc0ec, 0x7d4d, 0x0800, 0x0970, 0x0111,
0x5111, 0x5ac1, 0x5bc9, 0x028e, 0xc0fe, 0x068a, 0x7c45, 0x5cd1,
0x5dd9, 0x1a5c, 0x6ac3, 0x63c8, 0x0363, 0x7c40, 0x036f, 0x7d03,
0x0374, 0x7c79, 0x9935, 0x058f, 0x1d0c, 0x6d23, 0x650b, 0x007d,
0x7c01, 0x1d08, 0x007c, 0x7c01, 0x1d04, 0x6d23, 0x650b, 0x0488,
0x3c1f, 0x0417, 0x0417, 0x0417, 0x0417, 0x059c, 0x6d23, 0x028e,
0x1a34, 0x6ad7, 0x0488, 0x0804, 0x7802, 0x650b, 0x6dc8, 0x008c,
0x1a28, 0x6ad7, 0x63c8, 0x034c, 0x6bc8, 0x54d1, 0x0bff, 0x0311,
0x1bff, 0x04bb, 0x4c00, 0x7d06, 0x0065, 0x7c02, 0x0101, 0x0025,
0x0400, 0x98d2, 0x52c1, 0x53c9, 0x54d1, 0x0453, 0xc10d, 0x7dba,
0x0200, 0x98ca, 0x0200, 0x98c3, 0x0200, 0x98ca, 0xd9be, 0x3c06,
0x4c00, 0x7dbc, 0x6f23, 0x0462, 0x0488, 0x3c1f, 0x7c04, 0x4c00,
0x7d0a, 0x2001, 0x992b, 0x620b, 0x2201, 0x1c01, 0x1801, 0x02dc,
0x7d02, 0x301f, 0x00aa, 0x048f, 0x1c04, 0x6c07, 0x0488, 0x3c1f,
0x6c2b, 0x0045, 0x028e, 0x1a5c, 0x98d6, 0x55d9, 0x6d07, 0x54d1,
0x058a, 0x2508, 0x6dc7, 0x0373, 0x7c03, 0x65c8, 0x6d0b, 0x2408,
0x0372, 0x7c04, 0x65c8, 0x6d0b, 0x2408, 0x994a, 0x6cce, 0x65c8,
0x6d0a, 0x2404, 0x6d28, 0x6507, 0x5dd9, 0x5cd1, 0x6ae3, 0x6ad7,
0x63c8, 0x0334, 0x6bc8, 0x0370, 0x7c86, 0x0c60, 0x0411, 0x04bb,
0x4c00, 0x7d81, 0x0410, 0x1c30, 0x0410, 0x04bb, 0x046d, 0x7d0a,
0x047d, 0x7c03, 0x047c, 0x7c01, 0x98db, 0x003b, 0x003a, 0x0039,
0x0058, 0x9979, 0x047d, 0x7d03, 0x047c, 0x7d01, 0x98db, 0x005b,
0xd9b3, 0x1d18, 0x6d23, 0x650b, 0x0510, 0x003a, 0x0039, 0x0038,
0x00ad, 0xd9be, 0x0c30, 0x0410, 0x04bb, 0x003c, 0x003d, 0x00ac,
0xd9b3, 0x007b, 0x7c04, 0x003d, 0x003c, 0x1d0c, 0x9990, 0x0310,
0x3b30, 0x4b30, 0x7d01, 0x1b10, 0x0310, 0x003d, 0x003c, 0x00ab,
0x6ad7, 0x63c8, 0x6d23, 0x650b, 0x0560, 0x7d03, 0x005e, 0xd9a7,
0x98db, 0x003e, 0x0c80, 0x0410, 0x0394, 0xd9a7, 0x640b, 0x037f,
0x7d02, 0x1a14, 0x99a4, 0x1a0c, 0x6ad7, 0x6cc8, 0x98db, 0x0c7f,
0x0410, 0x03b4, 0x04b8, 0x03ac, 0x640b, 0x6bc8, 0x028e, 0x1a04,
0x6ad7, 0x6cc8, 0x0006, 0x058f, 0x1d08, 0x6d23, 0x650b, 0x007d,
0x7c01, 0x1d38, 0x007c, 0x7c01, 0x1d1c, 0x0006, 0x048b, 0x042c,
0x0454, 0x042b, 0x6ad7, 0x6cc8, 0x0006, 0x1e10, 0x0870, 0x0011,
0x5010, 0xc0ec, 0x7d5e, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8,
0x7d02, 0x0200, 0x99cc, 0x6d07, 0x0b70, 0x0311, 0x0dff, 0x0511,
0x1dff, 0x05bc, 0x4d00, 0x7d4f, 0x6ec3, 0x522b, 0x02b9, 0x4a00,
0x7d2b, 0x62c8, 0x7e6e, 0x0264, 0x7c53, 0x0212, 0x3aff, 0x008a,
0x05d8, 0x7d03, 0x008d, 0x0b01, 0x99f1, 0x0a10, 0x6ed3, 0x6ac8,
0x0b00, 0xda5b, 0x4b00, 0x0b70, 0x0311, 0x7c35, 0x0478, 0x7d27,
0x522b, 0x02b9, 0x4a00, 0x7cde, 0x6a28, 0x620c, 0x7e58, 0x4d00,
0x7c09, 0x5013, 0x52c0, 0x53c8, 0x04a5, 0xc10d, 0x7d01, 0x0201,
0x0400, 0x99cc, 0x0400, 0x99da, 0x62c8, 0x7e43, 0x0212, 0x3aff,
0x008a, 0x0b00, 0x00d5, 0x7d05, 0x008d, 0x0a10, 0x6ed3, 0x6ac8,
0x0b01, 0xda5b, 0x4b00, 0x7d03, 0x0b70, 0x0311, 0x9a2b, 0x6a28,
0x620c, 0x7e35, 0x5013, 0x52c0, 0x53c8, 0x04a5, 0xc10d, 0x0200,
0x99cc, 0x0200, 0x99c9, 0x6a28, 0x620c, 0x7e29, 0x0b70, 0x0311,
0x5013, 0x52c0, 0x53c8, 0x04a5, 0xc10d, 0x7d96, 0x0200, 0x99cc,
0x008f, 0x00d5, 0x7d01, 0x008d, 0xda5b, 0x522b, 0x02b9, 0x4a00,
0x7c99, 0x6a28, 0x620c, 0x7e13, 0x4d00, 0x7c09, 0x5013, 0x52c0,
0x53c8, 0x04a5, 0xc10d, 0x7d01, 0x0201, 0x0400, 0x99cc, 0x0400,
0x99da, 0x0007, 0x68cc, 0x6a28, 0x620c, 0x7e01, 0x9a59, 0x0007,
0x6a0c, 0x0454, 0x9a2b, 0x05a0, 0x1e08, 0x6ec1, 0x0060, 0x7c04,
0x62c8, 0x6a09, 0x7ff4, 0x7eed, 0x0015, 0x0060, 0x7c05, 0x6ece,
0x62c8, 0x6a0a, 0x7fec, 0x7ee5, 0x6ecf, 0x0015, 0x7802, 0x62c8,
0x6a0b, 0x0000, 0x7fe4, 0x7edd, 0x6a28, 0x2608, 0x0006, 0x0870,
0x0011, 0x5010, 0xc0ec, 0x7d70, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe,
0x56f8, 0x7d02, 0x0200, 0x9a7d, 0x6d03, 0x6ed3, 0x0dff, 0x0511,
0x1dff, 0x05bc, 0x5df8, 0x4d00, 0x7d56, 0x0b70, 0x0311, 0x522b,
0x5313, 0x02b9, 0x4a00, 0x7c04, 0x62ff, 0x7e37, 0x0400, 0x9a8d,
0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0, 0x5ddb, 0x0d03, 0x0512,
0x05bc, 0x0510, 0x5dd3, 0x4d00, 0x7d1f, 0x4d02, 0x7d18, 0x4d01,
0x7d12, 0x6209, 0x7e22, 0x6509, 0x7e20, 0x0212, 0x02ad, 0x6509,
0x7e1c, 0x0212, 0x02ad, 0x0212, 0x0210, 0x6ac8, 0x7f16, 0x2003,
0x4800, 0x7cef, 0x9ac9, 0x7802, 0x6209, 0x6ac8, 0x9ac9, 0x0015,
0x7802, 0x620a, 0x6ac8, 0x9ac9, 0x0015, 0x0015, 0x7802, 0x620b,
0x6ac8, 0x7c03, 0x0000, 0x55db, 0x9a8b, 0x0007, 0x68cc, 0x680c,
0x55d3, 0x4d00, 0x7d03, 0x4d02, 0x7d02, 0x9ad8, 0x0017, 0x0017,
0x55db, 0x009d, 0x55fb, 0x05a0, 0x08ff, 0x0011, 0x18ff, 0x0010,
0x04b8, 0x04ad, 0x0454, 0x62ff, 0x7ee8, 0x008b, 0x52c0, 0x53c8,
0xc10d, 0x7d93, 0x0200, 0x9a7d, 0x0200, 0x9a7a, 0xc19d, 0xc0ec,
0x7d50, 0x0c70, 0x0411, 0x5414, 0x5ac4, 0x5efc, 0xc0fe, 0x56fc,
0x7d02, 0x0200, 0x9af5, 0x6d03, 0x0d70, 0x0511, 0x5215, 0x5bca,
0x5cd2, 0x0bff, 0x0311, 0x1bff, 0x04bb, 0x0415, 0x0388, 0x4c00,
0x7d2f, 0x4c00, 0x7d21, 0x522d, 0x02bb, 0x4a00, 0x7c02, 0x0400,
0x9b0b, 0x4c01, 0x7d0f, 0x008f, 0x0015, 0x04d8, 0x7d01, 0x008c,
0x0020, 0x04a0, 0x0015, 0x7802, 0x620b, 0x5a06, 0x0000, 0x7e12,
0x7f12, 0x9b09, 0x620a, 0x7e0e, 0x008a, 0x0011, 0x0010, 0x02a8,
0x065f, 0x5a06, 0x063f, 0x7f07, 0x522d, 0x02b9, 0x4a00, 0x7c08,
0x0400, 0x9b2c, 0x680c, 0x0007, 0x5015, 0x54d0, 0x0454, 0x9b3b,
0x6928, 0x5015, 0x54d0, 0x52c0, 0x53c8, 0xc10d, 0x7db6, 0x0200,
0x9af5, 0x0200, 0x9aef, 0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d43,
0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9b49,
0x0b70, 0x0311, 0x6ed3, 0x6d03, 0x0dff, 0x0511, 0x1dff, 0x05bc,
0x4d00, 0x7d28, 0x522b, 0x02b9, 0x4a00, 0x7c04, 0x62ff, 0x7e1c,
0x0400, 0x9b5a, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0, 0x0060,
0x7c04, 0x6209, 0x6ac8, 0x7f10, 0x7e12, 0x0015, 0x0060, 0x7c04,
0x620a, 0x6ac8, 0x7f09, 0x7e0b, 0x0015, 0x7802, 0x620b, 0x6ac8,
0x0000, 0x7f02, 0x7e04, 0x9b58, 0x0007, 0x68cc, 0x9b81, 0x0007,
0x6a0c, 0x0454, 0x62ff, 0x7ef8, 0x5013, 0x52c0, 0x53c8, 0xc10d,
0x7dc0, 0x0200, 0x9b49, 0x0200, 0x9b46, 0xc19d, 0x0870, 0x0011,
0xc0ec, 0x7d28, 0x5010, 0x5ac0, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02,
0x0200, 0x9b94, 0x0870, 0x0011, 0x6d03, 0x0dff, 0x0511, 0x1dff,
0x05bc, 0x4d00, 0x7d11, 0x5228, 0x02b9, 0x4a00, 0x7c02, 0x0400,
0x9ba3, 0x620b, 0x7e06, 0x5a06, 0x7f05, 0x0000, 0x2504, 0x7d04,
0x9ba3, 0x680c, 0x0007, 0x0454, 0x5010, 0x52c0, 0xc10d, 0x7ddc,
0x0200, 0x9b94, 0x0200, 0x9b90, 0xc19d, 0x0870, 0x0011, 0xc0ec,
0x7d6c, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02,
0x0200, 0x9bc3, 0x6d03, 0x0d03, 0x0512, 0x05bc, 0x0510, 0x5dd0,
0x0dff, 0x0511, 0x1dff, 0x05bc, 0x5df8, 0x4d00, 0x7d4f, 0x0a70,
0x0211, 0x532a, 0x5212, 0x03b9, 0x4b00, 0x7c02, 0x0400, 0x9bd7,
0x008f, 0x05d8, 0x7d01, 0x008d, 0x05a0, 0x5dda, 0x55d2, 0x4d00,
0x7d1f, 0x4d02, 0x7d18, 0x4d01, 0x7d12, 0x6309, 0x7e22, 0x6509,
0x7e20, 0x0312, 0x03ad, 0x6509, 0x7e1c, 0x0312, 0x03ad, 0x0312,
0x0310, 0x5b06, 0x7f16, 0x2003, 0x4800, 0x7cef, 0x9c0d, 0x7802,
0x6309, 0x5b06, 0x9c0d, 0x0015, 0x7802, 0x630a, 0x5b06, 0x9c0d,
0x0015, 0x0015, 0x7802, 0x630b, 0x5b06, 0x7c03, 0x55da, 0x0000,
0x9bd5, 0x0007, 0x680c, 0x55d2, 0x4d00, 0x7d03, 0x4d02, 0x7d02,
0x9c1b, 0x0017, 0x0017, 0x55da, 0x009d, 0x55fa, 0x05a0, 0x08ff,
0x0011, 0x18ff, 0x0010, 0x04b8, 0x04ad, 0x0454, 0x008a, 0x52c0,
0x53c8, 0xc10d, 0x7d98, 0x0200, 0x9bc3, 0x0200, 0x9bbf, 0xc19d,
0x0870, 0x0011, 0xc0ec, 0x7d2e, 0x5010, 0x5ac0, 0x5ef8, 0xc0fe,
0x56f8, 0x7d02, 0x0200, 0x9c36, 0x0870, 0x0011, 0x6d07, 0x0dff,
0x0511, 0x1dff, 0x05bc, 0x4d00, 0x7d14, 0x5228, 0x02b9, 0x4a00,
0x7c05, 0x6928, 0x620c, 0x7e0a, 0x0400, 0x9c45, 0x5206, 0x7e07,
0x6a0b, 0x7f04, 0x0000, 0x2504, 0x7d04, 0x9c45, 0x680c, 0x0007,
0x0454, 0x6928, 0x620c, 0x7efa, 0x5010, 0x52c0, 0xc10d, 0x7dd6,
0x0200, 0x9c36, 0x0200, 0x9c32, 0xc19d, 0x0870, 0x0011, 0xc0ec,
0x7d58, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02,
0x0200, 0x9c6b, 0x6d07, 0x5df0, 0x0dff, 0x0511, 0x1dff, 0x05bc,
0x4d00, 0x7d3d, 0x0a70, 0x0211, 0x532a, 0x5212, 0x03b9, 0x4b00,
0x7c05, 0x6a28, 0x630c, 0x7e32, 0x0400, 0x9c7a, 0x008f, 0x05d8,
0x7d01, 0x008d, 0x05a0, 0x0b03, 0x0312, 0x03bc, 0x0310, 0x4b00,
0x7d14, 0x4b02, 0x7d18, 0x4b01, 0x7d1b, 0x5306, 0x7e1f, 0x0310,
0x0312, 0x6b09, 0x7f1b, 0x0312, 0x6b09, 0x7f18, 0x0312, 0x6b09,
0x7f15, 0x2003, 0x4800, 0x7cf1, 0x9cb3, 0x0015, 0x0015, 0x7802,
0x5306, 0x6b0b, 0x9cb3, 0x0015, 0x7802, 0x5306, 0x6b0a, 0x9cb3,
0x7802, 0x5306, 0x6b09, 0x7c02, 0x0000, 0x9c78, 0xc6d8, 0x6928,
0x630c, 0x7efc, 0x008a, 0x52c0, 0x53c8, 0xc10d, 0x7dac, 0x0200,
0x9c6b, 0x0200, 0x9c67, 0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d5b,
0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9cc9,
0x0b70, 0x0311, 0x6ec3, 0x6d07, 0x5df0, 0x0dff, 0x0511, 0x1dff,
0x05bc, 0x4d00, 0x7d3c, 0x522b, 0x02b9, 0x4a00, 0x7c05, 0x6a28,
0x620c, 0x7e31, 0x0400, 0x9cdb, 0x028e, 0x1a94, 0x6ac3, 0x62c8,
0x0269, 0x7d19, 0x1e94, 0x6ec3, 0x6ed3, 0x62c8, 0x0248, 0x6ac8,
0x2694, 0x6ec3, 0x62c8, 0x026e, 0x7d30, 0x6a09, 0x7f1c, 0x2501,
0x4d00, 0x7d1d, 0x028e, 0x1a98, 0x6ac3, 0x62c8, 0x6ec3, 0x0260,
0x7df1, 0xdd27, 0x9d1a, 0x6ee3, 0x008f, 0x2001, 0x00d5, 0x7d01,
0x008d, 0x05a0, 0x62c8, 0x026e, 0x7d18, 0x6a09, 0x7f04, 0x2001,
0x7cf9, 0x0000, 0x9cd9, 0x0007, 0x6a0c, 0xdd2a, 0x9d37, 0x6a28,
0x620c, 0x7ef9, 0x0b70, 0x0311, 0x5013, 0x52c0, 0x53c8, 0xc10d,
0x7da8, 0x0200, 0x9cc9, 0x0200, 0x9cc6, 0xdd27, 0x9d37, 0x6a28,
0x620c, 0x7ee9, 0x6207, 0x0b70, 0x0311, 0x5013, 0x55f0, 0x02a5,
0x0bff, 0x0312, 0x1bff, 0x0312, 0x04bb, 0x049a, 0x0006, 0x0458,
0x0454, 0x9d1a, 0xc19d, 0x0870, 0x0011, 0xc0ec, 0x7d54, 0x5010,
0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9d41,
0x0a70, 0x0211, 0x6d07, 0x5df0, 0x0dff, 0x0511, 0x1dff, 0x05bc,
0x4d00, 0x7d35, 0x532a, 0x03b9, 0x4b00, 0x7c05, 0x6928, 0x630c,
0x7e2a, 0x0400, 0x9d52, 0x038e, 0x1b94, 0x5303, 0x0369, 0x7d14,
0x1e94, 0x5306, 0x0348, 0x5b06, 0x2694, 0x5306, 0x036e, 0x7d2d,
0x6b09, 0x7f19, 0x2501, 0x4d00, 0x7d1a, 0x038e, 0x1b98, 0x5303,
0x0360, 0x7df3, 0xdd97, 0x9d8a, 0x008f, 0x2001, 0x00d5, 0x7d01,
0x008d, 0x05a0, 0x5306, 0x036e, 0x7d18, 0x6b09, 0x7f04, 0x2001,
0x7cf9, 0x0000, 0x9d50, 0x0007, 0x6b0c, 0xdd9a, 0x9da9, 0x6928,
0x630c, 0x7ef9, 0x0a70, 0x0211, 0x5012, 0x52c0, 0x53c8, 0xc10d,
0x7db0, 0x0200, 0x9d41, 0x0200, 0x9d3d, 0xdd97, 0x9da9, 0x6b28,
0x630c, 0x7ee9, 0x6307, 0x0a70, 0x0211, 0x5012, 0x55f0, 0x03a5,
0x0aff, 0x0212, 0x1aff, 0x0212, 0x04ba, 0x049b, 0x0a70, 0x0211,
0x0006, 0x0458, 0x0454, 0x9d8a, 0x9d8a
};
#endif
