/*
 * Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.
 */

/* 
 * The code contained herein is licensed under the GNU General Public
 * License. You may obtain a copy of the GNU General Public License
 * Version 2 or later at the following locations:
 * 
 * http://www.opensource.org/licenses/gpl-license.html 
 * http://www.gnu.org/copyleft/gpl.html
 */

/*!
 * @file mxc_sdma_tty.h
 * 
 * @brief This file contains the SDMA TTY public declarations.
 *
 * SDMA TTY driver is used for moving data between MCU and DSP using line discipline API.
 * 
 * @ingroup SDMA
 */

#ifndef MXC_SDMA_TTY_H
#define MXC_SDMA_TTY_H

#include <linux/ioctl.h>

/*!
 * This defines Change Loopback Mode ioctl
 */
#define TIOCLPBACK _IOR('s', 0, unsigned char)

/*!
 * This defines default loopback mode
 */
#define DEFAULT_LOOPBACK_MODE 0

/*!
 * This defines a number of bi-directional driver instances
 */
#define IPC_NB_CH_BIDIR  2

/*!
 * This defines a number of mono directional channels from DSP to MCU  driver instances
 */
#define IPC_NB_CH_DSPMCU 2

/*!
 * This defines a number of mono directional channels from MCU to DSP  driver instances
 */
#define IPC_NB_CH_MCUDSP 2

#endif
