
/*
 * Copyright 2004 Freescale Semiconductor, Inc. All Rights Reserved.  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/*!
 * @file sdma_script_code.h
 * @brief This file contains functions of SDMA scripts code initialization
 * 
 * The file was generated automatically. Based on sdma scripts library.
 * 
 * @ingroup SDMA
 */

#ifndef SDMA_SCRIPT_CODE_H
#define SDMA_SCRIPT_CODE_H


/*! 
* Following define start address of start script 
*/
#define start_ADDR	0
/*! 
* Following define size of start script 
*/
#define start_SIZE	21
 
/*! 
* Following define start address of core script 
*/
#define core_ADDR	80
/*! 
* Following define size of core script 
*/
#define core_SIZE	152
 
/*! 
* Following define start address of common script 
*/
#define common_ADDR	232
/*! 
* Following define size of common script 
*/
#define common_SIZE	191
 
/*! 
* Following define start address of burst_copy script 
*/
#define burst_copy_ADDR	423
/*! 
* Following define size of burst_copy script 
*/
#define burst_copy_SIZE	87
 
/*! 
* Following define start address of dsp_2_burst script 
*/
#define dsp_2_burst_ADDR	510
/*! 
* Following define size of dsp_2_burst script 
*/
#define dsp_2_burst_SIZE	24
 
/*! 
* Following define start address of burst_2_dsp script 
*/
#define burst_2_dsp_ADDR	534
/*! 
* Following define size of burst_2_dsp script 
*/
#define burst_2_dsp_SIZE	24
 
/*! 
* Following define start address of dsp_copy script 
*/
#define dsp_copy_ADDR	558
/*! 
* Following define size of dsp_copy script 
*/
#define dsp_copy_SIZE	86
 
/*! 
* Following define start address of mcu_2_mcu script 
*/
#define mcu_2_mcu_ADDR	644
/*! 
* Following define size of mcu_2_mcu script 
*/
#define mcu_2_mcu_SIZE	79
 
/*! 
* Following define start address of mcu_2_per script 
*/
#define mcu_2_per_ADDR	723
/*! 
* Following define size of mcu_2_per script 
*/
#define mcu_2_per_SIZE	88
 
/*! 
* Following define start address of test script 
*/
#define test_ADDR	811
/*! 
* Following define size of test script 
*/
#define test_SIZE	63
 
/*! 
* Following define start address of mcu_2_dsp script 
*/
#define mcu_2_dsp_ADDR	874
/*! 
* Following define size of mcu_2_dsp script 
*/
#define mcu_2_dsp_SIZE	30
 
/*! 
* Following define start address of mcu_2_dsp_2buf script 
*/
#define mcu_2_dsp_2buf_ADDR	904
/*! 
* Following define size of mcu_2_dsp_2buf script 
*/
#define mcu_2_dsp_2buf_SIZE	113
 
/*! 
* Following define start address of dsp_2_mcu script 
*/
#define dsp_2_mcu_ADDR	1017
/*! 
* Following define size of dsp_2_mcu script 
*/
#define dsp_2_mcu_SIZE	30
 
/*! 
* Following define start address of dsp_2_mcu_2buf script 
*/
#define dsp_2_mcu_2buf_ADDR	1047
/*! 
* Following define size of dsp_2_mcu_2buf script 
*/
#define dsp_2_mcu_2buf_SIZE	113
 
/*! 
* Following define start address of dsp_2_dsp script 
*/
#define dsp_2_dsp_ADDR	1160
/*! 
* Following define size of dsp_2_dsp script 
*/
#define dsp_2_dsp_SIZE	64
 
/*! 
* Following define start address of per_2_mcu script 
*/
#define per_2_mcu_ADDR	1224
/*! 
* Following define size of per_2_mcu script 
*/
#define per_2_mcu_SIZE	121
 
/*! 
* Following define start address of dsp_2_per_2buf script 
*/
#define dsp_2_per_2buf_ADDR	1345
/*! 
* Following define size of dsp_2_per_2buf script 
*/
#define dsp_2_per_2buf_SIZE	164
 
/*! 
* Following define start address of per_2_dsp_2buf script 
*/
#define per_2_dsp_2buf_ADDR	1509
/*! 
* Following define size of per_2_dsp_2buf script 
*/
#define per_2_dsp_2buf_SIZE	168
 
/*! 
* Following define start address of per_2_per script 
*/
#define per_2_per_ADDR	1677
/*! 
* Following define size of per_2_per script 
*/
#define per_2_per_SIZE	67
 
/*! 
* Following define start address of error_dsp script 
*/
#define error_dsp_ADDR	1744
/*! 
* Following define size of error_dsp script 
*/
#define error_dsp_SIZE	34
 
/*! 
* Following define start address of app_2_mcu script 
*/
#define app_2_mcu_ADDR	6144
/*! 
* Following define size of app_2_mcu script 
*/
#define app_2_mcu_SIZE	95
 
/*! 
* Following define start address of dsp_interrupt_only script 
*/
#define dsp_interrupt_only_ADDR	6239
/*! 
* Following define size of dsp_interrupt_only script 
*/
#define dsp_interrupt_only_SIZE	2
 
/*! 
* Following define start address of loopback_on_dsp_side script 
*/
#define loopback_on_dsp_side_ADDR	6241
/*! 
* Following define size of loopback_on_dsp_side script 
*/
#define loopback_on_dsp_side_SIZE	101
 
/*! 
* Following define start address of loopback_on_mcu_side script 
*/
#define loopback_on_mcu_side_ADDR	6342
/*! 
* Following define size of loopback_on_mcu_side script 
*/
#define loopback_on_mcu_side_SIZE	100
 
/*! 
* Following define start address of mcu_2_app script 
*/
#define mcu_2_app_ADDR	6442
/*! 
* Following define size of mcu_2_app script 
*/
#define mcu_2_app_SIZE	119
 
/*! 
* Following define start address of mcu_2_shp script 
*/
#define mcu_2_shp_ADDR	6561
/*! 
* Following define size of mcu_2_shp script 
*/
#define mcu_2_shp_SIZE	115
 
/*! 
* Following define start address of mcu_interrupt_only script 
*/
#define mcu_interrupt_only_ADDR	6676
/*! 
* Following define size of mcu_interrupt_only script 
*/
#define mcu_interrupt_only_SIZE	2
 
/*! 
* Following define start address of shp_2_mcu script 
*/
#define shp_2_mcu_ADDR	6678
/*! 
* Following define size of shp_2_mcu script 
*/
#define shp_2_mcu_SIZE	95
 
/*! 
* Following define start address of uart_2_mcu script 
*/
#define uart_2_mcu_ADDR	6773
/*! 
* Following define size of uart_2_mcu script 
*/
#define uart_2_mcu_SIZE	119
 
/*! 
* Following define start address of uartsh_2_mcu script 
*/
#define uartsh_2_mcu_ADDR	6892
/*! 
* Following define size of uartsh_2_mcu script 
*/
#define uartsh_2_mcu_SIZE	114
 
/*!
* Following define the start address of sdma ram 
*/

#define RAM_CODE_START_ADDR	6144
/*!
* Following define the size of sdma ram
*/
#define RAM_CODE_SIZE	862

/*!
* This function returns buffer that holds the image of SDMA RAM
*
* @return pointer to buffer that holds the image of SDMA RAM
*/

static const short sdma_code[] =
{
0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d58, 0x5ac0, 0x5bc8, 0x5ef8,
0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9806, 0x6ec3, 0x6d07, 0x5df0,
0x0dff, 0x0511, 0x1dff, 0x05bc, 0x4d00, 0x7d3d, 0x0b70, 0x0311,
0x522b, 0x5313, 0x02b9, 0x4a00, 0x7c05, 0x6a28, 0x620c, 0x7e32,
0x0400, 0x9816, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0, 0x0a03,
0x0212, 0x02bc, 0x0210, 0x4a00, 0x7d14, 0x4a02, 0x7d18, 0x4a01,
0x7d1b, 0x62c8, 0x7e1f, 0x0210, 0x0212, 0x6a09, 0x7f1b, 0x0212,
0x6a09, 0x7f18, 0x0212, 0x6a09, 0x7f15, 0x2003, 0x4800, 0x7cf1,
0x984f, 0x0015, 0x0015, 0x7802, 0x62c8, 0x6a0b, 0x984f, 0x0015,
0x7802, 0x62c8, 0x6a0a, 0x984f, 0x7802, 0x62c8, 0x6a09, 0x7c02,
0x0000, 0x9814, 0xc6d8, 0x6a28, 0x620c, 0x7efc, 0x008b, 0x52c3,
0x53cb, 0xc10d, 0x7dab, 0x0200, 0x9806, 0x0200, 0x9803, 0x0700,
0x985f, 0xc0ec, 0x7d61, 0x0e70, 0x0611, 0x5016, 0x5ac0, 0x5bc8,
0x5ef8, 0xc0fe, 0x56f8, 0x5cd0, 0x7d02, 0x0200, 0x9867, 0x078d,
0x1a10, 0x5ad8, 0x6ae7, 0x63c8, 0x7eec, 0x0000, 0x4b00, 0x7dfa,
0x5be0, 0x0000, 0x5ef8, 0xc0fe, 0x56f8, 0x5ce8, 0x7cfa, 0x068f,
0x6ed5, 0x6dc5, 0x08ff, 0x0011, 0x28ff, 0x00bc, 0x0788, 0x0904,
0x00d1, 0x7d18, 0x0904, 0x06a5, 0x3e03, 0x3d03, 0x01a5, 0x3903,
0x0089, 0xd8a5, 0x7e16, 0x07a1, 0x008f, 0x4e00, 0x7d01, 0x98a2,
0x6dcf, 0x6edf, 0x0015, 0x0015, 0xd8a5, 0x7e0b, 0x3f03, 0x008f,
0x6dcd, 0x6edd, 0xd8a5, 0x7e05, 0x98aa, 0x7802, 0x62d8, 0x0000,
0x0006, 0xc6d4, 0x078b, 0x0e70, 0x0611, 0x5016, 0x52d8, 0x53e0,
0x54e8, 0xc10d, 0x7d02, 0x0900, 0x98b6, 0x0901, 0x0e70, 0x0611,
0x5016, 0x52c0, 0x53c8, 0x54d0, 0xc10d, 0x7d01, 0x98c0, 0x1901,
0x4902, 0x7da5, 0x0200, 0x9867, 0x0200, 0x9861, 0xc147, 0x7d60,
0x0e70, 0x0611, 0x5016, 0x5ac0, 0x5bc8, 0x5ef8, 0xc158, 0x56f8,
0x5cd0, 0x7d02, 0x0600, 0x98cc, 0x078d, 0x1a10, 0x5ad8, 0x6a63,
0x634b, 0x7e33, 0x0000, 0x4b00, 0x7dfa, 0x5be0, 0x0000, 0x5ef8,
0xc158, 0x56f8, 0x038f, 0x5ce8, 0x7cf9, 0x068d, 0x058f, 0x6e44,
0x6d60, 0x08ff, 0x0011, 0x28ff, 0x00bc, 0x0788, 0x0904, 0x00d1,
0x7d16, 0x0f04, 0x06a5, 0x3e03, 0x3d03, 0x07a5, 0x3f03, 0xc23c,
0xd90a, 0x00a7, 0x0788, 0x4e00, 0x7d08, 0x0810, 0x07d8, 0x7c02,
0xc24b, 0xd90a, 0xc264, 0xd90a, 0x990e, 0xc22e, 0x7f06, 0xc23c,
0xd90a, 0x990e, 0x7f02, 0x7e01, 0x0006, 0xc6d0, 0x078b, 0x0e70,
0x0611, 0x5016, 0x52d8, 0x53e0, 0x54e8, 0xc166, 0x7d02, 0x0900,
0x991a, 0x0901, 0x0e70, 0x0611, 0x5016, 0x52c0, 0x53c8, 0x54d0,
0xc166, 0x7d01, 0x9924, 0x1901, 0x4902, 0x7da6, 0x0600, 0x98cc,
0x0600, 0x98c6, 0x0870, 0x0011, 0x5010, 0xc0ec, 0x7d70, 0x5ac0,
0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x9930, 0x6d03,
0x6ed3, 0x0dff, 0x0511, 0x1dff, 0x05bc, 0x5df8, 0x4d00, 0x7d56,
0x0b70, 0x0311, 0x522b, 0x5313, 0x02b9, 0x4a00, 0x7c04, 0x62ff,
0x7e37, 0x0400, 0x9940, 0x008f, 0x00d5, 0x7d01, 0x008d, 0x05a0,
0x5ddb, 0x0d03, 0x0512, 0x05bc, 0x0510, 0x5dd3, 0x4d00, 0x7d1f,
0x4d02, 0x7d18, 0x4d01, 0x7d12, 0x6209, 0x7e22, 0x6509, 0x7e20,
0x0212, 0x02ad, 0x6509, 0x7e1c, 0x0212, 0x02ad, 0x0212, 0x0210,
0x6ac8, 0x7f16, 0x2003, 0x4800, 0x7cef, 0x997c, 0x7802, 0x6209,
0x6ac8, 0x997c, 0x0015, 0x7802, 0x620a, 0x6ac8, 0x997c, 0x0015,
0x0015, 0x7802, 0x620b, 0x6ac8, 0x7c03, 0x0000, 0x55db, 0x993e,
0x0007, 0x68cc, 0x680c, 0x55d3, 0x4d00, 0x7d03, 0x4d02, 0x7d02,
0x998b, 0x0017, 0x0017, 0x55db, 0x009d, 0x55fb, 0x05a0, 0x08ff,
0x0011, 0x18ff, 0x0010, 0x04b8, 0x04ad, 0x0454, 0x62ff, 0x7ee8,
0x008b, 0x52c0, 0x53c8, 0xc10d, 0x7d93, 0x0200, 0x9930, 0x0200,
0x992d, 0xc19d, 0x0870, 0x0011, 0xc0ec, 0x7d6c, 0x5010, 0x5ac0,
0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02, 0x0200, 0x99a8, 0x6d03,
0x0d03, 0x0512, 0x05bc, 0x0510, 0x5dd0, 0x0dff, 0x0511, 0x1dff,
0x05bc, 0x5df8, 0x4d00, 0x7d4f, 0x0a70, 0x0211, 0x532a, 0x5212,
0x03b9, 0x4b00, 0x7c02, 0x0400, 0x99bc, 0x008f, 0x05d8, 0x7d01,
0x008d, 0x05a0, 0x5dda, 0x55d2, 0x4d00, 0x7d1f, 0x4d02, 0x7d18,
0x4d01, 0x7d12, 0x6309, 0x7e22, 0x6509, 0x7e20, 0x0312, 0x03ad,
0x6509, 0x7e1c, 0x0312, 0x03ad, 0x0312, 0x0310, 0x5b06, 0x7f16,
0x2003, 0x4800, 0x7cef, 0x99f2, 0x7802, 0x6309, 0x5b06, 0x99f2,
0x0015, 0x7802, 0x630a, 0x5b06, 0x99f2, 0x0015, 0x0015, 0x7802,
0x630b, 0x5b06, 0x7c03, 0x55da, 0x0000, 0x99ba, 0x0007, 0x680c,
0x55d2, 0x4d00, 0x7d03, 0x4d02, 0x7d02, 0x9a00, 0x0017, 0x0017,
0x55da, 0x009d, 0x55fa, 0x05a0, 0x08ff, 0x0011, 0x18ff, 0x0010,
0x04b8, 0x04ad, 0x0454, 0x008a, 0x52c0, 0x53c8, 0xc10d, 0x7d98,
0x0200, 0x99a8, 0x0200, 0x99a4, 0x0300, 0x9a14, 0xc19d, 0x0870,
0x0011, 0xc0ec, 0x7d58, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe,
0x56f8, 0x7d02, 0x0200, 0x9a1d, 0x6d07, 0x5df0, 0x0dff, 0x0511,
0x1dff, 0x05bc, 0x4d00, 0x7d3d, 0x0a70, 0x0211, 0x532a, 0x5212,
0x03b9, 0x4b00, 0x7c05, 0x6a28, 0x630c, 0x7e32, 0x0400, 0x9a2c,
0x008f, 0x05d8, 0x7d01, 0x008d, 0x05a0, 0x0b03, 0x0312, 0x03bc,
0x0310, 0x4b00, 0x7d14, 0x4b02, 0x7d18, 0x4b01, 0x7d1b, 0x5306,
0x7e1f, 0x0310, 0x0312, 0x6b09, 0x7f1b, 0x0312, 0x6b09, 0x7f18,
0x0312, 0x6b09, 0x7f15, 0x2003, 0x4800, 0x7cf1, 0x9a65, 0x0015,
0x0015, 0x7802, 0x5306, 0x6b0b, 0x9a65, 0x0015, 0x7802, 0x5306,
0x6b0a, 0x9a65, 0x7802, 0x5306, 0x6b09, 0x7c02, 0x0000, 0x9a2a,
0xc6d8, 0x6928, 0x630c, 0x7efc, 0x008a, 0x52c0, 0x53c8, 0xc10d,
0x7dac, 0x0200, 0x9a1d, 0x0200, 0x9a19, 0x0870, 0x0011, 0x5010,
0xc0ec, 0x7d5b, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02,
0x0200, 0x9a7b, 0x0b70, 0x0311, 0x6ec3, 0x6d07, 0x5df0, 0x0dff,
0x0511, 0x1dff, 0x05bc, 0x4d00, 0x7d3c, 0x522b, 0x02b9, 0x4a00,
0x7c05, 0x6a28, 0x620c, 0x7e31, 0x0400, 0x9a8d, 0x028e, 0x1a94,
0x6ac3, 0x62c8, 0x0269, 0x7d19, 0x1e94, 0x6ec3, 0x6ed3, 0x62c8,
0x0248, 0x6ac8, 0x2694, 0x6ec3, 0x62c8, 0x026e, 0x7d30, 0x6a09,
0x7f1c, 0x2501, 0x4d00, 0x7d1d, 0x028e, 0x1a98, 0x6ac3, 0x62c8,
0x6ec3, 0x0260, 0x7df1, 0xdad9, 0x9acc, 0x6ee3, 0x008f, 0x2001,
0x00d5, 0x7d01, 0x008d, 0x05a0, 0x62c8, 0x026e, 0x7d18, 0x6a09,
0x7f04, 0x2001, 0x7cf9, 0x0000, 0x9a8b, 0x0007, 0x6a0c, 0xdadc,
0x9ae9, 0x6a28, 0x620c, 0x7ef9, 0x0b70, 0x0311, 0x5013, 0x52c0,
0x53c8, 0xc10d, 0x7da8, 0x0200, 0x9a7b, 0x0200, 0x9a78, 0xdad9,
0x9ae9, 0x6a28, 0x620c, 0x7ee9, 0x6207, 0x0b70, 0x0311, 0x5013,
0x55f0, 0x02a5, 0x0bff, 0x0312, 0x1bff, 0x0312, 0x04bb, 0x049a,
0x0006, 0x0458, 0x0454, 0x9acc, 0xc19d, 0x0870, 0x0011, 0xc0ec,
0x7d54, 0x5010, 0x5ac0, 0x5bc8, 0x5ef8, 0xc0fe, 0x56f8, 0x7d02,
0x0200, 0x9af3, 0x0a70, 0x0211, 0x6d07, 0x5df0, 0x0dff, 0x0511,
0x1dff, 0x05bc, 0x4d00, 0x7d35, 0x532a, 0x03b9, 0x4b00, 0x7c05,
0x6928, 0x630c, 0x7e2a, 0x0400, 0x9b04, 0x038e, 0x1b94, 0x5303,
0x0369, 0x7d14, 0x1e94, 0x5306, 0x0348, 0x5b06, 0x2694, 0x5306,
0x036e, 0x7d2d, 0x6b09, 0x7f19, 0x2501, 0x4d00, 0x7d1a, 0x038e,
0x1b98, 0x5303, 0x0360, 0x7df3, 0xdb49, 0x9b3c, 0x008f, 0x2001,
0x00d5, 0x7d01, 0x008d, 0x05a0, 0x5306, 0x036e, 0x7d18, 0x6b09,
0x7f04, 0x2001, 0x7cf9, 0x0000, 0x9b02, 0x0007, 0x6b0c, 0xdb4c,
0x9b5b, 0x6928, 0x630c, 0x7ef9, 0x0a70, 0x0211, 0x5012, 0x52c0,
0x53c8, 0xc10d, 0x7db0, 0x0200, 0x9af3, 0x0200, 0x9aef, 0xdb49,
0x9b5b, 0x6b28, 0x630c, 0x7ee9, 0x6307, 0x0a70, 0x0211, 0x5012,
0x55f0, 0x03a5, 0x0aff, 0x0212, 0x1aff, 0x0212, 0x04ba, 0x049b,
0x0a70, 0x0211, 0x0006, 0x0458, 0x0454, 0x9b3c, 0x9b3c
};
#endif
