#ifndef PRDBG_H
#define PRDBG_H
/*
 *	Print debug message.
 *
 * Copyright 2006 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Should you need to contact me, the author, you can do so either by
 * e-mail - mail your message to <vojtech@suse.cz>, or by paper mail:
 * Vojtech Pavlik, Ucitelska 1576, Prague 8, 182 00 Czech Republic
 */

#include <linux/kernel.h>	/* for printk() */

#ifndef PrHead
#define PrHead	__FILE__ ":"
#endif /* PrHead */

#ifdef DEBUG
#define PrDebug(fmt, arg...) \
	printk(KERN_DEBUG PrHead "%s: " fmt, __func__, ## arg)
#else
#define PrDebug(fmt, arg...)	do {} while (0)
#endif
#define PrInfo(fmt, arg...)		printk(KERN_INFO PrHead fmt,##arg)
#define PrNotice(fmt, arg...)	printk(KERN_NOTICE PrHead fmt,##arg)
#define PrWarn(fmt, arg...)		printk(KERN_WARNING PrHead fmt,##arg)
#define PrErr(fmt, arg...)		printk(KERN_ERR PrHead fmt,##arg)
#define PrCrit(fmt, arg...)		printk(KERN_CRIT PrHead fmt,##arg)
#define PrAlert(fmt, arg...)	printk(KERN_ALERT PrHead fmt,##arg)
#define PrEmerg(fmt, arg...)	printk(KERN_EMERG PrHead fmt,##arg)

#endif /* PRDBG_H */
