/*
 *  linux/include/linux/serial_8250.h
 *
 *  Copyright (C) 2004 Russell King
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef _LINUX_SERIAL_8250_H
#define _LINUX_SERIAL_8250_H

#include <linux/serial_core.h>
#include <linux/device.h>

struct plat_serial8250_port {
	unsigned long	iobase;		/* io base address */
	void __iomem	*membase;	/* ioremap cookie or NULL */
	unsigned long	mapbase;	/* resource base */
	unsigned int	irq;		/* interrupt number */
	unsigned int	uartclk;	/* UART clock rate */
	unsigned char	regshift;	/* register shift */
	unsigned char	iotype;		/* UPIO_* */
	unsigned int	flags;		/* UPF_* flags */
	unsigned int	line;		/* uart # */
};


#ifdef CONFIG_SONY_ICX1087 /* 2006.07.13 yam */

void serial8250_register_event_notifier( void (*notifier)( int type ) );
#define SERIAL8250_EVENT_TYPE_RD_ERR	1	/* framing error, break condition */
#define SERIAL8250_EVENT_TYPE_OPEN		2	/* startup( open ) */

#endif

#endif
