/*
 *  File Name       : linux/sound/oss/mp200-ak4642.h
 *  Function        : Glue audio driver for the MP200 & AK4642 CODEC
 *  Release Version : Ver 1.00
 *  Release Date    : 2006/03/29
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __SOUND_OSS_MP200_AK4642_H
#define __SOUND_OSS_MP200_AK4642_H

#define AK4642_DEVICE					0x12
#define AK4642REG_00H_POWER_MANAGEMENT_1		0x00
#define AK4642REG_01H_POWER_MANAGEMENT_2		0x01
#define AK4642REG_02H_SIGNAL_SELECT_1			0x02
#define AK4642REG_03H_SIGNAL_SELECT_2			0x03
#define AK4642REG_04H_MODE_CONTROL_1			0x04
#define AK4642REG_05H_MODE_CONTROL_2			0x05
#define AK4642REG_06H_TIMER_SELECT			0x06
#define AK4642REG_07H_ALC_MODE_CONTROL_1		0x07
#define AK4642REG_08H_ALC_MODE_CONTROL_2		0x08
#define AK4642REG_09H_LCH_INPUT_VOLUME_CONTROL		0x09
#define AK4642REG_0AH_LCH_DIGITAL_VOLUME_CONTROL	0x0a
#define AK4642REG_0BH_ALC_MODE_CONTROL_3		0x0b
#define AK4642REG_0CH_RCH_INPUT_VOLUME_CONTROL		0x0c
#define AK4642REG_0DH_RCH_DIGITAL_VOLUME_CONTROL	0x0d
#define AK4642REG_0EH_MODE_CONTROL_3			0x0e
#define AK4642REG_0FH_MODE_CONTROL_4			0x0f
#define AK4642REG_10H_POWER_MANAGEMENT_3		0x10
#define AK4642REG_11H_DIGITAL_FILTER_SELECT		0x11
#define AK4642REG_12H_FIL3_CO_EFFICIENT_0		0x12
#define AK4642REG_13H_FIL3_CO_EFFICIENT_1		0x13
#define AK4642REG_14H_FIL3_CO_EFFICIENT_2		0x14
#define AK4642REG_15H_FIL3_CO_EFFICIENT_3		0x15
#define AK4642REG_16H_EQ_CO_EFFICIENT_0			0x16
#define AK4642REG_17H_EQ_CO_EFFICIENT_1			0x17
#define AK4642REG_18H_EQ_CO_EFFICIENT_2			0x18
#define AK4642REG_19H_EQ_CO_EFFICIENT_3			0x19
#define AK4642REG_1AH_EQ_CO_EFFICIENT_4			0x1a
#define AK4642REG_1BH_EQ_CO_EFFICIENT_5			0x1b
#define AK4642REG_1CH_FIL1_CO_EFFICIENT_0		0x1c
#define AK4642REG_1DH_FIL1_CO_EFFICIENT_1		0x1d
#define AK4642REG_1EH_FIL1_CO_EFFICIENT_2		0x1e
#define AK4642REG_1FH_FIL1_CO_EFFICIENT_3		0x1f
#define AK4642REG_MAX					0x20

#define AK4642BIT_00H_40H_PMVCM		0x40
#define AK4642BIT_00H_20H_PMBP		0x20
#define AK4642BIT_00H_10H_PMSPK		0x10
#define AK4642BIT_00H_08H_PMLO		0x08
#define AK4642BIT_00H_04H_PMDAC		0x04
#define AK4642BIT_00H_01H_PMADL		0x01

#define AK4642BIT_01H_40H_HPMTN		0x40
#define AK4642BIT_01H_20H_PMHPL		0x20
#define AK4642BIT_01H_10H_PMHPR		0x10
#define AK4642BIT_01H_08H_M_S		0x08
#define AK4642BIT_01H_02H_MCKO		0x02
#define AK4642BIT_01H_01H_PMPLL		0x01

#define AK4642BIT_02H_80H_SPPSN		0x80
#define AK4642BIT_02H_40H_BEEPS		0x40
#define AK4642BIT_02H_20H_DACS		0x20
#define AK4642BIT_02H_10H_DACL		0x10
#define AK4642BIT_02H_04H_PMMP		0x04
#define AK4642BIT_02H_01H_MGAIN0	0x01

#define AK4642BIT_03H_80H_LOVL		0x80
#define AK4642BIT_03H_40H_LOPS		0x40
#define AK4642BIT_03H_20H_MGAIN1	0x20
#define AK4642BIT_03H_10H_SPKG1		0x10
#define AK4642BIT_03H_08H_SPKG0		0x08
#define AK4642BIT_03H_18H_SPKG_MASK	0x18
#define AK4642BIT_03H_04H_BEEPL		0x04

#define AK4642BIT_04H_80H_PLL3		0x80
#define AK4642BIT_04H_40H_PLL2		0x40
#define AK4642BIT_04H_20H_PLL1		0x20
#define AK4642BIT_04H_10H_PLL0		0x10
#define AK4642BIT_04H_F0H_PLL_MASK	0xF0
#define AK4642BIT_04H_08H_BCKO		0x08
#define AK4642BIT_04H_02H_DIF1		0x02
#define AK4642BIT_04H_01H_DIF0		0x01
#define AK4642BIT_04H_03H_DIF_MASK	0x03

#define AK4642BIT_05H_80H_PS1		0x80
#define AK4642BIT_05H_40H_PS0		0x40
#define AK4642BIT_05H_C0H_PS_MASK	0xC0

#define AK4642BIT_06H_80H_DVTM		0x80
#define AK4642BIT_06H_20H_ZTM1		0x20
#define AK4642BIT_06H_10H_ZTM0		0x10
#define AK4642BIT_06H_30H_ZTM_MASK	0x30
#define AK4642BIT_06H_08H_WTM1		0x08
#define AK4642BIT_06H_04H_WTM0		0x04
#define AK4642BIT_06H_0CH_WTM_MASK	0x0C

#define AK4642BIT_07H_20H_ALC		0x20
#define AK4642BIT_07H_10H_ZELMN		0x10
#define AK4642BIT_07H_08H_LMAT1		0x08
#define AK4642BIT_07H_04H_LMAT0		0x04
#define AK4642BIT_07H_0CH_LMAT_MASK	0x0C
#define AK4642BIT_07H_02H_RGAIN0	0x02
#define AK4642BIT_07H_01H_LMTH0		0x01

#define AK4642BIT_0BH_80H_RGAIN1	0x80
#define AK4642BIT_0BH_40H_LMTH1		0x40

#define AK4642BIT_0EH_40H_LOOP		0x40
#define AK4642BIT_0EH_20H_SMUTE		0x20
#define AK4642BIT_0EH_10H_DVOLC		0x10
#define AK4642BIT_0EH_08H_BST1		0x08
#define AK4642BIT_0EH_04H_BST0		0x04
#define AK4642BIT_0EH_0CH_BST_MASK	0x0C
#define AK4642BIT_0EH_02H_DEM1		0x02
#define AK4642BIT_0EH_01H_DEM0		0x01
#define AK4642BIT_0EH_03H_DEM_MASK	0x03

#define AK4642BIT_0FH_08H_IVOLC		0x08
#define AK4642BIT_0FH_04H_HPM		0x04
#define AK4642BIT_0FH_02H_BEEPH		0x02
#define AK4642BIT_0FH_01H_DACH		0x01

#define AK4642BIT_10H_20H_HPG		0x20
#define AK4642BIT_10H_10H_MDIF2		0x10
#define AK4642BIT_10H_08H_MDIF1		0x08
#define AK4642BIT_10H_18H_MDIF_MASK	0x18
#define AK4642BIT_10H_04H_INR		0x04
#define AK4642BIT_10H_02H_INL		0x02
#define AK4642BIT_10H_06H_IN_MASK	0x06
#define AK4642BIT_10H_01H_PMADR		0x01

#define AK4642BIT_11H_80H_GN1		0x80
#define AK4642BIT_11H_40H_GN0		0x40
#define AK4642BIT_10H_C0H_GN_MASK	0xC0
#define AK4642BIT_11H_10H_FIL1		0x10
#define AK4642BIT_11H_08H_EQ		0x08
#define AK4642BIT_11H_04H_FIL3		0x04

/* PLL2 bit = "1" : MCKI input */
#define AK4642BIT_05H_FS_8KHZ		0x00
#define AK4642BIT_05H_FS_12KHZ		0x01
#define AK4642BIT_05H_FS_16KHZ		0x02
#define AK4642BIT_05H_FS_24KHZ		0x03
#define AK4642BIT_05H_FS_7_35KHZ	0x04
#define AK4642BIT_05H_FS_11_025KHZ	0x05
#define AK4642BIT_05H_FS_14_7KHZ	0x06
#define AK4642BIT_05H_FS_22_05KHZ	0x07
#define AK4642BIT_05H_FS_32KHZ		0x22
#define AK4642BIT_05H_FS_48KHZ		0x23
#define AK4642BIT_05H_FS_29_4KHZ	0x26
#define AK4642BIT_05H_FS_44_1KHZ	0x27
#define AK4642BIT_05H_27H_FS_MASK	0x27

#define AK4642_INPUT_VOL_MAX		241
#define AK4642_OUTPUT_VOL_MAX		255

#define AK4642_WAIT_PLL_LOCK		(4 * HZ / 100)	/* 40ms */
#define AK4642_WAIT_LO_LOCK		(30 * HZ / 100)	/* 300ms */
#define AK4642_WAIT_ALC_LOCK		(7 * HZ / 100)	/* 70ms */

#define AK4642_POWER_ON_MAX_SEQ_NUM	25

struct mixer_volume {
	unsigned int mixer;
	int volume;
};

#endif				/* __SOUND_OSS_MP200_AK4642_H */
