/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Copyright (C) 2004 freescale Inc Ltd
 *
 * History :
 *      04/05/18 : Removed the dmabuf structure.
 *      05/03/03: Compile warning removal for FIFO mode
 */
  
 /*!
  * @file mxc-audio.h
  * @brief this file implements the OSS dependent part of the sound driver
  * @ingroup SOUND_DRV
  */
  
#ifndef _MXC_AUDIO_H
#define _MXC_AUDIO_H
#include "mxc-defs.h"

static int mxc_mixer_ioctl(int dev, unsigned int cmd, void __user *arg);
static int  mxc_audio_prepare_for_io (int dev, int bsize, int bcount);
static void mxc_audio_trigger (int dev, int state);
static void mxc_audio_output_block (int dev, unsigned long buf, \
                                    int count, int intrflag);
static void mxc_audio_close (int dev);
static int  mxc_audio_open (int dev, int mode);
static void mxc_audio_reset (int dev);
static int  mxc_audio_ioctl (int dev, unsigned int cmd, void __user *arg);
static int  mxc_audio_setspeed (int dev, int speed);
static signed short mxc_audio_setchannel (int dev, signed short channels);
static unsigned int mxc_audio_setbits (int dev, unsigned int bits);
static int mxc_get_drv_data(int dev, mxc_state_t **drv_inst);
static inline void mxc_setup_tx_dma(mxc_state_t *drv_inst, \
                                    dma_channel_params *params);
static inline void mxc_setup_rx_dma(mxc_state_t *drv_inst, \
                                    dma_channel_params *params);
#ifdef CONFIG_SOUND_MXC_SDMA
static int mxc_setup_dma(mxc_state_t *drv_inst, e_transfer_dir_t inout);
#endif /* CONFIG_SOUND_MXC_SDMA */
static inline int mxc_open_read_allowed(mxc_state_t *drv_inst, int mode);
static inline int mxc_open_write_allowed(mxc_state_t *drv_inst, int mode);
int mxc_open_allowed(mxc_state_t *drv_inst, int mode);
void mxc_dma_tx_handler(void* arg);
void mxc_dma_rx_handler(void* arg);
void mxc_dma_err_handler(int err_type);
void OSS_DMAbuf_init(int dev, int dma1, int dma2);

#endif
