/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Copyright (C) 2004 Freescale Inc Ltd
 *
 * Modification History
 *    2004 May, 18th, addition of Atlas control commands
 *
 */
 
 /*!
  * @file mxc-hwdep.h
  * @brief Definitions and prototypes for mxc-hwdep.c
  * @ingroup SOUND_DRV
  */
 
#ifndef _MXC_HWDEP_H
#define _MXC_HWDEP_H

#include "mxc-defs.h"

int mxc_convert_receive_signal(int val, receive_signal *rs);
void mxc_reset_ssi(int index);
void mxc_setup_ssi_fifo_dep(mxc_state_t *drv_inst);
void mxc_setup_ssi(mxc_state_t *drv_inst, int snd_device);
unsigned int mxc_get_bits(mxc_state_t *drv_inst);
unsigned int mxc_set_bits(mxc_state_t *drv_inst, int bits);
signed short mxc_get_channels(mxc_state_t *drv_inst);
signed short mxc_set_channels(mxc_state_t *drv_inst, signed short channels);
int mxc_get_speed(mxc_state_t *drv_inst);
int mxc_set_speed(mxc_state_t *drv_inst, int speed);
int mxc_setup_stdac(mxc_state_t *drv_inst);
int mxc_setup_codec(mxc_state_t *drv_inst);
int atlas_get_dev_in_selected(mxc_state_t *drv_inst);
int atlas_get_dev_out_selected(mxc_state_t *drv_inst);
int atlas_select_dev_in(mxc_state_t *drv_inst, int dev_in);
int atlas_select_dev_out(mxc_state_t *drv_inst, int dev_out);
int mxc_setup_atlas_stdac(mxc_state_t *drv_inst);
int mxc_setup_atlas_codec(mxc_state_t *drv_inst);
int atlas_get_src_in_selected(mxc_state_t *drv_inst);
int atlas_get_src_out_selected(mxc_state_t *drv_inst);
int atlas_select_src_in(mxc_state_t *drv_inst, int src_in);
int atlas_select_src_out(mxc_state_t *drv_inst, int src_out);
int atlas_set_dev_in_volume(mxc_state_t *drv_inst, int vol);
int atlas_set_dev_out_volume(mxc_state_t *drv_inst, int vol);
int atlas_get_dev_in_volume(mxc_state_t *drv_inst);
int atlas_get_dev_out_volume(mxc_state_t *drv_inst);
int atlas_set_input_bias(mxc_state_t *drv_inst, int onoff);
int atlas_get_input_bias(mxc_state_t *drv_inst);
int atlas_set_output_balance(mxc_state_t *drv_inst, int val);
int atlas_get_output_balance(mxc_state_t *drv_inst);
int atlas_device_switch_on_off(int device, int on_off);
int atlas_check_device_still_in_use(mxc_state_t *drv_inst, int device);
int atlas_enable_out_device(mxc_state_t *drv_inst, int device, int en_flag);
int atlas_enable_in_device(mxc_state_t *drv_inst, int device, int en_flag);
int atlas_get_output_mixer(mxc_state_t *drv_inst);
int atlas_set_output_mixer(mxc_state_t *drv_inst);
int atlas_set_output_adder(mxc_state_t *drv_inst, int val);
int atlas_get_output_adder(mxc_state_t *drv_inst);
int atlas_set_src_out_volume(mxc_state_t *drv_inst, int src_mask, int val);
int atlas_set_src_in_volume(mxc_state_t *drv_inst, int src_mask, int val);
int atlas_get_src_out_volume(mxc_state_t *drv_inst, int src_mask);
int atlas_get_src_in_volume(mxc_state_t *drv_inst, int src_mask);
int atlas_set_codec_filter(mxc_state_t *drv_inst, int mask);
int atlas_get_codec_filter(mxc_state_t *drv_inst);
unsigned long get_ssi_stx_register_addr(mxc_state_t *drv_inst);
unsigned long get_ssi_srx_register_addr(mxc_state_t*drv_inst);
void dam_connect_port_to_port \
        (dam_port target_port, dam_port source_port, signal_direction dir);
int mxc_setup_dam(mxc_state_t *drv_inst);
int mxc_setup_dam_atlas_master(mxc_state_t *drv_inst);
int mxc_setup_dam_mcu_master(mxc_state_t *drv_inst);
void mxc_init_dam(mxc_state_t *drv_inst);
int mxc_setup_clk_master(mxc_state_t *drv_inst, unsigned int clock);
int mxc_setup_dam_out_port(mxc_state_t *drv_inst, unsigned int out_port);
int get_ssi_timeslots(mxc_state_t *drv_inst, \
              timeslots *prim_ts, timeslots *sec_ts_tx, timeslots *sec_ts_rx);


#endif
